package demo.areacharts ;

import java.awt.Color ;
import java.awt.Font ;
import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.AbstractValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class XYAreaRenderer2Demo1 extends JPanel {

  public XYAreaRenderer2Demo1() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel1() ;
  }

  private void addPanel1() {
    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createXYAreaChart("XYAreaRenderer2Demo1", "Domain (X)",
                                                   "Range (Y)", dataset, ChartOrientation.VERTICAL,
                                                   true, true, false, false) ;

    XYPlot xyplot = (XYPlot) chart.getPlot() ;
    xyplot.setForegroundAlpha(0.65F) ;
    xyplot.setDomainGridlinePaint(Color.white) ;
    xyplot.setValueGridlinePaint(Color.white) ;
    xyplot.getRender().setBackgroundPaint(Color.lightGray) ;

    AbstractValueAxis valueaxis = xyplot.getDomainAxis() ;
    valueaxis.setTickMarkPaint(Color.black) ;
    valueaxis.setLowerMargin(0.0D) ;
    valueaxis.setUpperMargin(0.0D) ;
    valueaxis.setAxisLabelFont(new Font("SansSerif", Font.BOLD, 12));
    AbstractValueAxis valueaxis1 = xyplot.getValueAxis() ;
    valueaxis1.setTickMarkPaint(Color.black) ;
    valueaxis1.setAxisLabelFont(new Font("SansSerif", Font.BOLD, 12));

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset1() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("Random 1") ;
    dataset.addRowKey("Random 2") ;

    dataset.addRowData() ;
    dataset.addData(0, new XYNumberChartData(1, 500.19999999999999D)) ;
    dataset.addData(0, new XYNumberChartData(2, 694.10000000000002D)) ;
    dataset.addData(0, new XYNumberChartData(3, -734.39999999999998D)) ;
    dataset.addData(0, new XYNumberChartData(4, 453.19999999999999D)) ;
    dataset.addData(0, new XYNumberChartData(5, 500.19999999999999D)) ;
    dataset.addData(0, new XYNumberChartData(6, 300.69999999999999D)) ;
    dataset.addData(0, new XYNumberChartData(7, 734.39999999999998D)) ;
    dataset.addData(0, new XYNumberChartData(8, 453.19999999999999D)) ;

    dataset.addRowData() ;
    dataset.addData(1, new XYNumberChartData(1, 700.20000000000005D)) ;
    dataset.addData(1, new XYNumberChartData(2, 534.10000000000002D)) ;
    dataset.addData(1, new XYNumberChartData(3, 323.39999999999998D)) ;
    dataset.addData(1, new XYNumberChartData(4, 125.2D)) ;
    dataset.addData(1, new XYNumberChartData(5, 653.20000000000005D)) ;
    dataset.addData(1, new XYNumberChartData(6, 432.69999999999999D)) ;
    dataset.addData(1, new XYNumberChartData(7, 564.39999999999998D)) ;
    dataset.addData(1, new XYNumberChartData(8, 322.19999999999999D)) ;

    return dataset ;
  }

}
