package demo.barcharts.xy ;

import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.StackedXYBarValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.constant.DateTickUnitType ;
import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.tickunit.DateTickUnit ;
import com.ijchart.xychart.util.DateUtil ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class RelativeDateFormatDemo2 extends JPanel {
  private ChartOrientation orientation = ChartOrientation.VERTICAL ;

  public RelativeDateFormatDemo2() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel() ;
  }

  private void addPanel() {
    IMatrixDataset dataset = createDataset() ;
    IJChart chart = ChartFactory.createStackedXYBarChart("RelativeDateFormat Demo 2", "Date ",
                                                         "Time To Complete", dataset, orientation,
                                                         true, true, true, true) ;
    XYPlot xyplot = (XYPlot) chart.getPlot() ;
    xyplot.setDomainCrosshairVisible(true) ;
    xyplot.setValueCrosshairVisible(true) ;

    StackedXYBarValueAxis xAxis = (StackedXYBarValueAxis) xyplot.getDomainAxis() ;
    xAxis.setTickUnit(new DateTickUnit(DateTickUnitType.DATE_UNIT_DAY)) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("Heart Rate") ;

    dataset.addRowData() ;

    dataset.addData(0, createData(19, 1, 2007, 3343000D)) ;
    dataset.addData(0, createData(20, 1, 2007, 3420000D)) ;
    dataset.addData(0, createData(21, 1, 2007, 3515000D)) ;
    dataset.addData(0, createData(22, 1, 2007, 3315000D)) ;
    dataset.addData(0, createData(23, 1, 2007, 3490000D)) ;
    dataset.addData(0, createData(24, 1, 2007, 3556000D)) ;
    dataset.addData(0, createData(25, 1, 2007, 3383000D)) ;
    dataset.addData(0, createData(26, 1, 2007, 3575000D)) ;

    return dataset ;
  }

  private static XYNumberChartData createData(int day, int month, int year, double value) {
    long mills = DateUtil.dateToTimeInMillis(year, month, day) ;
    return new XYNumberChartData(mills, value) ;
  }
}
