package demo.financialcharts ;

import java.awt.Color ;
import java.awt.GridLayout ;
import java.util.Calendar ;
import java.util.Date ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.OHLCDateAxis ;
import com.ijchart.xychart.axis.value.OHLCValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.constant.IAngle ;
import com.ijchart.xychart.data.OHLCChartData ;
import com.ijchart.xychart.dataset.SingleRowDataset ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.render.xy.HighLowRender ;
import com.ijchart.xychart.render.xy.StockRender ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class HighLowChartDemo3 extends JPanel {

  private ChartOrientation vertical = ChartOrientation.VERTICAL ;

  /** A working calendar. */
  private static final Calendar CALENDAR = Calendar.getInstance() ;

  private SingleRowDataset dataset = createDataset1() ;

  public HighLowChartDemo3() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel1() ;
  }

  private void addPanel1() {
    IJChart chart = ChartFactory.createHighLowChart(
      "OHLC Demo 3", "Time", "Price", dataset, vertical, true, true) ;
    XYPlot plot = (XYPlot) chart.getPlot() ;
    HighLowRender highlowrenderer = (HighLowRender) plot.getRender() ;
    highlowrenderer.setBaseItemBorderPaint(Color.blue) ;
    OHLCValueAxis numberaxis = (OHLCValueAxis) plot.getValueAxis() ;
    numberaxis.setAxisRangeIncludeZero(false) ;

    SingleRowDataset dataset2 = createDataset2() ;
    OHLCDateAxis domainaxis = new OHLCDateAxis(null, dataset2) ;
    domainaxis.setVisible(false) ;
    plot.setDomainAxis(1, domainaxis) ;
    OHLCValueAxis numberaxis1 = new OHLCValueAxis("Price 2", dataset2) ;
    numberaxis1.setAxisRangeIncludeZero(false) ;
    numberaxis1.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    plot.setValueAxis(1, numberaxis1) ;

    StockRender render2 = new StockRender(dataset2, 8) ;
    render2.setBaseItemBorderPaint(Color.blue) ;
    plot.setRender(1, render2) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  public static SingleRowDataset createDataset1() {
    SingleRowDataset dataset = new SingleRowDataset() ;
    dataset.addRowKey("Series 1") ;

    dataset.addRowData() ;
    dataset.addData(0, createData(createDate(24, 9, 2007), 50.5D, 53.200000000000003D,
                                  49.799999999999997D, 50.100000000000001D)) ;
    dataset.addData(0, createData(createDate(25, 9, 2007), 50.200000000000003D,
                                  51.200000000000003D, 47.799999999999997D, 48.100000000000001D)) ;
    dataset.addData(0, createData(createDate(26, 9, 2007), 48D, 49.200000000000003D,
                                  45.299999999999997D, 47.399999999999999D)) ;
    dataset.addData(0, createData(createDate(27, 9, 2007), 47.5D, 48.299999999999997D,
                                  46.799999999999997D, 46.799999999999997D)) ;
    dataset.addData(0, createData(createDate(28, 9, 2007), 46.600000000000001D, 47D,
                                  45.100000000000001D, 46D)) ;
    dataset.addData(0, createData(createDate(1, 10, 2007), 46.600000000000001D, 47D,
                                  45.100000000000001D, 46D)) ;
    dataset.addData(0, createData(createDate(2, 10, 2007), 47.5D, 48.299999999999997D,
                                  46.799999999999997D, 46.799999999999997D)) ;
    dataset.addData(0, createData(createDate(3, 10, 2007), 48D, 49.200000000000003D,
                                  45.299999999999997D, 47.399999999999999D)) ;
    dataset.addData(0, createData(createDate(4, 10, 2007), 50.200000000000003D,
                                  51.200000000000003D, 47.799999999999997D, 48.100000000000001D)) ;
    dataset.addData(0, createData(createDate(5, 10, 2007), 50.5D, 53.200000000000003D,
                                  49.799999999999997D, 50.100000000000001D)) ;

    return dataset ;
  }

  public static SingleRowDataset createDataset2() {
    SingleRowDataset dataset = new SingleRowDataset() ;
    dataset.addRowKey("Series 2") ;

    dataset.addRowData() ;
    dataset.addData(0, createData(createDate(24, 9, 2007), 5.5D, 6.2000000000000002D,
                                  4.7999999999999998D, 5.9000000000000004D)) ;
    dataset.addData(0, createData(createDate(25, 9, 2007), 6D, 6.9000000000000004D, 6D,
                                  6.7000000000000002D)) ;
    dataset.addData(0, createData(createDate(26, 9, 2007), 6.7999999999999998D, 7.5D,
                                  6.4000000000000004D, 7.0999999999999996D)) ;
    dataset.addData(0, createData(createDate(27, 9, 2007), 7.2000000000000002D,
                                  8.1999999999999993D, 7D, 7.9000000000000004D)) ;
    dataset.addData(0, createData(createDate(28, 9, 2007), 7.7999999999999998D, 8.5D,
                                  7.7000000000000002D, 8.1999999999999993D)) ;
    dataset.addData(0, createData(createDate(1, 10, 2007), 8.1999999999999993D, 8.5D,
                                  7.7000000000000002D, 7.7999999999999998D)) ;
    dataset.addData(0, createData(createDate(2, 10, 2007), 7.9000000000000004D,
                                  8.1999999999999993D, 7D, 7.2000000000000002D)) ;
    dataset.addData(0, createData(createDate(3, 10, 2007), 7.0999999999999996D, 7.5D,
                                  6.4000000000000004D, 6.7999999999999998D)) ;
    dataset.addData(0, createData(createDate(4, 10, 2007), 6D, 6.9000000000000004D, 6D,
                                  6.7000000000000002D)) ;
    dataset.addData(0, createData(createDate(5, 10, 2007), 5.5D, 6.2000000000000002D,
                                  4.7999999999999998D, 5.9000000000000004D)) ;

    return dataset ;
  }

  private static OHLCChartData createData(Date date, double open, double high, double low,
                                          double close) {
    return new OHLCChartData(date, open, high, low, close, 0.0) ;
  }

  public static synchronized Date createDate(final int day, final int month, final int year) {
    CALENDAR.clear() ;
    CALENDAR.set(year, month - 1, day) ;
    return CALENDAR.getTime() ;
  }

}
