package demo.images ;

import java.awt.Font ;

import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.dataset.SingleRowDataset ;
import com.ijchart.xychart.plot.NoAxisPlot ;
import com.ijchart.xychart.render.noaxis.PieRender ;
import com.ijchart.xychart.title.TextTitle ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class PieChartHotspotTest {

  public IJChart createChart() {
    SingleRowDataset dataset = createDataset() ;
    IJChart chart = ChartFactory.createPieChart("Pie Chart Demo 1", dataset, true, true) ;

    ((TextTitle) chart.getTitle()).setToolTipText("A title tooltip!") ;
    NoAxisPlot plot = (NoAxisPlot) chart.getPlot() ;
    plot.setNoDataMessage("No data available") ;
    PieRender render = (PieRender) plot.getRender() ;
    render.setBaseItemLabelFont(new Font("SansSerif", 0, 12)) ;
    render.setCircular(false) ;
    render.setLabelGap(0.02D) ;

    return chart ;
  }

  private static SingleRowDataset createDataset() {
    SingleRowDataset dataset = new SingleRowDataset() ;

    dataset.addColKey("One") ;
    dataset.addColKey("Two") ;
    dataset.addColKey("Three") ;
    dataset.addColKey("Four") ;
    dataset.addColKey("Five") ;
    dataset.addColKey("Six") ;

    dataset.addRowData() ;
    dataset.addData(0, new NumberChartData(43.200000000000003D)) ;
    dataset.addData(0, new NumberChartData(10D)) ;
    dataset.addData(0, new NumberChartData(27.5D)) ;
    dataset.addData(0, new NumberChartData(17.5D)) ;
    dataset.addData(0, new NumberChartData(11D)) ;
    dataset.addData(0, new NumberChartData(19.399999999999999D)) ;

    return dataset ;
  }

}
