package demo.miscellaneous;

import java.awt.BorderLayout ;
import java.awt.Color ;
import java.awt.GradientPaint ;
import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.constant.GradientPaintTransformType ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.CategoryPlot ;
import com.ijchart.xychart.render.category.Bar2DRender ;
import com.ijchart.xychart.ui.RectangleEdge ;
import com.ijchart.xychart.ui.RectangleInsets ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class GradientPaintTransformerDemo1 extends JPanel {
  private static ChartOrientation orientation = ChartOrientation.VERTICAL ;

  public GradientPaintTransformerDemo1() {
    setLayout(new BorderLayout()) ;
    addPanel1() ;
  }

  private void addPanel1() {
    JPanel jpanel = new JPanel(new GridLayout(2, 2)) ;
    IMatrixDataset categorydataset = createDataset() ;

    IJChart chart = createChart("Type: VERTICAL", categorydataset) ;
    CategoryPlot categoryplot = (CategoryPlot) chart.getPlot() ;

    Bar2DRender render = (Bar2DRender) categoryplot.getRender() ;
    render.setBaseItemDrawBorder(false) ;
    render.setAutoSelectFillPaint(false) ;
    render.setColumnItemFillPaint(0, new GradientPaint(0.0F, 0.0F, Color.red, 0.0F, 0.0F,
                                                        Color.yellow)) ;
    render.setColumnItemFillPaint(1, new GradientPaint(0.0F, 0.0F, Color.blue, 0.0F, 0.0F,
                                                        Color.green)) ;
    render.setBaseItemFillPaintTransformer(GradientPaintTransformType.VERTICAL) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    jpanel.add(chartpanel) ;

    IJChart chart1 = createChart("Type: HORIZONTAL", categorydataset) ;
    CategoryPlot categoryplot1 = (CategoryPlot) chart1.getPlot() ;

    Bar2DRender render1 = (Bar2DRender) categoryplot1.getRender() ;
    render1.setBaseItemDrawBorder(false) ;
    render1.setAutoSelectFillPaint(false) ;
    render1.setColumnItemFillPaint(0, new GradientPaint(0.0F, 0.0F, Color.red, 0.0F, 0.0F,
                                                         Color.yellow)) ;
    render1.setColumnItemFillPaint(1, new GradientPaint(0.0F, 0.0F, Color.blue, 0.0F, 0.0F,
                                                         Color.green)) ;
    render1.setBaseItemFillPaintTransformer(GradientPaintTransformType.HORIZONTAL) ;

    ChartPanel chartpanel1 = new ChartPanel(chart1) ;
    jpanel.add(chartpanel1) ;

    IJChart chart2 = createChart("Type: CENTER_VERTICAL", categorydataset) ;
    CategoryPlot categoryplot2 = (CategoryPlot) chart2.getPlot() ;

    Bar2DRender render2 = (Bar2DRender) categoryplot2.getRender() ;
    render2.setBaseItemDrawBorder(false) ;
    render2.setAutoSelectFillPaint(false) ;
    render2.setColumnItemFillPaint(0, new GradientPaint(0.0F, 0.0F, Color.red, 0.0F, 0.0F,
                                                         Color.yellow)) ;
    render2.setColumnItemFillPaint(1, new GradientPaint(0.0F, 0.0F, Color.blue, 0.0F, 0.0F,
                                                         Color.green)) ;
    render2.setBaseItemFillPaintTransformer(GradientPaintTransformType.CENTER_VERTICAL) ;

    ChartPanel chartpanel2 = new ChartPanel(chart2) ;
    jpanel.add(chartpanel2) ;

    IJChart chart3 = createChart("Type: CENTER_HORIZONTAL", categorydataset) ;
    CategoryPlot categoryplot3 = (CategoryPlot) chart3.getPlot() ;

    Bar2DRender render3 = (Bar2DRender) categoryplot3.getRender() ;
    render3.setBaseItemDrawBorder(false) ;
    render3.setAutoSelectFillPaint(false) ;
    render3.setColumnItemFillPaint(0, new GradientPaint(0.0F, 0.0F, Color.red, 0.0F, 0.0F,
                                                         Color.yellow)) ;
    render3.setColumnItemFillPaint(1, new GradientPaint(0.0F, 0.0F, Color.blue, 0.0F, 0.0F,
                                                         Color.green)) ;
    render3.setBaseItemFillPaintTransformer(GradientPaintTransformType.CENTER_HORIZONTAL) ;

    ChartPanel chartpanel3 = new ChartPanel(chart3) ;
    jpanel.add(chartpanel3) ;
    add(jpanel) ;
  }

  private static IJChart createChart(String s, IMatrixDataset categorydataset) {
    IJChart chart = ChartFactory.createCategoryBar2DChart(s, null, "Value", categorydataset,
                                                          orientation, true, true) ;

    CategoryPlot categoryplot = (CategoryPlot) chart.getPlot() ;
    categoryplot.getRender().setBackgroundPaint(Color.lightGray) ;
    categoryplot.setDomainGridlinePaint(Color.white) ;
    categoryplot.setValueGridlinePaint(Color.white) ;
    categoryplot.setAxisOffset(new RectangleInsets(0D, 0D, 0D, 40D)) ;

    chart.getLegendTitle().setPosition(RectangleEdge.BOTTOM) ;

    Bar2DRender barrenderer = (Bar2DRender) categoryplot.getRender() ;
    barrenderer.setItemMargin(0.02D) ;

    return chart ;
  }

  private static IMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addColKey("Series 1") ;
    dataset.addColKey("Series 2") ;
    dataset.addRowKey("Category 1") ;

    dataset.addRowData(1) ;
    dataset.addData(0, new NumberChartData(7D)) ;
    dataset.addData(0, new NumberChartData(5D)) ;

    return dataset ;
  }

}
