package demo.miscellaneous;

import java.awt.BorderLayout ;
import java.awt.event.ActionEvent ;
import java.awt.event.ActionListener ;

import javax.swing.JCheckBox ;
import javax.swing.JPanel ;

import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.render.xy.XYLineAndShapeRender ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class HideSeriesDemo1 extends JPanel implements ActionListener {
  private IJChart chart ;

  public HideSeriesDemo1() {
    setLayout(new BorderLayout()) ;
    addPanel1() ;

    JPanel jpanel = new JPanel() ;
    JCheckBox jcheckbox = new JCheckBox("Series 1") ;
    jcheckbox.setActionCommand("S1") ;
    jcheckbox.addActionListener(this) ;
    jcheckbox.setSelected(true) ;
    JCheckBox jcheckbox1 = new JCheckBox("Series 2") ;
    jcheckbox1.setActionCommand("S2") ;
    jcheckbox1.addActionListener(this) ;
    jcheckbox1.setSelected(true) ;
    JCheckBox jcheckbox2 = new JCheckBox("Series 3") ;
    jcheckbox2.setActionCommand("S3") ;
    jcheckbox2.addActionListener(this) ;
    jcheckbox2.setSelected(true) ;
    jpanel.add(jcheckbox) ;
    jpanel.add(jcheckbox1) ;
    jpanel.add(jcheckbox2) ;
    add(jpanel, BorderLayout.SOUTH) ;
  }

  private void addPanel1() {
    IMatrixDataset dataset = createDataset() ;
    chart = ChartFactory.createXYLineAndShapeChart("Hide Series Demo 1", "X", "Y",
                                           dataset, ChartOrientation.VERTICAL, true, true,
                                           false, false) ;
    XYPlot plot = (XYPlot) chart.getPlot() ;
    plot.getDomainAxis().setAxisRangeIncludeZero(false) ;

    XYLineAndShapeRender render = (XYLineAndShapeRender) plot.getRender() ;
    render.setBaseItemShapeVisible(false) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel, BorderLayout.CENTER) ;
  }

  public static IMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("Series 1") ;
    dataset.addRowKey("Series 2") ;
    dataset.addRowKey("Series 3") ;
    dataset.addRowData(3) ;

    dataset.addData(0, new XYNumberChartData(1.0D, 3.2999999999999998D)) ;
    dataset.addData(0, new XYNumberChartData(2D, 4.4000000000000004D)) ;
    dataset.addData(0, new XYNumberChartData(3D, 1.7D)) ;

    dataset.addData(1, new XYNumberChartData(1.0D, 7.2999999999999998D)) ;
    dataset.addData(1, new XYNumberChartData(2D, 6.7999999999999998D)) ;
    dataset.addData(1, new XYNumberChartData(3D, 9.5999999999999996D)) ;
    dataset.addData(1, new XYNumberChartData(4D, 5.5999999999999996D)) ;

    dataset.addData(2, new XYNumberChartData(1.0D, 17.300000000000001D)) ;
    dataset.addData(2, new XYNumberChartData(2D, 16.800000000000001D)) ;
    dataset.addData(2, new XYNumberChartData(3D, 19.600000000000001D)) ;
    dataset.addData(2, new XYNumberChartData(4D, 15.6D)) ;

    return dataset ;
  }

  public void actionPerformed(ActionEvent actionevent) {
    int row = -1 ;
    if (actionevent.getActionCommand().equals("S1")) {
      row = 0 ;
    } else if (actionevent.getActionCommand().equals("S2")) {
      row = 1 ;
    } else if (actionevent.getActionCommand().equals("S3")) {
      row = 2 ;
    }

    if (row >= 0) {
      XYPlot plot = (XYPlot) chart.getPlot() ;
      XYLineAndShapeRender render = (XYLineAndShapeRender) plot.getRender() ;
      Boolean flag = render.isRowItemVisible(row) ;
      render.setRowItemVisible(row, flag == null ? false : !flag.booleanValue()) ;
    }

  }
}
