package demo.miscellaneous.annotations ;

import java.awt.Color ;
import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.annotation.XYPointerAnnotation ;
import com.ijchart.xychart.axis.value.XYNumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.constant.HorizontalAlignment ;
import com.ijchart.xychart.constant.IAngle ;
import com.ijchart.xychart.constant.XYValueAxisType ;
import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.render.xy.XYLineAndShapeRender ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class AnnotationDemo2 extends JPanel {
  private ChartOrientation vertical = ChartOrientation.VERTICAL ;

  public AnnotationDemo2() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel1() ;
  }

  private void addPanel1() {
    IMatrixDataset dataset = createDataset1() ;
    IMatrixDataset dataset2 = createDataset2() ;
    IJChart chart = ChartFactory.createXYLineAndShapeChart("Annotation Demo 2", "Date",
                                                           "Price Per Unit",
                                                           dataset, vertical, true, true, false, false) ;

    XYPlot plot = (XYPlot) chart.getPlot() ;
    XYNumberValueAxis yAxis = (XYNumberValueAxis) plot.getValueAxis() ;
    yAxis.setAxisRangeIncludeZero(false) ;

    XYNumberValueAxis yAxis2 = new XYNumberValueAxis("Secondary", dataset2,
                                                     XYValueAxisType.XY_VALUE_AXIS_Y) ;
    yAxis2.setAxisRangeIncludeZero(false) ;
    yAxis2.setAxisLabelAngle(IAngle.ANGLE_DOWN_90) ;
    plot.setValueAxis(1, yAxis2) ;

    XYLineAndShapeRender render = (XYLineAndShapeRender) plot.getRender() ;
    XYPointerAnnotation annotation = new XYPointerAnnotation("Annotation 1 (2.0, 167.3)", 2D,
                                                             167.30000000000001D,
                                                             -0.78539816339744828D) ;
    annotation.setArrowPaint(Color.red) ;
    annotation.setTextPaint(Color.red) ;
    render.addAnnotation(annotation) ;

    XYLineAndShapeRender render1 = new XYLineAndShapeRender(dataset2) ;
    plot.setRender(1, render1) ;
    plot.mapRenderToValueAxis(1, 1) ;

    XYPointerAnnotation xypointerannotation1 = new XYPointerAnnotation("Annotation 2 (15.0, 613.2)",
                                                                       15D, 613.20000000000005D,
                                                                       1.5707963267948966D) ;
    xypointerannotation1.setTextHorizontalAlign(HorizontalAlignment.CENTER) ;
    render1.addAnnotation(xypointerannotation1) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset1() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("Random Data 1") ;
    dataset.addRowData() ;

    dataset.addData(0, new XYNumberChartData(1.0D, 181.80000000000001D)) ;
    dataset.addData(0, new XYNumberChartData(2D, 167.30000000000001D)) ;
    dataset.addData(0, new XYNumberChartData(3D, 153.80000000000001D)) ;
    dataset.addData(0, new XYNumberChartData(4D, 167.59999999999999D)) ;
    dataset.addData(0, new XYNumberChartData(5D, 158.80000000000001D)) ;
    dataset.addData(0, new XYNumberChartData(6D, 148.30000000000001D)) ;
    dataset.addData(0, new XYNumberChartData(7D, 153.90000000000001D)) ;
    dataset.addData(0, new XYNumberChartData(8D, 142.69999999999999D)) ;
    dataset.addData(0, new XYNumberChartData(9D, 123.2D)) ;
    dataset.addData(0, new XYNumberChartData(10D, 131.80000000000001D)) ;
    dataset.addData(0, new XYNumberChartData(11D, 139.59999999999999D)) ;
    dataset.addData(0, new XYNumberChartData(12D, 142.90000000000001D)) ;
    dataset.addData(0, new XYNumberChartData(13D, 138.69999999999999D)) ;
    dataset.addData(0, new XYNumberChartData(14D, 137.30000000000001D)) ;
    dataset.addData(0, new XYNumberChartData(15D, 143.90000000000001D)) ;
    dataset.addData(0, new XYNumberChartData(16D, 139.80000000000001D)) ;
    dataset.addData(0, new XYNumberChartData(17D, 137D)) ;
    dataset.addData(0, new XYNumberChartData(18D, 132.80000000000001D)) ;

    return dataset ;
  }

  private static IMatrixDataset createDataset2() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("Random Data 2") ;
    dataset.addRowData() ;

    dataset.addData(0, new XYNumberChartData(1.0D, 429.60000000000002D)) ;
    dataset.addData(0, new XYNumberChartData(2D, 323.19999999999999D)) ;
    dataset.addData(0, new XYNumberChartData(3D, 417.19999999999999D)) ;
    dataset.addData(0, new XYNumberChartData(4D, 624.10000000000002D)) ;
    dataset.addData(0, new XYNumberChartData(5D, 422.60000000000002D)) ;
    dataset.addData(0, new XYNumberChartData(6D, 619.20000000000005D)) ;
    dataset.addData(0, new XYNumberChartData(7D, 416.5D)) ;
    dataset.addData(0, new XYNumberChartData(8D, 512.70000000000005D)) ;
    dataset.addData(0, new XYNumberChartData(9D, 501.5D)) ;
    dataset.addData(0, new XYNumberChartData(10D, 306.10000000000002D)) ;
    dataset.addData(0, new XYNumberChartData(11D, 410.30000000000001D)) ;
    dataset.addData(0, new XYNumberChartData(12D, 511.69999999999999D)) ;
    dataset.addData(0, new XYNumberChartData(13D, 611D)) ;
    dataset.addData(0, new XYNumberChartData(14D, 709.60000000000002D)) ;
    dataset.addData(0, new XYNumberChartData(15D, 613.20000000000005D)) ;
    dataset.addData(0, new XYNumberChartData(16D, 711.60000000000002D)) ;
    dataset.addData(0, new XYNumberChartData(17D, 708.79999999999995D)) ;
    dataset.addData(0, new XYNumberChartData(18D, 501.60000000000002D)) ;

    return dataset ;
  }
}
