package demo.multipleaxischarts ;

import java.awt.Color ;
import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.NumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.AxisLocation ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.constant.IAngle ;
import com.ijchart.xychart.constant.RenderDrawOrder ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.CategoryPlot ;
import com.ijchart.xychart.render.category.Bar2DRender ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class DualAxisDemo5 extends JPanel {
  public DualAxisDemo5() {
    setLayout(new GridLayout(1, 1)) ;
    createPanel1() ;
  }

  public void createPanel1() {
    IJChart chart = createChart() ;
    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private IJChart createChart() {
    IMatrixDataset dataset1 = createDataset1() ;
    IJChart chart = ChartFactory.createCategoryBar2DChart("Dual Axis Chart", "Category", "Value",
                                                          dataset1, ChartOrientation.VERTICAL, true, true) ;
    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    plot.setCategoryAxisLocation(AxisLocation.BOTTOM_OR_RIGHT) ;
    plot.setDomainGridlineVisible(false) ;

    Bar2DRender render = new Bar2DRender(dataset1) {
      protected int getLegendItemCount() {
        return 1 ;
      }
    } ;
    plot.setRender(0, render) ;

    IMatrixDataset dataset2 = createDataset2() ;
    Bar2DRender shapeRender = new Bar2DRender(dataset2) {
      protected int getLegendItemCount() {
        return 1 ;
      }

      protected String[] getLegendItemLabels() {
        return new String[] {"Series 2"} ;
      }
    } ;
    shapeRender.setAutoSelectFillPaint(false) ;
    shapeRender.setBaseItemFillPaint(Color.blue) ;
    plot.setRender(1, shapeRender) ;

    NumberValueAxis numberaxis = new NumberValueAxis("Secondary", dataset2) ;
    numberaxis.setAxisLabelAngle(IAngle.ANGLE_DOWN_90) ;
    plot.setValueAxis(1, numberaxis) ;
    plot.setRenderDrawOrder(RenderDrawOrder.FORWARD) ;

    return chart ;
  }

  private static IMatrixDataset createDataset1() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    String s = "Series 1" ;
    String s2 = "Category 1" ;
    String s3 = "Category 2" ;
    String s4 = "Category 3" ;
    String s5 = "Category 4" ;

    dataset.addColKey(s) ;

    dataset.addRowKey(s2) ;
    dataset.addRowKey(s3) ;
    dataset.addRowKey(s4) ;
    dataset.addRowKey(s5) ;

    dataset.addRowData(4) ;

    dataset.addData(0, new NumberChartData(1.0D)) ;
    dataset.addData(1, new NumberChartData(4D)) ;
    dataset.addData(2, new NumberChartData(3D)) ;
    dataset.addData(3, new NumberChartData(5D)) ;
    dataset.addData(0, new NumberChartData(Double.NaN)) ;
    dataset.addData(1, new NumberChartData(Double.NaN)) ;
    dataset.addData(2, new NumberChartData(Double.NaN)) ;
    dataset.addData(3, new NumberChartData(Double.NaN)) ;

    return dataset ;
  }

  private static IMatrixDataset createDataset2() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    String s = "Dummy 2" ;
    String s1 = "Series 2" ;
    String s2 = "Category 1" ;
    String s3 = "Category 2" ;
    String s4 = "Category 3" ;
    String s5 = "Category 4" ;

    dataset.addColKey(s) ;
    dataset.addColKey(s1) ;

    dataset.addRowKey(s2) ;
    dataset.addRowKey(s3) ;
    dataset.addRowKey(s4) ;
    dataset.addRowKey(s5) ;

    dataset.addRowData(4) ;

    dataset.addData(0, new NumberChartData(Double.NaN)) ;
    dataset.addData(1, new NumberChartData(Double.NaN)) ;
    dataset.addData(2, new NumberChartData(Double.NaN)) ;
    dataset.addData(3, new NumberChartData(Double.NaN)) ;
    dataset.addData(0, new NumberChartData(75D)) ;
    dataset.addData(1, new NumberChartData(87D)) ;
    dataset.addData(2, new NumberChartData(96D)) ;
    dataset.addData(3, new NumberChartData(68D)) ;

    return dataset ;
  }
}
