package demo.others ;

import java.awt.GridLayout ;
import java.util.Calendar ;
import java.util.Date ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.AbstractValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.GranttChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.CategoryPlot ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class GranttChartPanel1 extends JPanel {

  private ChartOrientation vertical = ChartOrientation.VERTICAL ;

  private ChartOrientation horizontal = ChartOrientation.HORIZONTAL ;

  public GranttChartPanel1() {
    setLayout(new GridLayout(2, 2)) ;
    addPanel1() ;
    addPanel2() ;
    addPanel3() ;
    addPanel4() ;

//    setLayout(new GridLayout(1, 1)) ;
//    addPanel4() ;
  }

  private void addPanel1() {
    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createGranttChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, vertical, true, true) ;

    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setLowerMargin(0.05) ;
    valueAxis.setUpperMargin(0.1) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel2() {
    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createGranttChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, vertical, true, true) ;

    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setLowerMargin(0.05) ;
    valueAxis.setUpperMargin(0.1) ;
    valueAxis.setInverted(true) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel3() {
    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createGranttChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, horizontal, true, true) ;

    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setLowerMargin(0.05) ;
    valueAxis.setUpperMargin(0.1) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel4() {
    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createGranttChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, horizontal, true, true) ;

    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setLowerMargin(0.05) ;
    valueAxis.setUpperMargin(0.1) ;
    valueAxis.setInverted(true) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset1() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addColKey("Scheduled") ;
    dataset.addColKey("Actual") ;

    dataset.addRowKey("Write Proposal") ;
    dataset.addRowKey("Obtain Approval") ;
    dataset.addRowKey("Requirements Analysis") ;
    dataset.addRowKey("Design Phase") ;
    dataset.addRowKey("Design Signoff") ;
    dataset.addRowKey("Alpha Implementation") ;
    dataset.addRowKey("Design Review") ;
    dataset.addRowKey("Revised Design Signoff") ;
    dataset.addRowKey("Beta Implementation") ;
    dataset.addRowKey("Testing") ;
    dataset.addRowKey("Final Implementation") ;
    dataset.addRowKey("Signoff") ;

    dataset.addRowData() ;
    dataset.addData(0, new GranttChartData(createDate(1, 2, 2001), createDate(28, 2, 2001),
                                           new Double(0.3))) ;
    dataset.addData(0, new GranttChartData(createDate(1, 2, 2001), createDate(27, 2, 2001),
                                           new Double(0.23))) ;

    dataset.addRowData() ;
    dataset.addData(1, new GranttChartData(createDate(9, 3, 2001), createDate(15, 3, 2001),
                                           new Double(0.23))) ;
    dataset.addData(1, new GranttChartData(createDate(9, 3, 2001), createDate(9, 3, 2001),
                                           new Double(0.43))) ;

    dataset.addRowData() ;
    dataset.addData(2, new GranttChartData(createDate(10, 3, 2001), createDate(5, 4, 2001),
                                           new Double(0.343))) ;
    dataset.addData(2, new GranttChartData(createDate(10, 3, 2001), createDate(15, 4, 2001),
                                           new Double(0.53))) ;

    dataset.addRowData() ;
    dataset.addData(3, new GranttChartData(createDate(6, 4, 2001), createDate(30, 4, 2001),
                                           new Double(0.43))) ;
    dataset.addData(3, new GranttChartData(createDate(15, 4, 2001), createDate(17, 5, 2001),
                                           new Double(0.73))) ;

    dataset.addRowData() ;
    dataset.addData(4, new GranttChartData(createDate(2, 5, 2001), createDate(2, 5, 2001),
                                           new Double(0.43))) ;
    dataset.addData(4, new GranttChartData(createDate(30, 5, 2001), createDate(30, 5, 2001),
                                           new Double(0.53))) ;

    dataset.addRowData() ;
    dataset.addData(5, new GranttChartData(createDate(3, 5, 2001), createDate(31, 6, 2001),
                                           new Double(0.33))) ;
    dataset.addData(5, new GranttChartData(createDate(1, 6, 2001), createDate(12, 8, 2001),
                                           new Double(0.13))) ;

    dataset.addRowData() ;
    dataset.addData(6, new GranttChartData(createDate(1, 7, 2001), createDate(8, 7, 2001),
                                           new Double(0.23))) ;
    dataset.addData(6, new GranttChartData(createDate(12, 8, 2001), createDate(22, 8, 2001),
                                           new Double(0.3))) ;

    dataset.addRowData() ;
    dataset.addData(7, new GranttChartData(createDate(10, 7, 2001), createDate(10, 7, 2001),
                                           new Double(0.33))) ;
    dataset.addData(7, new GranttChartData(createDate(25, 8, 2001), createDate(27, 8, 2001),
                                           new Double(0.23))) ;

    dataset.addRowData() ;
    dataset.addData(8, new GranttChartData(createDate(12, 7, 2001), createDate(12, 8, 2001),
                                           new Double(0.33))) ;
    dataset.addData(8, new GranttChartData(createDate(27, 8, 2001), createDate(30, 9, 2001),
                                           new Double(0.23))) ;

    dataset.addRowData() ;
    dataset.addData(9, new GranttChartData(createDate(13, 8, 2001), createDate(31, 9, 2001),
                                           new Double(0.323))) ;
    dataset.addData(9, new GranttChartData(createDate(31, 9, 2001), createDate(17, 10, 2001),
                                           new Double(0.333))) ;

    dataset.addRowData() ;
    dataset.addData(10, new GranttChartData(createDate(1, 10, 2001), createDate(15, 10, 2001),
                                            new Double(0.83))) ;
    dataset.addData(10, new GranttChartData(createDate(18, 10, 2001), createDate(5, 11, 2001),
                                            new Double(0.63))) ;

    dataset.addRowData() ;
    dataset.addData(11, new GranttChartData(createDate(28, 10, 2001), createDate(30, 10, 2001),
                                            new Double(0.73))) ;
    dataset.addData(11, new GranttChartData(createDate(10, 11, 2001), createDate(11, 11, 2001),
                                            new Double(0.63))) ;

    return dataset ;
  }

  private static Date createDate(int day, int month, int year) {
    Calendar calendar = Calendar.getInstance() ;
    calendar.set(year, month - 1, day) ;
    Date date1 = calendar.getTime() ;

    return date1 ;
  }

}
