package demo.others.categorycharts;

import java.awt.GridLayout ;
import java.util.Calendar ;
import java.util.Date ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.AbstractValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.constant.GranttDrawType ;
import com.ijchart.xychart.data.GranttChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.CategoryPlot ;
import com.ijchart.xychart.render.category.GranttRender ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class GranttChartPanel2 extends JPanel {

  private ChartOrientation vertical = ChartOrientation.VERTICAL ;

  private ChartOrientation horizontal = ChartOrientation.HORIZONTAL ;

  public GranttChartPanel2() {
    setLayout(new GridLayout(2, 2)) ;
    addPanel1() ;
    addPanel2() ;
    addPanel3() ;
    addPanel4() ;
  }

  private void addPanel1() {
    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createGranttChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, vertical, true, true) ;

    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setLowerMargin(0.05) ;
    valueAxis.setUpperMargin(0.1) ;

    GranttRender render = (GranttRender) plot.getRender() ;
    render.setDrawType(GranttDrawType.VERTICAL) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel2() {
    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createGranttChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, vertical, true, true) ;

    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setLowerMargin(0.05) ;
    valueAxis.setUpperMargin(0.1) ;
    valueAxis.setInverted(true) ;

    GranttRender render = (GranttRender) plot.getRender() ;
    render.setDrawType(GranttDrawType.VERTICAL) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel3() {
    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createGranttChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, horizontal, true, true) ;

    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setLowerMargin(0.05) ;
    valueAxis.setUpperMargin(0.1) ;

    GranttRender render = (GranttRender) plot.getRender() ;
    render.setDrawType(GranttDrawType.VERTICAL) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel4() {
    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createGranttChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, horizontal, true, true) ;

    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setLowerMargin(0.05) ;
    valueAxis.setUpperMargin(0.1) ;
    valueAxis.setInverted(true) ;

    GranttRender render = (GranttRender) plot.getRender() ;
    render.setDrawType(GranttDrawType.VERTICAL) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset1() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addColKey("Scheduled") ;
    dataset.addColKey("Actual") ;
    dataset.addColKey("Actual2") ;

    dataset.addRowKey("Write Proposal") ;
    dataset.addRowData() ;
    dataset.addData(0, new GranttChartData(createDate(1, 3, 2001), createDate(5, 3, 2001),
                                           new Double(0.23))) ;

    dataset.addRowKey("Obtain Approval") ;
    dataset.addRowData() ;
    dataset.addData(1, new GranttChartData(createDate(9, 3, 2001), createDate(12, 3, 2001),
                                           new Double(0.36))) ;

    dataset.addRowKey("Requirements Analysis") ;
    dataset.addRowData() ;
    dataset.addData(2, new GranttChartData(createDate(9, 3, 2001), createDate(15, 3, 2001),
                                           new Double(0.38))) ;

    dataset.addRowKey("Analysis2") ;
    dataset.addRowData() ;
    dataset.addData(3, new GranttChartData(createDate(10, 3, 2001), createDate(25, 3, 2001),
                                           new Double(0.97))) ;
    dataset.addData(3, new GranttChartData(createDate(20, 4, 2001), createDate(25, 4, 2001),
                                           new Double(0.86))) ;
    dataset.addData(3, new GranttChartData(createDate(1, 4, 2001), createDate(5, 4, 2001),
                                           new Double(0.56))) ;

    dataset.addRowKey("Design Phase") ;
    dataset.addRowData() ;
    dataset.addData(4, new GranttChartData(createDate(6, 4, 2001), createDate(8, 4, 2001),
                                           new Double(0.47))) ;
    dataset.addData(4, new GranttChartData(createDate(9, 4, 2001), createDate(10, 4, 2001),
                                           new Double(0.76))) ;
    dataset.addData(4, new GranttChartData(createDate(15, 4, 2001), createDate(20, 4, 2001),
                                           new Double(0.36))) ;
    dataset.addData(4, new GranttChartData(createDate(23, 4, 2001), createDate(30, 4, 2001),
                                           new Double(0.46))) ;

    dataset.addRowKey("Design Signoff") ;
    dataset.addRowData() ;
    dataset.addData(5, new GranttChartData(createDate(2, 5, 2001), createDate(2, 5, 2001),
                                           new Double(0.91))) ;

    dataset.addRowKey("Alpha Implementation") ;
    dataset.addRowData() ;
    dataset.addData(6, new GranttChartData(createDate(3, 5, 2001), createDate(31, 6, 2001),
                                           new Double(0.59999999999999998D))) ;

    dataset.addRowKey("Design Review") ;
    dataset.addRowData() ;
    dataset.addData(7, new GranttChartData(createDate(1, 7, 2001), createDate(8, 7, 2001),
                                           new Double(0.22D))) ;

    dataset.addRowKey("Revised Design Signoff") ;
    dataset.addRowData() ;
    dataset.addData(8, new GranttChartData(createDate(10, 7, 2001), createDate(10, 7, 2001),
                                           new Double(0.32D))) ;

    dataset.addRowKey("Beta Implementation") ;
    dataset.addRowData() ;
    dataset.addData(9, new GranttChartData(createDate(12, 7, 2001), createDate(12, 8, 2001),
                                           new Double(0.26D))) ;

    dataset.addRowKey("Testing") ;
    dataset.addRowData() ;
    dataset.addData(10, new GranttChartData(createDate(13, 8, 2001), createDate(31, 9, 2001),
                                            new Double(0.2D))) ;

    dataset.addRowKey("Final Implementation") ;
    dataset.addRowData() ;
    dataset.addData(11, new GranttChartData(createDate(1, 10, 2001), createDate(15, 10, 2001),
                                            new Double(0.18D))) ;

    dataset.addRowKey("Signoff") ;
    dataset.addRowData() ;
    dataset.addData(12, new GranttChartData(createDate(28, 10, 2001), createDate(30, 11, 2001),
                                            new Double(0.27D))) ;

    return dataset ;
  }

  private static Date createDate(int day, int month, int year) {
    Calendar calendar = Calendar.getInstance() ;
    calendar.set(year, month - 1, day) ;
    Date date1 = calendar.getTime() ;

    return date1 ;
  }

}
