package demo.others.xy ;

import java.awt.GridLayout ;
import java.util.Calendar ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.AbstractValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.IntervalXNumberYBaseChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class IntervalXNumberYBaseBar2DChartPanelYear extends JPanel {

  private ChartOrientation vertical = ChartOrientation.VERTICAL ;

  private ChartOrientation horizontal = ChartOrientation.HORIZONTAL ;

  public IntervalXNumberYBaseBar2DChartPanelYear() {
    setLayout(new GridLayout(2, 2)) ;
    addPanel1() ;
    addPanel2() ;
    addPanel3() ;
    addPanel4() ;
  }

  private void addPanel1() {

    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createIntervalXBaseYBar2DChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, vertical, true, true, true, false) ;

//        setChartLabelXY(chart) ;
//        XYPlot plot = (XYPlot) chart.getPlot() ;
//        AbstractXYRender xyRender = plot.getRender() ;
//        xyRender.setRowItemsOutlineStroke(0, new BasicStroke(2.0F)) ;
//        xyRender.setRowItemsOutlineStroke(1, new BasicStroke(2.0F)) ;
//        xyRender.setBaseItemLabelFont(new Font("Dialog", 1, 14)) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel2() {

    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createIntervalXBaseYBar2DChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, vertical, true, true, true, false) ;

    XYPlot plot = (XYPlot) chart.getPlot() ;
//        AbstractXYRender xyRender = plot.getRender() ;
//        xyRender.setRowItemsOutlineStroke(0, new BasicStroke(2.0F)) ;
//        xyRender.setRowItemsOutlineStroke(1, new BasicStroke(2.0F)) ;
//        xyRender.setBaseItemLabelFont(new Font("Dialog", 1, 14)) ;
//
    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setInverted(true) ;
//        valueAxis.setLowerMargin(0.05) ;
//        valueAxis.setUpperMargin(0.05) ;
//        setChartLabelXY(chart) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel3() {

    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createIntervalXBaseYBar2DChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, horizontal, true, true, true, false) ;

//        setChartLabelXY(chart) ;
//        XYPlot plot = (XYPlot) chart.getPlot() ;
//        AbstractXYRender xyRender = plot.getRender() ;
//        xyRender.setRowItemsOutlineStroke(0, new BasicStroke(1.5F)) ;
//        xyRender.setRowItemsOutlineStroke(1, new BasicStroke(2.5F)) ;
//
//        AbstractValueAxis valueAxis = plot.getValueAxis() ;
//        valueAxis.setLowerMargin(0.05) ;
//        valueAxis.setUpperMargin(0.05) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel4() {

    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createIntervalXBaseYBar2DChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, horizontal, true, true, true, false) ;

//        setChartLabelXY(chart) ;
    XYPlot plot = (XYPlot) chart.getPlot() ;
//        AbstractXYRender xyRender = plot.getRender() ;
//        xyRender.setRowItemsOutlineStroke(0, new BasicStroke(1.0F)) ;
//        xyRender.setRowItemsOutlineStroke(1, new BasicStroke(4.0F)) ;
//
    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setInverted(true) ;
//        valueAxis.setLowerMargin(0.05) ;
//        valueAxis.setUpperMargin(0.05) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset1() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addColKey("Col1") ;
    dataset.addColKey("Col2") ;
    dataset.addColKey("Col3") ;
    dataset.addColKey("Col4") ;

    dataset.addRowKey("Row1") ;
    dataset.addRowKey("Row2") ;
    dataset.addRowKey("Row3") ;

    dataset.addRowData() ;
    int[] yearArr1 = {0, 1, 0, 2, 0, 1, 2, 5, 21, 18, 18, 25, 11, 16, 23, 14, 31, 38, 31, 56, 45,
                     74, 68, 98, 85, 66, 71, 65, 59, 60} ;
    int startYear1 = 1976 ;
    for (int i = 0 ; i < yearArr1.length ; i++) {
      dataset.addData(0, createData(startYear1, ++startYear1, yearArr1[i])) ;
    }

    dataset.addRowData() ;
    int[] yearArr2 = {0, 1, 0, 2, 0, 1, 2, 5, 21, 18, 18, 25, 11, 16, 23, 14, 31, 38, 31, 56, 45,
                     74, 68, 98, 85, 66, 71, 65, 59, 60} ;
    int startYear2 = 1936 ;
    for (int i = 0 ; i < yearArr2.length ; i++) {
      dataset.addData(1, createData(startYear2, ++startYear2, yearArr2[i])) ;
    }
    dataset.addData(1, createData(1900, 1901, 60)) ;

    dataset.addRowData() ;
    int[] yearArr3 = {20, 21, 20, 22, 20, 21, 22, 25, 221, 218, 218, 225, 211, 216, 223, 214, 231,
                     238, 231, 256, 245, 274, 268, 298, 285, 266, 271, 265, 259, 260} ;
    int startYear3 = 2936 ;
    for (int i = 0 ; i < yearArr3.length ; i++) {
      dataset.addData(2, createData(startYear3, ++startYear3, yearArr3[i])) ;
    }

    return dataset ;
  }

  private static IntervalXNumberYBaseChartData createData(int yearStart, int yearEnd, int value) {
    Calendar cal = Calendar.getInstance() ;
    cal.set(yearStart, 0, 0, 0, 0, 0) ;

    long start = cal.getTime().getTime() ;
    cal.set(yearEnd, 0, 0, 0, 0, 0) ;
    long end = cal.getTime().getTime() ;

    return new IntervalXNumberYBaseChartData(start, end, value) ;
  }

}
