package demo.others.xy ;

import java.awt.Color ;
import java.awt.GridLayout ;
import java.util.Calendar ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.NumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.XYZNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.render.paint.LookupPaintScale ;
import com.ijchart.xychart.render.xy.XYBlockRender ;
import com.ijchart.xychart.tickunit.LongTickUnit ;
import com.ijchart.xychart.ui.RectangleEdge ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class XYBlockChartPanel2 extends JPanel {

  private IMatrixDataset dataset ;

  public XYBlockChartPanel2() {
    dataset = createDataset() ;
    setLayout(new GridLayout(2, 2)) ;
    createPanel1() ;
    createPanel2() ;
    createPanel3() ;
    createPanel4() ;

  }

  public void createPanel1() {
    IJChart chart = createChart() ;
    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  public void createPanel2() {
    IJChart chart = createChart() ;
    chart.getLegendTitle().setPosition(RectangleEdge.TOP) ;
    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  public void createPanel3() {
    IJChart chart = createChart() ;
    chart.getLegendTitle().setPosition(RectangleEdge.LEFT) ;
    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  public void createPanel4() {
    IJChart chart = createChart() ;
    chart.getLegendTitle().setPosition(RectangleEdge.RIGHT) ;
    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private IJChart createChart() {
    IJChart chart = ChartFactory.createXYBlockChart(
      "This is a very long title,it has many words and wrap automatically.", "Date",
      "Hour", "ͼ", dataset, ChartOrientation.HORIZONTAL, true, true, true, false) ;

    XYPlot plot = (XYPlot) chart.getPlot() ;
    ((NumberValueAxis) plot.getValueAxis()).setTickUnit(new LongTickUnit()) ;

    String[] symbols = new String[] {"", "Unavailable", "", "Free", "",
                       "Group 1", "", "Group 2", ""} ;
    LookupPaintScale lookuppaintscale = new LookupPaintScale(0.0D, 4.5D, Color.white, symbols) ;
    lookuppaintscale.add(0.0D, Color.red) ;
    lookuppaintscale.add(1D, Color.green) ;
    lookuppaintscale.add(2D, Color.blue) ;
    lookuppaintscale.add(3D, Color.yellow) ;

    XYBlockRender render = (XYBlockRender) plot.getRender() ;
    render.setPaintScale(lookuppaintscale) ;
    render.setBlockWidth(86400000D) ;

    return chart ;
  }

  private static IMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowData() ;
    dataset.addRowKey("Series 1") ;

    Calendar cal = Calendar.getInstance() ;
    cal.set(Calendar.HOUR_OF_DAY, 0) ;
    cal.set(Calendar.MINUTE, 0) ;
    cal.set(Calendar.SECOND, 0) ;
    cal.set(Calendar.MILLISECOND, 0) ;

    for (int i = 0 ; i < 100 ; i++) {
      double d = 1.0D ;
      for (int j = 0 ; j <= 24 ; j++) {
        if (Math.random() < 0.10000000000000001D) {
          d = Math.random() * 4D ;
        }

        dataset.addData(0, new XYZNumberChartData(cal.getTime().getTime(), j, d)) ;
      }

      cal.add(Calendar.DAY_OF_MONTH, 1) ;
    }

    return dataset ;
  }

}
