package demo.piecharts ;

import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.dataset.SingleRowDataset ;
import com.ijchart.xychart.label.DefaultLabelGenerator ;
import com.ijchart.xychart.plot.NoAxisPlot ;
import com.ijchart.xychart.render.noaxis.PieRender ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class PieChartDemo8 extends JPanel {

  public PieChartDemo8() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel() ;
  }

  private void addPanel() {
    SingleRowDataset dataset = createDataset() ;
    IJChart chart = ChartFactory.createPieChart("Pie Chart Demo 8", dataset, true, true) ;
    NoAxisPlot plot = (NoAxisPlot) chart.getPlot() ;

    PieRender render = (PieRender) plot.getRender() ;
    render.setLabelGenerator(new DefaultLabelGenerator() {
      public String generateLabel(IMatrixDataset dataset, int row, int column) {
        Object colKey = dataset.getColKey(column) ;
        if (colKey.equals("Two")) {
          return "" ;
        }

        return colKey.toString() ;
      }
    }) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static SingleRowDataset createDataset() {
    SingleRowDataset dataset = new SingleRowDataset() ;

    dataset.addColKey("One") ;
    dataset.addColKey("Two") ;
    dataset.addColKey("Three") ;
    dataset.addColKey("Four") ;
    dataset.addColKey("Five") ;
    dataset.addColKey("Six") ;

    dataset.addRowData() ;
    dataset.addData(0, new NumberChartData(43.200000000000003D)) ;
    dataset.addData(0, new NumberChartData(10D)) ;
    dataset.addData(0, new NumberChartData(27.5D)) ;
    dataset.addData(0, new NumberChartData(17.5D)) ;
    dataset.addData(0, new NumberChartData(11D)) ;
    dataset.addData(0, new NumberChartData(19.399999999999999D)) ;

    return dataset ;
  }

}
