package demo.timeseriescharts ;

import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.XYNumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.constant.DateTickUnitType ;
import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.format.MillisecondsToDateFormatter ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.render.xy.XYLineAndShapeRender ;
import com.ijchart.xychart.tickunit.DateTickUnit ;
import com.ijchart.xychart.util.DateUtil ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class TimeSeriesDemo6 extends JPanel {

  public TimeSeriesDemo6() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel1() ;
  }

  private void addPanel1() {
    IMatrixDataset dataset = createDataset() ;
    IJChart chart = ChartFactory.createXYLineAndShapeChart("Time Series Demo 6", "Date",
                                                           "Value", dataset,
                                                           ChartOrientation.VERTICAL,
                                                           true, true, true, false) ;

    XYPlot xyplot = (XYPlot) chart.getPlot() ;

    XYLineAndShapeRender render = (XYLineAndShapeRender) xyplot.getRender() ;
    render.setBaseItemShapeVisible(false) ;

    XYNumberValueAxis xAxis = (XYNumberValueAxis) xyplot.getDomainAxis() ;
    xAxis.setTickUnit(new DateTickUnit(DateTickUnitType.DATE_UNIT_HOUR)) ;
    xAxis.setTickValueFormatter(new MillisecondsToDateFormatter("MMM-yyyy")) ;
    XYNumberValueAxis yAxis = (XYNumberValueAxis) xyplot.getValueAxis() ;
    yAxis.setUserDefineDatasetRange( -0.5, 0.5) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("Series 1") ;
    dataset.addRowData() ;

    final double d = 0.0 ;
    dataset.addData(0, createData(2, 2001, d)) ;
    dataset.addData(0, createData(3, 2001, d)) ;
    dataset.addData(0, createData(4, 2001, d)) ;
    dataset.addData(0, createData(5, 2001, d)) ;
    dataset.addData(0, createData(6, 2001, d)) ;
    dataset.addData(0, createData(7, 2001, d)) ;
    dataset.addData(0, createData(8, 2001, d)) ;
    dataset.addData(0, createData(9, 2001, d)) ;
    dataset.addData(0, createData(10, 2001, d)) ;
    dataset.addData(0, createData(11, 2001, d)) ;
    dataset.addData(0, createData(12, 2001, d)) ;
    dataset.addData(0, createData(1, 2002, d)) ;
    dataset.addData(0, createData(2, 2002, d)) ;
    dataset.addData(0, createData(3, 2002, d)) ;
    dataset.addData(0, createData(4, 2002, d)) ;
    dataset.addData(0, createData(5, 2002, d)) ;
    dataset.addData(0, createData(6, 2002, d)) ;
    dataset.addData(0, createData(7, 2002, d)) ;

    return dataset ;
  }

  private static XYNumberChartData createData(int month, int year, double value) {
    return new XYNumberChartData(DateUtil.dateToTimeInMillis(year, month), value) ;
  }

}
