package com.ijchart.xychart.client ;

import java.awt.Color ;
import java.awt.Paint ;

import com.ijchart.xychart.axis.category.CategoryAxis ;
import com.ijchart.xychart.axis.category.CategoryAxis3D ;
import com.ijchart.xychart.axis.category.GroupCategoryAxis ;
import com.ijchart.xychart.axis.value.BoxAndWhiskerValueAxis ;
import com.ijchart.xychart.axis.value.ErrorValueAxis ;
import com.ijchart.xychart.axis.value.GranttValueAxis ;
import com.ijchart.xychart.axis.value.GroupStackedNumberValueAxis ;
import com.ijchart.xychart.axis.value.IntervalValueAxis ;
import com.ijchart.xychart.axis.value.IntervalXNumberYBaseValueAxis ;
import com.ijchart.xychart.axis.value.IntervalXYValueAxis ;
import com.ijchart.xychart.axis.value.NumberValueAxis ;
import com.ijchart.xychart.axis.value.NumberValueAxis3D ;
import com.ijchart.xychart.axis.value.OHLCDateAxis ;
import com.ijchart.xychart.axis.value.OHLCValueAxis ;
import com.ijchart.xychart.axis.value.Stacked3DNumberValueAxis ;
import com.ijchart.xychart.axis.value.StackedNumberValueAxis ;
import com.ijchart.xychart.axis.value.StackedXYBarValueAxis ;
import com.ijchart.xychart.axis.value.StackedXYValueAxis ;
import com.ijchart.xychart.axis.value.StatisticalNumberValueAxis ;
import com.ijchart.xychart.axis.value.SymbolValueAxis ;
import com.ijchart.xychart.axis.value.WaterfallNumberValueAxis ;
import com.ijchart.xychart.axis.value.WindValueAxis ;
import com.ijchart.xychart.axis.value.XYNumberValueAxis ;
import com.ijchart.xychart.axis.value.XYZNumberValueAxis ;
import com.ijchart.xychart.axis.value.YIntervalValueAxis ;
import com.ijchart.xychart.constant.AxisLabelType ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.constant.HorizontalAlignment ;
import com.ijchart.xychart.constant.IAngle ;
import com.ijchart.xychart.constant.TextDirection ;
import com.ijchart.xychart.constant.TextPosition ;
import com.ijchart.xychart.constant.VerticalAlignment ;
import com.ijchart.xychart.constant.XYValueAxisType ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.dataset.SingleRowDataset ;
import com.ijchart.xychart.plot.Category3DPlot ;
import com.ijchart.xychart.plot.CategoryPlot ;
import com.ijchart.xychart.plot.NoAxisPlot ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.render.category.AreaRender ;
import com.ijchart.xychart.render.category.Bar2DRender ;
import com.ijchart.xychart.render.category.Bar3DRender ;
import com.ijchart.xychart.render.category.BoxAndWhiskerRender ;
import com.ijchart.xychart.render.category.CylinderRender ;
import com.ijchart.xychart.render.category.GranttRender ;
import com.ijchart.xychart.render.category.GroupStackedBarRender ;
import com.ijchart.xychart.render.category.IntervalBarRender ;
import com.ijchart.xychart.render.category.LayeredBarRender ;
import com.ijchart.xychart.render.category.LevelRender ;
import com.ijchart.xychart.render.category.Line3DRender ;
import com.ijchart.xychart.render.category.LineAndShapeRender ;
import com.ijchart.xychart.render.category.MinMaxRender ;
import com.ijchart.xychart.render.category.StackedAreaRender ;
import com.ijchart.xychart.render.category.StackedBar3DRender ;
import com.ijchart.xychart.render.category.StackedBarRender ;
import com.ijchart.xychart.render.category.StatisticalBarRender ;
import com.ijchart.xychart.render.category.StatisticalLineRender ;
import com.ijchart.xychart.render.category.StepRender ;
import com.ijchart.xychart.render.category.WaterfallBarRender ;
import com.ijchart.xychart.render.noaxis.MeterRender ;
import com.ijchart.xychart.render.noaxis.PieRender ;
import com.ijchart.xychart.render.noaxis.PolarRender ;
import com.ijchart.xychart.render.noaxis.SpiderWebRender ;
import com.ijchart.xychart.render.xy.DeviationRender ;
import com.ijchart.xychart.render.xy.HighLowRender ;
import com.ijchart.xychart.render.xy.IntervalXNumberYBaseBar2DRender ;
import com.ijchart.xychart.render.xy.StockRender ;
import com.ijchart.xychart.render.xy.VectorRender ;
import com.ijchart.xychart.render.xy.WindRender ;
import com.ijchart.xychart.render.xy.XYAreaRender ;
import com.ijchart.xychart.render.xy.XYBlockRender ;
import com.ijchart.xychart.render.xy.XYBoxAndWhiskerRender ;
import com.ijchart.xychart.render.xy.XYBubbleRender ;
import com.ijchart.xychart.render.xy.XYClusteredBar2DRender ;
import com.ijchart.xychart.render.xy.XYDifferenceRender ;
import com.ijchart.xychart.render.xy.XYDotRender ;
import com.ijchart.xychart.render.xy.XYErrorRender ;
import com.ijchart.xychart.render.xy.XYIntervalBar2DRender ;
import com.ijchart.xychart.render.xy.XYLineAndShapeRender ;
import com.ijchart.xychart.render.xy.XYShapeRender ;
import com.ijchart.xychart.render.xy.XYStackedAreaRender ;
import com.ijchart.xychart.render.xy.XYStackedBarRender ;
import com.ijchart.xychart.render.xy.XYStackedStepAreaRender ;
import com.ijchart.xychart.render.xy.XYStepLineRender ;
import com.ijchart.xychart.render.xy.YIntervalRenderer ;
import com.ijchart.xychart.tickunit.LongTickUnit ;
import com.ijchart.xychart.tooltip.DefaultTooltipGenerator ;
import com.ijchart.xychart.ui.supplier.DefaultDrawingSupplier ;
import com.ijchart.xychart.util.DatasetUtil ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>ڴͼĹ,ڴChartʱʹô,ԼС,ʹ.</zh>
 * <en>A collection of utility methods for creating some standard charts with IJChart.</en>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public abstract class ChartFactory {
  /**
   * <zh>״ͼChart.ChartPlotΪ{@link CategoryPlot},XΪ{@link CategoryAxis},
   * YΪ{@link NumberValueAxis},RenderΪ{@link Bar2DRender},ݼеÿ
   * {@link com.ijchart.xychart.data.NumberChartData}.</zh>
   * <en>Creates a bar chart. The chart object returned by this method uses a
   * {@link CategoryPlot} instance as the plot, with a {@link CategoryAxis}
   * for the X axis, a {@link NumberValueAxis} as the Y axis, a
   * {@link Bar2DRender} as the render,and each data is
   * {@link com.ijchart.xychart.data.NumberChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param xAxisLabel String <zh>Xıǩ (Ϊnull).</zh>
   * <en>The label for the category axis (null permitted).</en>
   * @param yAxisLabel String <zh>Yıǩ (Ϊnull).</zh>
   * <en>The label for the value axis (null permitted).</en>
   * @param dataset IMatrixDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param orientation ChartOrientation <zh>ͼķ,ˮƽֱ (Ϊnull).</zh>
   * <en>The plot orientation (horizontal or vertical) (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createCategoryBar2DChart(String title, String xAxisLabel, String yAxisLabel,
                                                 IMatrixDataset dataset,
                                                 ChartOrientation orientation,
                                                 boolean legend, boolean tooltips) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }
    if (orientation == null) {
      throw new IllegalArgumentException("Null 'orientation' argument.") ;
    }

    CategoryAxis categoryAxis = new CategoryAxis(xAxisLabel, dataset) ;
    NumberValueAxis valueAxis = new NumberValueAxis(yAxisLabel, dataset) ;
    valueAxis.setValueLineVisible(true) ;

    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      categoryAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      valueAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    Bar2DRender render = new Bar2DRender(dataset) ;
    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    CategoryPlot plot = new CategoryPlot(categoryAxis, valueAxis, render) ;
    plot.setOrientation(orientation) ;

    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>3D״ͼChart.ChartPlotΪ{@link Category3DPlot},XΪ
   * {@link CategoryAxis3D},YΪ{@link NumberValueAxis3D},
   * RenderΪ{@link Bar3DRender},ݼеÿ
   * {@link com.ijchart.xychart.data.NumberChartData}.</zh>
   * <en>Creates a 3D bar chart. The chart object returned by this method uses a
   * {@link Category3DPlot} instance as the plot, with a {@link CategoryAxis3D}
   * for the X axis, a {@link NumberValueAxis3D} as the Y axis,a {@link Bar3DRender} as the render
   * ,and each data is {@link com.ijchart.xychart.data.NumberChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param xAxisLabel String <zh>Xıǩ (Ϊnull).</zh>
   * <en>The label for the category axis (null permitted).</en>
   * @param yAxisLabel String <zh>Yıǩ (Ϊnull).</zh>
   * <en>The label for the value axis (null permitted).</en>
   * @param dataset IMatrixDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param orientation ChartOrientation <zh>ͼķ,ˮƽֱ (Ϊnull).</zh>
   * <en>The plot orientation (horizontal or vertical) (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createCategoryBar3DChart(String title, String xAxisLabel, String yAxisLabel,
                                                 IMatrixDataset dataset,
                                                 ChartOrientation orientation,
                                                 boolean legend, boolean tooltips) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }
    if (orientation == null) {
      throw new IllegalArgumentException("Null 'orientation' argument.") ;
    }

    Category3DPlot plot = new Category3DPlot() ;
    CategoryAxis3D categoryAxis = new CategoryAxis3D(xAxisLabel, dataset, plot) ;
    NumberValueAxis3D valueAxis = new NumberValueAxis3D(yAxisLabel, dataset, plot) ;
    valueAxis.setValueLineVisible(true) ;

    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      categoryAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      valueAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    Bar3DRender render = new Bar3DRender(plot, dataset) ;
    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    plot.setCategoryAxis(categoryAxis) ;
    plot.setValueAxis(valueAxis) ;
    plot.setRender(render) ;
    plot.setOrientation(orientation) ;
    plot.setForegroundAlpha(0.75f) ;

    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>ԲChart.ChartPlotΪ{@link Category3DPlot},XΪ
   * {@link CategoryAxis3D},YΪ{@link NumberValueAxis3D},
   * RenderΪ{@link Bar3DRender},ݼеÿ
   * {@link com.ijchart.xychart.data.NumberChartData}.</zh>
   * <en>Creates a cylinder chart. The chart object returned by this method uses a
   * {@link Category3DPlot} instance as the plot, with a {@link CategoryAxis3D}
   * for the X axis, a {@link NumberValueAxis3D} as the Y axis, a
   * {@link Bar3DRender} as the render,and each data is
   * {@link com.ijchart.xychart.data.NumberChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param xAxisLabel String <zh>Xıǩ (Ϊnull).</zh>
   * <en>The label for the category axis (null permitted).</en>
   * @param yAxisLabel String <zh>Yıǩ (Ϊnull).</zh>
   * <en>The label for the value axis (null permitted).</en>
   * @param dataset IMatrixDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param orientation ChartOrientation <zh>ͼķ,ˮƽֱ (Ϊnull).</zh>
   * <en>The plot orientation (horizontal or vertical) (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createCylinderChart(String title, String xAxisLabel, String yAxisLabel,
                                            IMatrixDataset dataset, ChartOrientation orientation,
                                            boolean legend, boolean tooltips) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }
    if (orientation == null) {
      throw new IllegalArgumentException("Null 'orientation' argument.") ;
    }

    Category3DPlot plot = new Category3DPlot() ;
    CategoryAxis3D categoryAxis = new CategoryAxis3D(xAxisLabel, dataset, plot) ;
    NumberValueAxis3D valueAxis = new NumberValueAxis3D(yAxisLabel, dataset, plot) ;
    valueAxis.setValueLineVisible(true) ;

    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      categoryAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      valueAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    CylinderRender render = new CylinderRender(plot, dataset, orientation) ;
    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    plot.setCategoryAxis(categoryAxis) ;
    plot.setValueAxis(valueAxis) ;
    plot.setRender(render) ;
    plot.setOrientation(orientation) ;
    plot.setForegroundAlpha(0.75f) ;

    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>Interval()Chart.ChartPlotΪ{@link CategoryPlot},
   * XΪ{@link CategoryAxis},YΪ{@link IntervalValueAxis},
   * RenderΪ{@link IntervalBarRender},ݼеÿ
   * {@link com.ijchart.xychart.data.IntervalChartData}.</zh>
   * <en>Creates a interval bar chart.The chart object returned by this method uses a
   * {@link CategoryPlot} instance as the plot, with a {@link CategoryAxis}
   * for the X axis, a {@link IntervalValueAxis} as the Y axis, a
   * {@link IntervalBarRender} as the render,and each data is
   * {@link com.ijchart.xychart.data.IntervalChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param xAxisLabel String <zh>Xıǩ (Ϊnull).</zh>
   * <en>The label for the category axis (null permitted).</en>
   * @param yAxisLabel String <zh>Yıǩ (Ϊnull).</zh>
   * <en>The label for the value axis (null permitted).</en>
   * @param dataset IMatrixDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param orientation ChartOrientation <zh>ͼķ,ˮƽֱ (Ϊnull).</zh>
   * <en>The plot orientation (horizontal or vertical) (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createIntervalBarChart(String title, String xAxisLabel, String yAxisLabel,
                                               IMatrixDataset dataset, ChartOrientation orientation,
                                               boolean legend, boolean tooltips) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }
    if (orientation == null) {
      throw new IllegalArgumentException("Null 'orientation' argument.") ;
    }

    CategoryAxis categoryAxis = new CategoryAxis(xAxisLabel, dataset) ;
    IntervalValueAxis valueAxis = new IntervalValueAxis(yAxisLabel, dataset) ;

    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      categoryAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      valueAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    IntervalBarRender render = new IntervalBarRender(dataset) ;
    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    CategoryPlot plot = new CategoryPlot(categoryAxis, valueAxis, render) ;
    plot.setOrientation(orientation) ;

    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>Layered()Chart.ChartPlotΪ{@link CategoryPlot},
   * XΪ{@link CategoryAxis},YΪ{@link NumberValueAxis},
   * RenderΪ{@link LayeredBarRender},ݼеÿ
   * {@link com.ijchart.xychart.data.NumberChartData}.</zh>
   * <en>Creates a layered bar chart.The chart object returned by this method uses a
   * {@link CategoryPlot} instance as the plot, with a {@link CategoryAxis}
   * for the X axis, a {@link NumberValueAxis} as the Y axis, a
   * {@link LayeredBarRender} as the render,and each data is
   * {@link com.ijchart.xychart.data.NumberChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param xAxisLabel String <zh>Xıǩ (Ϊnull).</zh>
   * <en>The label for the category axis (null permitted).</en>
   * @param yAxisLabel String <zh>Yıǩ (Ϊnull).</zh>
   * <en>The label for the value axis (null permitted).</en>
   * @param dataset IMatrixDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param orientation ChartOrientation <zh>ͼķ,ˮƽֱ (Ϊnull).</zh>
   * <en>The plot orientation (horizontal or vertical) (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createLayeredBarChart(String title, String xAxisLabel, String yAxisLabel,
                                              IMatrixDataset dataset, ChartOrientation orientation,
                                              boolean legend, boolean tooltips) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }
    if (orientation == null) {
      throw new IllegalArgumentException("Null 'orientation' argument.") ;
    }

    CategoryAxis categoryAxis = new CategoryAxis(xAxisLabel, dataset) ;
    NumberValueAxis valueAxis = new NumberValueAxis(yAxisLabel, dataset) ;

    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      categoryAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      valueAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    LayeredBarRender render = new LayeredBarRender(dataset) ;
    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    CategoryPlot plot = new CategoryPlot(categoryAxis, valueAxis, render) ;
    plot.setOrientation(orientation) ;

    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>ջͼChart.ChartPlotΪ{@link CategoryPlot},XΪ{@link CategoryAxis},
   * YΪ{@link StackedNumberValueAxis},RenderΪ{@link StackedBarRender},ݼеÿ
   * {@link com.ijchart.xychart.data.NumberChartData}.</zh>
   * <en>Creates a stacked bar chart. The chart object returned by this method uses a
   * {@link CategoryPlot} instance as the plot, with a {@link CategoryAxis}
   * for the X axis, a {@link StackedNumberValueAxis} as the Y axis, and a
   * {@link StackedBarRender} as the render,and each data is
   * {@link com.ijchart.xychart.data.NumberChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param xAxisLabel String <zh>Xıǩ (Ϊnull).</zh>
   * <en>The label for the category axis (null permitted).</en>
   * @param yAxisLabel String <zh>Yıǩ (Ϊnull).</zh>
   * <en>The label for the value axis (null permitted).</en>
   * @param dataset IMatrixDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param orientation ChartOrientation <zh>ͼķ,ˮƽֱ (Ϊnull).</zh>
   * <en>The plot orientation (horizontal or vertical) (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createStackedBarChart(String title, String xAxisLabel, String yAxisLabel,
                                              IMatrixDataset dataset, ChartOrientation orientation,
                                              boolean legend, boolean tooltips) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }
    if (orientation == null) {
      throw new IllegalArgumentException("Null 'orientation' argument.") ;
    }

    CategoryAxis categoryAxis = new CategoryAxis(xAxisLabel, dataset) ;
    StackedBarRender render = new StackedBarRender(dataset) ;
    StackedNumberValueAxis valueAxis = new StackedNumberValueAxis(yAxisLabel, dataset, render) ;
    valueAxis.setValueLineVisible(true) ;

    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      categoryAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      valueAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    CategoryPlot plot = new CategoryPlot(categoryAxis, valueAxis, render) ;
    plot.setOrientation(orientation) ;

    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>ջͼChart.ChartPlotΪ{@link Category3DPlot},XΪ{@link CategoryAxis3D}
   * ,YΪ{@link Stacked3DNumberValueAxis},RenderΪ{@link StackedBar3DRender},ݼе
   * ÿ{@link com.ijchart.xychart.data.NumberChartData}.</zh>
   * <en>Creates a stacked bar chart. The chart object returned by this method uses a
   * {@link Category3DPlot} instance as the plot, with a {@link CategoryAxis3D}
   * for the X axis, a {@link Stacked3DNumberValueAxis} as the Y axis, and a
   * {@link StackedBar3DRender} as the render,and each data is
   * {@link com.ijchart.xychart.data.NumberChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param xAxisLabel String <zh>Xıǩ (Ϊnull).</zh>
   * <en>The label for the category axis (null permitted).</en>
   * @param yAxisLabel String <zh>Yıǩ (Ϊnull).</zh>
   * <en>The label for the value axis (null permitted).</en>
   * @param dataset IMatrixDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param orientation ChartOrientation <zh>ͼķ,ˮƽֱ (Ϊnull).</zh>
   * <en>The plot orientation (horizontal or vertical) (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createStackedBar3DChart(String title, String xAxisLabel, String yAxisLabel,
                                                IMatrixDataset dataset,
                                                ChartOrientation orientation,
                                                boolean legend, boolean tooltips) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }
    if (orientation == null) {
      throw new IllegalArgumentException("Null 'orientation' argument.") ;
    }

    Category3DPlot plot = new Category3DPlot() ;
    CategoryAxis3D categoryAxis = new CategoryAxis3D(xAxisLabel, dataset, plot) ;

    StackedBar3DRender render = new StackedBar3DRender(plot, dataset) ;
    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;
    Stacked3DNumberValueAxis valueAxis = new Stacked3DNumberValueAxis(yAxisLabel, dataset, render,
                                                                      plot) ;
    valueAxis.setValueLineVisible(true) ;

    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      categoryAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      valueAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    plot.setCategoryAxis(categoryAxis) ;
    plot.setValueAxis(valueAxis) ;
    plot.setRender(render) ;
    plot.setOrientation(orientation) ;

    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>ջͼChart.ChartPlotΪ{@link CategoryPlot},XΪ{@link GroupCategoryAxis}
   * ,YΪ{@link GroupStackedNumberValueAxis},RenderΪ{@link StackedBarRender},ݼ
   * ÿ{@link com.ijchart.xychart.data.group.NumberGroupChartData}.</zh>
   * <en>Creates a stacked bar chart. The chart object returned by this method uses a
   * {@link CategoryPlot} instance as the plot, with a {@link GroupCategoryAxis}
   * for the X axis, a {@link GroupStackedNumberValueAxis} as the Y axis, and a
   * {@link StackedBarRender} as the render,and each data is
   * {@link com.ijchart.xychart.data.group.NumberGroupChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param xAxisLabel String <zh>Xıǩ (Ϊnull).</zh>
   * <en>The label for the category axis (null permitted).</en>
   * @param yAxisLabel String <zh>Yıǩ (Ϊnull).</zh>
   * <en>The label for the value axis (null permitted).</en>
   * @param dataset IMatrixDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param orientation ChartOrientation <zh>ͼķ,ˮƽֱ (Ϊnull).</zh>
   * <en>The plot orientation (horizontal or vertical) (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createGroupStackedBarChart(String title, String xAxisLabel,
                                                   String yAxisLabel, IMatrixDataset dataset,
                                                   ChartOrientation orientation, boolean legend,
                                                   boolean tooltips) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }
    if (orientation == null) {
      throw new IllegalArgumentException("Null 'orientation' argument.") ;
    }

    GroupStackedBarRender render = new GroupStackedBarRender(dataset) ;
    GroupCategoryAxis categoryAxis = new GroupCategoryAxis(render, null, dataset) ;
    CategoryAxis subCategoryAxis = new CategoryAxis(xAxisLabel, dataset) ;
    subCategoryAxis.setTickMarkVisible(false) ;
    subCategoryAxis.setAxisLineVisible(false) ;
    categoryAxis.addSubCategoryAxis(subCategoryAxis) ;

    GroupStackedNumberValueAxis valueAxis = new GroupStackedNumberValueAxis(yAxisLabel, dataset,
                                                                            render) ;
    valueAxis.setValueLineVisible(true) ;

    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      categoryAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      valueAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    CategoryPlot plot = new CategoryPlot(categoryAxis, valueAxis, render) ;
    plot.setOrientation(orientation) ;

    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>Statistical() bar͵Chart.ChartPlotΪ{@link CategoryPlot},XΪ
   * {@link CategoryAxis},YΪ{@link StatisticalNumberValueAxis},RenderΪ
   * {@link StatisticalBarRender},ݼеÿ
   * {@link com.ijchart.xychart.data.StatisticalChartData}.</zh>
   * <en>Creates a Statistical bar chart. The chart object returned by this method uses a
   * {@link CategoryPlot} instance as the plot, with a {@link CategoryAxis}
   * for the X axis, a {@link StatisticalNumberValueAxis} as the Y axis, a
   * {@link StatisticalBarRender} as the render,and each data is
   * {@link com.ijchart.xychart.data.StatisticalChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param xAxisLabel String <zh>Xıǩ (Ϊnull).</zh>
   * <en>The label for the category axis (null permitted).</en>
   * @param yAxisLabel String <zh>Yıǩ (Ϊnull).</zh>
   * <en>The label for the value axis (null permitted).</en>
   * @param dataset IMatrixDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param orientation ChartOrientation <zh>ͼķ,ˮƽֱ (Ϊnull).</zh>
   * <en>The plot orientation (horizontal or vertical) (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createStaticalBarChart(String title, String xAxisLabel, String yAxisLabel,
                                               IMatrixDataset dataset, ChartOrientation orientation,
                                               boolean legend, boolean tooltips) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }
    if (orientation == null) {
      throw new IllegalArgumentException("Null 'orientation' argument.") ;
    }

    CategoryAxis categoryAxis = new CategoryAxis(xAxisLabel, dataset) ;
    StatisticalNumberValueAxis valueAxis = new StatisticalNumberValueAxis(yAxisLabel, dataset) ;
    valueAxis.setValueLineVisible(true) ;

    StatisticalBarRender render = new StatisticalBarRender(dataset) ;
    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      categoryAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
      render.setBaseItemLabelPosition(TextPosition.INSIDE) ;
      render.setBaseItemLabelVerticalAlignment(VerticalAlignment.CENTER) ;
      render.setBaseItemLabelHorizontalAlignment(HorizontalAlignment.CENTER) ;
      render.setBaseItemLabelDirection(TextDirection.VERTICAL) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      valueAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    CategoryPlot plot = new CategoryPlot(categoryAxis, valueAxis, render) ;
    plot.setOrientation(orientation) ;
    plot.setDrawingSupplier(new DefaultDrawingSupplier() {
      public Paint getNextBorderPaint() {
        return Color.BLACK ;
      }
    }) ;

    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>Statistical() line͵Chart.ChartPlotΪ{@link CategoryPlot},XΪ
   * {@link CategoryAxis},YΪ{@link StatisticalNumberValueAxis},RenderΪ
   * {@link StatisticalLineRender},ݼеÿ
   * {@link com.ijchart.xychart.data.StatisticalChartData}.</zh>
   * <en>Creates a Statistical line chart. The chart object returned by this method uses a
   * {@link CategoryPlot} instance as the plot, with a {@link CategoryAxis}
   * for the X axis, a {@link StatisticalNumberValueAxis} as the Y axis, a
   * {@link StatisticalLineRender} as the render,and each data is
   * {@link com.ijchart.xychart.data.StatisticalChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param xAxisLabel String <zh>Xıǩ (Ϊnull).</zh>
   * <en>The label for the category axis (null permitted).</en>
   * @param yAxisLabel String <zh>Yıǩ (Ϊnull).</zh>
   * <en>The label for the value axis (null permitted).</en>
   * @param dataset IMatrixDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param orientation ChartOrientation <zh>ͼķ,ˮƽֱ (Ϊnull).</zh>
   * <en>The plot orientation (horizontal or vertical) (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createStaticalLineChart(String title, String xAxisLabel, String yAxisLabel,
                                                IMatrixDataset dataset,
                                                ChartOrientation orientation,
                                                boolean legend, boolean tooltips) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }
    if (orientation == null) {
      throw new IllegalArgumentException("Null 'orientation' argument.") ;
    }

    CategoryAxis categoryAxis = new CategoryAxis(xAxisLabel, dataset) ;
    categoryAxis.setAxisLabelType(AxisLabelType.COLUMN) ;
    categoryAxis.setCategoryMargin(0) ;

    StatisticalNumberValueAxis valueAxis = new StatisticalNumberValueAxis(yAxisLabel, dataset) ;
    valueAxis.setValueLineVisible(true) ;

    StatisticalLineRender render = new StatisticalLineRender(dataset) ;
    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      categoryAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
      render.setBaseItemLabelPosition(TextPosition.OUTSIDE_LEFT) ;
      render.setBaseItemLabelVerticalAlignment(VerticalAlignment.CENTER) ;
      render.setBaseItemLabelHorizontalAlignment(HorizontalAlignment.CENTER) ;
      render.setBaseItemLabelDirection(TextDirection.VERTICAL) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      valueAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    CategoryPlot plot = new CategoryPlot(categoryAxis, valueAxis, render) ;
    plot.setOrientation(orientation) ;

    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>ٲ͵Chart.ChartPlotΪ{@link CategoryPlot},XΪ
   * {@link CategoryAxis},YΪ{@link WaterfallNumberValueAxis},RenderΪ
   * {@link WaterfallBarRender},ݼеÿ
   * {@link com.ijchart.xychart.data.NumberChartData}.</zh>
   * <en>Creates a waterfall bar chart. The chart object returned by this method uses a
   * {@link CategoryPlot} instance as the plot, with a {@link CategoryAxis}
   * for the X axis, a {@link WaterfallNumberValueAxis} as the Y axis, a
   * {@link WaterfallBarRender} as the render,and each data is
   * {@link com.ijchart.xychart.data.NumberChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param xAxisLabel String <zh>Xıǩ (Ϊnull).</zh>
   * <en>The label for the category axis (null permitted).</en>
   * @param yAxisLabel String <zh>Yıǩ (Ϊnull).</zh>
   * <en>The label for the value axis (null permitted).</en>
   * @param dataset IMatrixDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param orientation ChartOrientation <zh>ͼķ,ˮƽֱ (Ϊnull).</zh>
   * <en>The plot orientation (horizontal or vertical) (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createWaterfallBarChart(String title, String xAxisLabel, String yAxisLabel,
                                                IMatrixDataset dataset,
                                                ChartOrientation orientation, boolean legend,
                                                boolean tooltips) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }
    if (orientation == null) {
      throw new IllegalArgumentException("Null 'orientation' argument.") ;
    }

    CategoryAxis categoryAxis = new CategoryAxis(xAxisLabel, dataset) ;
    categoryAxis.setAxisLabelType(AxisLabelType.COLUMN) ;
    WaterfallNumberValueAxis valueAxis = new WaterfallNumberValueAxis(yAxisLabel, dataset) ;
    valueAxis.setValueLineVisible(true) ;

    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      categoryAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      valueAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    WaterfallBarRender render = new WaterfallBarRender(dataset) ;
    render.setBaseItemBorderPaint(Color.BLACK) ;
    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    CategoryPlot plot = new CategoryPlot(categoryAxis, valueAxis, render) ;
    plot.setOrientation(orientation) ;

    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>״ͼChart.ChartPlotΪ{@link CategoryPlot},XΪ{@link CategoryAxis},
   * YΪ{@link NumberValueAxis},RenderΪ{@link AreaRender},ݼеÿ
   * {@link com.ijchart.xychart.data.NumberChartData}.</zh>
   * <en>Creates a bar chart. The chart object returned by this method uses a
   * {@link CategoryPlot} instance as the plot, with a {@link CategoryAxis}
   * for the X axis, a {@link NumberValueAxis} as the Y axis, a
   * {@link AreaRender} as the render,and each data is
   * {@link com.ijchart.xychart.data.NumberChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param xAxisLabel String <zh>Xıǩ (Ϊnull).</zh>
   * <en>The label for the category axis (null permitted).</en>
   * @param yAxisLabel String <zh>Yıǩ (Ϊnull).</zh>
   * <en>The label for the value axis (null permitted).</en>
   * @param dataset IMatrixDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param orientation ChartOrientation <zh>ͼķ,ˮƽֱ (Ϊnull).</zh>
   * <en>The plot orientation (horizontal or vertical) (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createAreaChart(String title, String xAxisLabel, String yAxisLabel,
                                        IMatrixDataset dataset, ChartOrientation orientation,
                                        boolean legend, boolean tooltips) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }
    if (orientation == null) {
      throw new IllegalArgumentException("Null 'orientation' argument.") ;
    }

    CategoryAxis categoryAxis = new CategoryAxis(xAxisLabel, dataset) ;
    categoryAxis.setAxisLabelType(AxisLabelType.COLUMN) ;
    categoryAxis.setCategoryMargin(0) ;
    categoryAxis.setLowerMargin(0) ;
    categoryAxis.setUpperMargin(0) ;

    NumberValueAxis valueAxis = new NumberValueAxis(yAxisLabel, dataset) ;
    valueAxis.setValueLineVisible(true) ;
    valueAxis.setLowerMargin(0.0) ;
    valueAxis.setUpperMargin(0.0) ;

    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      categoryAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      valueAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    AreaRender render = new AreaRender(dataset) ;
    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    CategoryPlot plot = new CategoryPlot(categoryAxis, valueAxis, render) ;
    plot.setOrientation(orientation) ;
    plot.setForegroundAlpha(0.8F) ;

    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>category͵BoxAndWhisker()ͼChart.ChartPlotΪ{@link CategoryPlot},
   * XΪ{@link CategoryAxis},YΪ{@link BoxAndWhiskerValueAxis},RenderΪ
   * {@link BoxAndWhiskerRender},ݼеÿ
   * {@link com.ijchart.xychart.data.BoxAndWhiskerData}.</zh>
   * <en>Creates a category BoxAndWhisker chart. The chart object returned by this method uses a
   * {@link CategoryPlot} instance as the plot, with a {@link CategoryAxis}
   * for the X axis, a {@link BoxAndWhiskerValueAxis} as the Y axis, a
   * {@link BoxAndWhiskerRender} as the render,and each data is
   * {@link com.ijchart.xychart.data.BoxAndWhiskerData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param xAxisLabel String <zh>Xıǩ (Ϊnull).</zh>
   * <en>The label for the category axis (null permitted).</en>
   * @param yAxisLabel String <zh>Yıǩ (Ϊnull).</zh>
   * <en>The label for the value axis (null permitted).</en>
   * @param dataset IMatrixDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param orientation ChartOrientation <zh>ͼķ,ˮƽֱ (Ϊnull).</zh>
   * <en>The plot orientation (horizontal or vertical) (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createCategoryBoxAndWhiskerChart(String title, String xAxisLabel,
                                                         String yAxisLabel, IMatrixDataset dataset,
                                                         ChartOrientation orientation,
                                                         boolean legend, boolean tooltips) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }
    if (orientation == null) {
      throw new IllegalArgumentException("Null 'orientation' argument.") ;
    }

    CategoryAxis categoryAxis = new CategoryAxis(xAxisLabel, dataset) ;
    BoxAndWhiskerValueAxis valueAxis = new BoxAndWhiskerValueAxis(yAxisLabel, dataset,
                                                                  XYValueAxisType.XY_VALUE_AXIS_Y) ;
    valueAxis.setValueLineVisible(true) ;

    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      categoryAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      valueAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    BoxAndWhiskerRender render = new BoxAndWhiskerRender(dataset) ;
    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    CategoryPlot plot = new CategoryPlot(categoryAxis, valueAxis, render) ;
    plot.setOrientation(orientation) ;

    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>IntervalX BoxAndWhisker()ͼChart.ChartPlotΪ{@link CategoryPlot},XΪ
   * {@link CategoryAxis},YΪ{@link BoxAndWhiskerValueAxis},RenderΪ
   * {@link BoxAndWhiskerRender},ݼеÿ
   * {@link com.ijchart.xychart.data.BoxAndWhiskerData}.</zh>
   * <en>Creates a Interval X BoxAndWhisker chart. The chart object returned by this method uses a
   * {@link CategoryPlot} instance as the plot, with a {@link CategoryAxis}
   * for the X axis, a {@link BoxAndWhiskerValueAxis} as the Y axis, a
   * {@link BoxAndWhiskerRender} as the render,and each data is
   * {@link com.ijchart.xychart.data.BoxAndWhiskerData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param xAxisLabel String <zh>Xıǩ (Ϊnull).</zh>
   * <en>The label for the category axis (null permitted).</en>
   * @param yAxisLabel String <zh>Yıǩ (Ϊnull).</zh>
   * <en>The label for the value axis (null permitted).</en>
   * @param dataset SingleRowDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param orientation ChartOrientation <zh>ͼķ,ˮƽֱ (Ϊnull).</zh>
   * <en>The plot orientation (horizontal or vertical) (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   * @param isXAxisDate boolean <zh>Ƿx.</zh>
   * <en>Whether or not x-axis is date.</en>
   * @param isYAxisDate boolean <zh>Ƿy.</zh>
   * <en>Whether or not y-axis is date.</en>

   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createXYBoxAndWhiskerChart(String title, String xAxisLabel,
                                                   String yAxisLabel, SingleRowDataset dataset,
                                                   ChartOrientation orientation,
                                                   boolean legend, boolean tooltips,
                                                   boolean isXAxisDate, boolean isYAxisDate) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }
    if (orientation == null) {
      throw new IllegalArgumentException("Null 'orientation' argument.") ;
    }

    BoxAndWhiskerValueAxis xAxis =
      new BoxAndWhiskerValueAxis(xAxisLabel, dataset, XYValueAxisType.XY_VALUE_AXIS_X, isXAxisDate) ;
    BoxAndWhiskerValueAxis yAxis =
      new BoxAndWhiskerValueAxis(yAxisLabel, dataset, XYValueAxisType.XY_VALUE_AXIS_Y, isYAxisDate) ;
    yAxis.setValueLineVisible(true) ;

    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      xAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      yAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    XYBoxAndWhiskerRender render = new XYBoxAndWhiskerRender(dataset) ;
    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    XYPlot plot = new XYPlot(xAxis, yAxis, render) ;
    plot.setOrientation(orientation) ;

    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>ͼ(Category Step) Chart.ChartPlotΪ{@link CategoryPlot},XΪ
   * {@link CategoryAxis},YΪ{@link NumberValueAxis},RenderΪ
   * {@link StepRender},ݼеÿ{@link com.ijchart.xychart.data.NumberChartData}
   * .</zh>
   * <en>Creates a Category Step chart. The chart object returned by this method uses a
   * {@link CategoryPlot} instance as the plot, with a {@link CategoryAxis}
   * for the X axis, a {@link NumberValueAxis} as the Y axis, a
   * {@link StepRender} as the render,and each data is
   * {@link com.ijchart.xychart.data.NumberChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param xAxisLabel String <zh>Xıǩ (Ϊnull).</zh>
   * <en>The label for the category axis (null permitted).</en>
   * @param yAxisLabel String <zh>Yıǩ (Ϊnull).</zh>
   * <en>The label for the value axis (null permitted).</en>
   * @param dataset IMatrixDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param orientation ChartOrientation <zh>ͼķ,ˮƽֱ (Ϊnull).</zh>
   * <en>The plot orientation (horizontal or vertical) (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createCategoryStepChart(String title, String xAxisLabel, String yAxisLabel,
                                                IMatrixDataset dataset,
                                                ChartOrientation orientation, boolean legend,
                                                boolean tooltips) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }
    if (orientation == null) {
      throw new IllegalArgumentException("Null 'orientation' argument.") ;
    }

    CategoryAxis categoryAxis = new CategoryAxis(xAxisLabel, dataset) ;
    categoryAxis.setLowerMargin(0.0) ;
    categoryAxis.setUpperMargin(0.0) ;
    categoryAxis.setAxisLabelType(AxisLabelType.COLUMN) ;
    NumberValueAxis valueAxis = new NumberValueAxis(yAxisLabel, dataset) ;
    valueAxis.setValueLineVisible(true) ;
    categoryAxis.setLowerMargin(0.0) ;
    categoryAxis.setUpperMargin(0.0) ;

    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      categoryAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      valueAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    StepRender render = new StepRender(dataset) ;
    render.setAutoSelectBorderPaint(true) ;
    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    CategoryPlot plot = new CategoryPlot(categoryAxis, valueAxis, render) ;
    plot.setOrientation(orientation) ;

    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>ͼ(Grantt) Chart.ChartPlotΪ{@link CategoryPlot},XΪ
   * {@link CategoryAxis},YΪ{@link GranttValueAxis},RenderΪ
   * {@link GranttRender},ݼеÿ{@link com.ijchart.xychart.data.GranttChartData}
   * .</zh>
   * <en>Creates a grantt chart. The chart object returned by this method uses a
   * {@link CategoryPlot} instance as the plot, with a {@link CategoryAxis}
   * for the X axis, a {@link GranttValueAxis} as the Y axis, a
   * {@link GranttRender} as the render,and each data is
   * {@link com.ijchart.xychart.data.GranttChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param xAxisLabel String <zh>Xıǩ (Ϊnull).</zh>
   * <en>The label for the category axis (null permitted).</en>
   * @param yAxisLabel String <zh>Yıǩ (Ϊnull).</zh>
   * <en>The label for the value axis (null permitted).</en>
   * @param dataset IMatrixDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param orientation ChartOrientation <zh>ͼķ,ˮƽֱ (Ϊnull).</zh>
   * <en>The plot orientation (horizontal or vertical) (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createGranttChart(String title, String xAxisLabel, String yAxisLabel,
                                          IMatrixDataset dataset, ChartOrientation orientation,
                                          boolean legend, boolean tooltips) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }
    if (orientation == null) {
      throw new IllegalArgumentException("Null 'orientation' argument.") ;
    }

    CategoryAxis categoryAxis = new CategoryAxis(xAxisLabel, dataset) ;
    categoryAxis.setLowerMargin(0.0) ;
    categoryAxis.setUpperMargin(0.0) ;
    GranttValueAxis valueAxis = new GranttValueAxis(yAxisLabel, dataset) ;
    valueAxis.setValueLineVisible(true) ;
    valueAxis.setLowerMargin(0.0) ;
    valueAxis.setUpperMargin(0.0) ;

    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      categoryAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      valueAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    GranttRender render = new GranttRender(dataset) ;
    render.setAutoSelectBorderPaint(true) ;
    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    CategoryPlot plot = new CategoryPlot(categoryAxis, valueAxis, render) ;
    plot.setOrientation(orientation) ;

    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>LevelͼChart.ChartPlotΪ{@link CategoryPlot},XΪ{@link CategoryAxis}
   * ,YΪ{@link NumberValueAxis},RenderΪ{@link LevelRender},ݼеÿ
   * {@link com.ijchart.xychart.data.NumberChartData}.</zh>
   * <en>Creates a level chart. The chart object returned by this method uses a
   * {@link CategoryPlot} instance as the plot, with a {@link CategoryAxis}
   * for the X axis, a {@link NumberValueAxis} as the Y axis, a
   * {@link LevelRender} as the render,and each data is
   * {@link com.ijchart.xychart.data.NumberChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param xAxisLabel String <zh>Xıǩ (Ϊnull).</zh>
   * <en>The label for the category axis (null permitted).</en>
   * @param yAxisLabel String <zh>Yıǩ (Ϊnull).</zh>
   * <en>The label for the value axis (null permitted).</en>
   * @param dataset IMatrixDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param orientation ChartOrientation <zh>ͼķ,ˮƽֱ (Ϊnull).</zh>
   * <en>The plot orientation (horizontal or vertical) (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createCategoryLevelChart(String title, String xAxisLabel, String yAxisLabel,
                                                 IMatrixDataset dataset,
                                                 ChartOrientation orientation,
                                                 boolean legend, boolean tooltips) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }
    if (orientation == null) {
      throw new IllegalArgumentException("Null 'orientation' argument.") ;
    }

    CategoryAxis categoryAxis = new CategoryAxis(xAxisLabel, dataset) ;
    NumberValueAxis valueAxis = new NumberValueAxis(yAxisLabel, dataset) ;
    valueAxis.setValueLineVisible(true) ;

    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      categoryAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      valueAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    LevelRender render = new LevelRender(dataset) ;
    render.setAutoSelectBorderPaint(true) ;
    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    CategoryPlot plot = new CategoryPlot(categoryAxis, valueAxis, render) ;
    plot.setOrientation(orientation) ;

    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>ͼChart.ChartPlotΪ{@link CategoryPlot},XΪ{@link CategoryAxis}
   * ,YΪ{@link NumberValueAxis},RenderΪ{@link LineAndShapeRender},ݼеÿ
   * {@link com.ijchart.xychart.data.NumberChartData}.</zh>
   * <en>Creates a category line chart. The chart object returned by this method uses a
   * {@link CategoryPlot} instance as the plot, with a {@link CategoryAxis}
   * for the X axis, a {@link NumberValueAxis} as the Y axis, a
   * {@link LineAndShapeRender} as the render,and each data is
   * {@link com.ijchart.xychart.data.NumberChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param xAxisLabel String <zh>Xıǩ (Ϊnull).</zh>
   * <en>The label for the category axis (null permitted).</en>
   * @param yAxisLabel String <zh>Yıǩ (Ϊnull).</zh>
   * <en>The label for the value axis (null permitted).</en>
   * @param dataset IMatrixDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param orientation ChartOrientation <zh>ͼķ,ˮƽֱ (Ϊnull).</zh>
   * <en>The plot orientation (horizontal or vertical) (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createCategoryLineAndShapeChart(String title, String xAxisLabel,
                                                        String yAxisLabel, IMatrixDataset dataset,
                                                        ChartOrientation orientation,
                                                        boolean legend, boolean tooltips) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }
    if (orientation == null) {
      throw new IllegalArgumentException("Null 'orientation' argument.") ;
    }

    CategoryAxis categoryAxis = new CategoryAxis(xAxisLabel, dataset) ;
    categoryAxis.setAxisLabelType(AxisLabelType.COLUMN) ;
    NumberValueAxis valueAxis = new NumberValueAxis(yAxisLabel, dataset) ;
    valueAxis.setValueLineVisible(true) ;

    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      categoryAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      valueAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    LineAndShapeRender render = new LineAndShapeRender(dataset) ;
    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    CategoryPlot plot = new CategoryPlot(categoryAxis, valueAxis, render) ;
    plot.setOrientation(orientation) ;

    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>СֵֵͼChart.ChartPlotΪ{@link CategoryPlot},XΪ
   * {@link CategoryAxis},YΪ{@link NumberValueAxis},RenderΪ
   * {@link MinMaxRender},ݼеÿ
   * {@link com.ijchart.xychart.data.NumberChartData}.</zh>
   * <en>Creates a min-max shape chart. The chart object returned by this method uses a
   * {@link CategoryPlot} instance as the plot, with a {@link CategoryAxis}
   * for the X axis, a {@link NumberValueAxis} as the Y axis, a
   * {@link MinMaxRender} as the render,and each data is
   * {@link com.ijchart.xychart.data.NumberChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param xAxisLabel String <zh>Xıǩ (Ϊnull).</zh>
   * <en>The label for the category axis (null permitted).</en>
   * @param yAxisLabel String <zh>Yıǩ (Ϊnull).</zh>
   * <en>The label for the value axis (null permitted).</en>
   * @param dataset IMatrixDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param orientation ChartOrientation <zh>ͼķ,ˮƽֱ (Ϊnull).</zh>
   * <en>The plot orientation (horizontal or vertical) (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createCategoryMinMaxChart(String title, String xAxisLabel,
                                                  String yAxisLabel, IMatrixDataset dataset,
                                                  ChartOrientation orientation, boolean legend,
                                                  boolean tooltips) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }
    if (orientation == null) {
      throw new IllegalArgumentException("Null 'orientation' argument.") ;
    }

    CategoryAxis categoryAxis = new CategoryAxis(xAxisLabel, dataset) ;
    categoryAxis.setAxisLabelType(AxisLabelType.COLUMN) ;
    NumberValueAxis valueAxis = new NumberValueAxis(yAxisLabel, dataset) ;
    valueAxis.setValueLineVisible(true) ;
    valueAxis.setUpperMargin(0.03) ;

    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      categoryAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      valueAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    MinMaxRender render = new MinMaxRender(dataset) ;
    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    CategoryPlot plot = new CategoryPlot(categoryAxis, valueAxis, render) ;
    plot.setOrientation(orientation) ;

    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>XYͼChart.ChartPlotΪ{@link XYPlot},XΪ
   * {@link XYNumberValueAxis},YΪ{@link XYNumberValueAxis},RenderΪ
   * {@link XYLineAndShapeRender},ݼеÿ
   * {@link com.ijchart.xychart.data.XYNumberChartData}.</zh>
   * <en>Creates a XY line chart. The chart object returned by this method uses a
   * {@link XYPlot} instance as the plot, with a {@link XYNumberValueAxis}
   * for the X axis, a {@link XYNumberValueAxis} as the Y axis, a
   * {@link XYLineAndShapeRender} as the render,and each data is
   * {@link com.ijchart.xychart.data.XYNumberChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param xAxisLabel String <zh>Xıǩ (Ϊnull).</zh>
   * <en>The label for the category axis (null permitted).</en>
   * @param yAxisLabel String <zh>Yıǩ (Ϊnull).</zh>
   * <en>The label for the value axis (null permitted).</en>
   * @param dataset IMatrixDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param orientation ChartOrientation <zh>ͼķ,ˮƽֱ (Ϊnull).</zh>
   * <en>The plot orientation (horizontal or vertical) (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   * @param isXAxisDate boolean <zh>Ƿx.</zh>
   * <en>Whether or not x-axis is date.</en>
   * @param isYAxisDate boolean <zh>Ƿy.</zh>
   * <en>Whether or not y-axis is date.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createXYLineAndShapeChart(String title, String xAxisLabel,
                                                  String yAxisLabel, IMatrixDataset dataset,
                                                  ChartOrientation orientation, boolean legend,
                                                  boolean tooltips,
                                                  boolean isXAxisDate, boolean isYAxisDate) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }
    if (orientation == null) {
      throw new IllegalArgumentException("Null 'orientation' argument.") ;
    }

    XYNumberValueAxis xAxis = new XYNumberValueAxis(xAxisLabel, dataset,
                                                    XYValueAxisType.XY_VALUE_AXIS_X, isXAxisDate) ;
    xAxis.setAxisLabelType(AxisLabelType.COLUMN) ;
    xAxis.setAxisRangeIncludeZero(false) ;
    XYNumberValueAxis yAxis = new XYNumberValueAxis(yAxisLabel, dataset,
                                                    XYValueAxisType.XY_VALUE_AXIS_Y, isYAxisDate) ;
    yAxis.setValueLineVisible(true) ;
    yAxis.setAxisRangeIncludeZero(false) ;

    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      xAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      yAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    XYLineAndShapeRender render = new XYLineAndShapeRender(dataset) ;
    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    XYPlot plot = new XYPlot(xAxis, yAxis, render) ;
    plot.setOrientation(orientation) ;

    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>XYͼChart.ChartPlotΪ{@link XYPlot},XΪ
   * {@link XYNumberValueAxis},YΪ{@link XYNumberValueAxis},RenderΪ
   * {@link XYStepLineRender},ݼеÿ
   * {@link com.ijchart.xychart.data.XYNumberChartData}.</zh>
   * <en>Creates a XY line chart. The chart object returned by this method uses a
   * {@link XYPlot} instance as the plot, with a {@link XYNumberValueAxis}
   * for the X axis, a {@link XYNumberValueAxis} as the Y axis, a
   * {@link XYStepLineRender} as the render,and each data is
   * {@link com.ijchart.xychart.data.XYNumberChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param xAxisLabel String <zh>Xıǩ (Ϊnull).</zh>
   * <en>The label for the category axis (null permitted).</en>
   * @param yAxisLabel String <zh>Yıǩ (Ϊnull).</zh>
   * <en>The label for the value axis (null permitted).</en>
   * @param dataset IMatrixDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param orientation ChartOrientation <zh>ͼķ,ˮƽֱ (Ϊnull).</zh>
   * <en>The plot orientation (horizontal or vertical) (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   * @param isXAxisDate boolean <zh>Ƿx.</zh>
   * <en>Whether or not x-axis is date.</en>
   * @param isYAxisDate boolean <zh>Ƿy.</zh>
   * <en>Whether or not y-axis is date.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createXYStepLineChart(String title, String xAxisLabel, String yAxisLabel,
                                              IMatrixDataset dataset, ChartOrientation orientation,
                                              boolean legend, boolean tooltips,
                                              boolean isXAxisDate, boolean isYAxisDate) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }
    if (orientation == null) {
      throw new IllegalArgumentException("Null 'orientation' argument.") ;
    }

    XYNumberValueAxis xAxis = new XYNumberValueAxis(xAxisLabel, dataset,
                                                    XYValueAxisType.XY_VALUE_AXIS_X, isXAxisDate) ;
    xAxis.setAxisLabelType(AxisLabelType.COLUMN) ;
    XYNumberValueAxis yAxis = new XYNumberValueAxis(yAxisLabel, dataset,
                                                    XYValueAxisType.XY_VALUE_AXIS_Y, isYAxisDate) ;
    yAxis.setValueLineVisible(true) ;

    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      xAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      yAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    XYStepLineRender render = new XYStepLineRender(dataset) ;
    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    XYPlot plot = new XYPlot(xAxis, yAxis, render) ;
    plot.setOrientation(orientation) ;

    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>״ͼChart.ChartPlotΪ{@link XYPlot},XΪ
   * {@link IntervalXYValueAxis},YΪ{@link IntervalXYValueAxis},RenderΪ
   * {@link XYIntervalBar2DRender},ݼеÿ
   * {@link com.ijchart.xychart.data.IntervalXYNumberChartData}.</zh>
   * <en>Creates a interval bar chart. The chart object returned by this method uses a
   * {@link XYPlot} instance as the plot, with a {@link IntervalXYValueAxis}
   * for the X axis, a {@link IntervalXYValueAxis} as the Y axis, a
   * {@link XYIntervalBar2DRender} as the render,and each data is
   * {@link com.ijchart.xychart.data.IntervalXYNumberChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param xAxisLabel String <zh>Xıǩ (Ϊnull).</zh>
   * <en>The label for the category axis (null permitted).</en>
   * @param yAxisLabel String <zh>Yıǩ (Ϊnull).</zh>
   * <en>The label for the value axis (null permitted).</en>
   * @param dataset IMatrixDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param orientation ChartOrientation <zh>ͼķ,ˮƽֱ (Ϊnull).</zh>
   * <en>The plot orientation (horizontal or vertical) (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   * @param isXAxisDate boolean <zh>Ƿx.</zh>
   * <en>Whether or not x-axis is date.</en>
   * @param isYAxisDate boolean <zh>Ƿy.</zh>
   * <en>Whether or not y-axis is date.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createIntervalXYBar2DChart(String title, String xAxisLabel,
                                                   String yAxisLabel, IMatrixDataset dataset,
                                                   ChartOrientation orientation,
                                                   boolean legend, boolean tooltips,
                                                   boolean isXAxisDate, boolean isYAxisDate) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }
    if (orientation == null) {
      throw new IllegalArgumentException("Null 'orientation' argument.") ;
    }

    XYIntervalBar2DRender render = new XYIntervalBar2DRender(dataset) ;
    IntervalXYValueAxis xAxis = new IntervalXYValueAxis(xAxisLabel, dataset,
                                                        XYValueAxisType.XY_VALUE_AXIS_X,
                                                        isXAxisDate) ;
    xAxis.setAxisLabelType(AxisLabelType.COLUMN) ;
    xAxis.setRender(render) ;
    IntervalXYValueAxis yAxis = new IntervalXYValueAxis(yAxisLabel, dataset,
                                                        XYValueAxisType.XY_VALUE_AXIS_Y,
                                                        isYAxisDate) ;
    yAxis.setValueLineVisible(true) ;

    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      xAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      yAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    XYPlot plot = new XYPlot(xAxis, yAxis, render) ;
    plot.setOrientation(orientation) ;

    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>״ͼChart.ChartPlotΪ{@link XYPlot},XΪ
   * {@link IntervalXNumberYBaseValueAxis},YΪ{@link IntervalXNumberYBaseValueAxis},
   * RenderΪ{@link IntervalXNumberYBaseBar2DRender},ݼеÿ
   * {@link com.ijchart.xychart.data.IntervalXNumberYBaseChartData}.</zh>
   * <en>Creates a interval bar chart. The chart object returned by this method uses a
   * {@link XYPlot} instance as the plot, with a {@link IntervalXNumberYBaseValueAxis}
   * for the X axis, a {@link IntervalXNumberYBaseValueAxis} as the Y axis, a
   * {@link IntervalXNumberYBaseBar2DRender} as the render,and each data is
   * {@link com.ijchart.xychart.data.IntervalXNumberYBaseChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param xAxisLabel String <zh>Xıǩ (Ϊnull).</zh>
   * <en>The label for the category axis (null permitted).</en>
   * @param yAxisLabel String <zh>Yıǩ (Ϊnull).</zh>
   * <en>The label for the value axis (null permitted).</en>
   * @param dataset IMatrixDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param orientation ChartOrientation <zh>ͼķ,ˮƽֱ (Ϊnull).</zh>
   * <en>The plot orientation (horizontal or vertical) (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   * @param isXAxisDate boolean <zh>Ƿx.</zh>
   * <en>Whether or not x-axis is date.</en>
   * @param isYAxisDate boolean <zh>Ƿy.</zh>
   * <en>Whether or not y-axis is date.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createIntervalXBaseYBar2DChart(String title, String xAxisLabel,
                                                       String yAxisLabel, IMatrixDataset dataset,
                                                       ChartOrientation orientation,
                                                       boolean legend, boolean tooltips,
                                                       boolean isXAxisDate, boolean isYAxisDate) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }
    if (orientation == null) {
      throw new IllegalArgumentException("Null 'orientation' argument.") ;
    }

    IntervalXNumberYBaseValueAxis xAxis =
      new IntervalXNumberYBaseValueAxis(xAxisLabel, dataset, XYValueAxisType.XY_VALUE_AXIS_X,
                                        isXAxisDate) ;
    xAxis.setAxisLabelType(AxisLabelType.COLUMN) ;
    IntervalXNumberYBaseValueAxis yAxis =
      new IntervalXNumberYBaseValueAxis(yAxisLabel, dataset, XYValueAxisType.XY_VALUE_AXIS_Y,
                                        isYAxisDate) ;
    yAxis.setValueLineVisible(true) ;

    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      xAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      yAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    IntervalXNumberYBaseBar2DRender render = new IntervalXNumberYBaseBar2DRender(dataset) ;
    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    XYPlot plot = new XYPlot(xAxis, yAxis, render) ;
    plot.setOrientation(orientation) ;

    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>Ⱥ״ͼChart.ChartPlotΪ{@link XYPlot},XΪ
   * {@link IntervalXYValueAxis},YΪ{@link IntervalXYValueAxis},RenderΪ
   * {@link XYClusteredBar2DRender},ݼеÿ
   * {@link com.ijchart.xychart.data.IntervalXYNumberChartData}.</zh>
   * <en>Creates a Clustered bar chart. The chart object returned by this method uses a
   * {@link XYPlot} instance as the plot, with a {@link IntervalXYValueAxis}
   * for the X axis, a {@link IntervalXYValueAxis} as the Y axis, a
   * {@link XYClusteredBar2DRender} as the render,and each data is
   * {@link com.ijchart.xychart.data.IntervalXYNumberChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param xAxisLabel String <zh>Xıǩ (Ϊnull).</zh>
   * <en>The label for the category axis (null permitted).</en>
   * @param yAxisLabel String <zh>Yıǩ (Ϊnull).</zh>
   * <en>The label for the value axis (null permitted).</en>
   * @param dataset IMatrixDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param orientation ChartOrientation <zh>ͼķ,ˮƽֱ (Ϊnull).</zh>
   * <en>The plot orientation (horizontal or vertical) (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   * @param isXAxisDate boolean <zh>Ƿx.</zh>
   * <en>Whether or not x-axis is date.</en>
   * @param isYAxisDate boolean <zh>Ƿy.</zh>
   * <en>Whether or not y-axis is date.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createClusteredXYBar2DChart(String title, String xAxisLabel,
                                                    String yAxisLabel, IMatrixDataset dataset,
                                                    ChartOrientation orientation,
                                                    boolean legend, boolean tooltips,
                                                    boolean isXAxisDate, boolean isYAxisDate) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }
    if (orientation == null) {
      throw new IllegalArgumentException("Null 'orientation' argument.") ;
    }

    IntervalXYValueAxis xAxis = new IntervalXYValueAxis(xAxisLabel, dataset,
                                                        XYValueAxisType.XY_VALUE_AXIS_X,
                                                        isXAxisDate) ;
    xAxis.setAxisLabelType(AxisLabelType.COLUMN) ;
    xAxis.setLowerMargin(0.0) ;
    xAxis.setUpperMargin(0.0) ;

    IntervalXYValueAxis yAxis = new IntervalXYValueAxis(yAxisLabel, dataset,
                                                        XYValueAxisType.XY_VALUE_AXIS_Y,
                                                        isYAxisDate) ;
    yAxis.setValueLineVisible(true) ;

    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      xAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      yAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    XYClusteredBar2DRender render = new XYClusteredBar2DRender(dataset, true) ;
    xAxis.setRender(render) ;
    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    XYPlot plot = new XYPlot(xAxis, yAxis, render) ;
    plot.setOrientation(orientation) ;

    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>ͼChart.ChartPlotΪ{@link CategoryPlot},XΪ{@link CategoryAxis}
   * ,YΪ{@link SymbolValueAxis},RenderΪ{@link LineAndShapeRender},ݼеÿ
   * {@link com.ijchart.xychart.data.NumberChartData}.</zh>
   * <en>Creates a category line chart. The chart object returned by this method uses a
   * {@link CategoryPlot} instance as the plot, with a {@link CategoryAxis}
   * for the X axis, a {@link SymbolValueAxis} as the Y axis, a
   * {@link LineAndShapeRender} as the render,and each data is
   * {@link com.ijchart.xychart.data.NumberChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param xAxisLabel String <zh>Xıǩ (Ϊnull).</zh>
   * <en>The label for the category axis (null permitted).</en>
   * @param yAxisLabel String <zh>Yıǩ (Ϊnull).</zh>
   * <en>The label for the value axis (null permitted).</en>
   * @param dataset IMatrixDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param symbols String[] <zh> (Ϊnull).</zh>
   * <en>The symbols (null not permitted).</en>
   * @param orientation ChartOrientation <zh>ͼķ,ˮƽֱ (Ϊnull).</zh>
   * <en>The plot orientation (horizontal or vertical) (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createSymbolCategoryLineChart(String title, String xAxisLabel,
                                                      String yAxisLabel, IMatrixDataset dataset,
                                                      String[] symbols,
                                                      ChartOrientation orientation, boolean legend,
                                                      boolean tooltips) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }
    if (orientation == null) {
      throw new IllegalArgumentException("Null 'orientation' argument.") ;
    }
    if (symbols == null) {
      throw new IllegalArgumentException("Null 'symbols' argument.") ;
    }

    CategoryAxis categoryAxis = new CategoryAxis(xAxisLabel, dataset) ;
    categoryAxis.setAxisLabelType(AxisLabelType.COLUMN) ;
    NumberValueAxis valueAxis = new NumberValueAxis(yAxisLabel, dataset) ;
    SymbolValueAxis symbolValueAxis = new SymbolValueAxis(yAxisLabel, valueAxis, symbols) ;
    symbolValueAxis.setValueLineVisible(true) ;

    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      categoryAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      symbolValueAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    LineAndShapeRender render = new LineAndShapeRender(dataset) ;
    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    CategoryPlot plot = new CategoryPlot(categoryAxis, symbolValueAxis, render) ;
    plot.setOrientation(orientation) ;

    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>XYͼChart.ChartPlotΪ{@link XYPlot},XΪ
   * {@link XYNumberValueAxis}{@link SymbolValueAxis},YΪ{@link XYNumberValueAxis}
   * {@link SymbolValueAxis},RenderΪ{@link XYLineAndShapeRender},ݼеÿ
   * {@link com.ijchart.xychart.data.XYNumberChartData}.</zh>
   * <en>Creates a XY line chart. The chart object returned by this method uses a
   * {@link XYPlot} instance as the plot, with a {@link XYNumberValueAxis} or
   * {@link SymbolValueAxis} for the X axis, a {@link XYNumberValueAxis} or
   *  {@link SymbolValueAxis} as the Y axis, a {@link XYLineAndShapeRender} as the render,
   * and each data is {@link com.ijchart.xychart.data.XYNumberChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param xAxisLabel String <zh>Xıǩ (Ϊnull).</zh>
   * <en>The label for the category axis (null permitted).</en>
   * @param yAxisLabel String <zh>Yıǩ (Ϊnull).</zh>
   * <en>The label for the value axis (null permitted).</en>
   * @param dataset IMatrixDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param symbols String[] <zh> (Ϊnull).</zh>
   * <en>The symbols (null not permitted).</en>
   * @param symbolValueAxisType XYValueAxisType <zh>value (Ϊnull).</zh>
   * <en>The type of value axis (null not permitted).</en>
   * @param orientation ChartOrientation <zh>ͼķ,ˮƽֱ (Ϊnull).</zh>
   * <en>The plot orientation (horizontal or vertical) (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createSymbolXYLineChart(String title, String xAxisLabel, String yAxisLabel,
                                                IMatrixDataset dataset, String[] symbols,
                                                XYValueAxisType symbolValueAxisType,
                                                ChartOrientation orientation, boolean legend,
                                                boolean tooltips) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }
    if (symbols == null) {
      throw new IllegalArgumentException("Null 'symbols' argument.") ;
    }
    if (symbolValueAxisType == null) {
      throw new IllegalArgumentException("Null 'symbolValueAxisType' argument.") ;
    }
    if (orientation == null) {
      throw new IllegalArgumentException("Null 'orientation' argument.") ;
    }

    NumberValueAxis xAxis = null ;
    NumberValueAxis yAxis = null ;
    if (symbolValueAxisType.equals(XYValueAxisType.XY_VALUE_AXIS_X)) {
      XYNumberValueAxis valueAxis = new XYNumberValueAxis(xAxisLabel, dataset,
                                                          XYValueAxisType.XY_VALUE_AXIS_X) ;
      xAxis = new SymbolValueAxis(xAxisLabel, valueAxis, symbols) ;
      yAxis = new XYNumberValueAxis(yAxisLabel, dataset, XYValueAxisType.XY_VALUE_AXIS_Y, false) ;
    } else if (symbolValueAxisType.equals(XYValueAxisType.XY_VALUE_AXIS_Y)) {
      xAxis = new XYNumberValueAxis(xAxisLabel, dataset, XYValueAxisType.XY_VALUE_AXIS_X, false) ;
      XYNumberValueAxis valueAxis = new XYNumberValueAxis(yAxisLabel, dataset,
                                                          XYValueAxisType.XY_VALUE_AXIS_Y) ;
      yAxis = new SymbolValueAxis(xAxisLabel, valueAxis, symbols) ;
    } else {
      xAxis = new XYNumberValueAxis(xAxisLabel, dataset, XYValueAxisType.XY_VALUE_AXIS_X, false) ;
      yAxis = new XYNumberValueAxis(yAxisLabel, dataset, XYValueAxisType.XY_VALUE_AXIS_Y, false) ;
    }

    xAxis.setAxisLabelType(AxisLabelType.COLUMN) ;
    yAxis.setValueLineVisible(true) ;

    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      xAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      yAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    XYLineAndShapeRender render = new XYLineAndShapeRender(dataset) ;
    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    XYPlot plot = new XYPlot(xAxis, yAxis, render) ;
    plot.setOrientation(orientation) ;

    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>3DͼChart.ChartPlotΪ{@link Category3DPlot},XΪ
   * {@link CategoryAxis3D},YΪ{@link NumberValueAxis3D},
   * RenderΪ{@link Line3DRender},ݼеÿ
   * {@link com.ijchart.xychart.data.NumberChartData}.</zh>
   * <en>Creates a 3D line chart. The chart object returned by this method uses a
   * {@link Category3DPlot} instance as the plot, with a {@link CategoryAxis3D}
   * for the X axis, a {@link NumberValueAxis3D} as the Y axis,a {@link Line3DRender} as the render
   * ,and each data is {@link com.ijchart.xychart.data.NumberChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param xAxisLabel String <zh>Xıǩ (Ϊnull).</zh>
   * <en>The label for the category axis (null permitted).</en>
   * @param yAxisLabel String <zh>Yıǩ (Ϊnull).</zh>
   * <en>The label for the value axis (null permitted).</en>
   * @param dataset IMatrixDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param orientation ChartOrientation <zh>ͼķ,ˮƽֱ (Ϊnull).</zh>
   * <en>The plot orientation (horizontal or vertical) (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createLine3DChart(String title, String xAxisLabel, String yAxisLabel,
                                          IMatrixDataset dataset, ChartOrientation orientation,
                                          boolean legend, boolean tooltips) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }
    if (orientation == null) {
      throw new IllegalArgumentException("Null 'orientation' argument.") ;
    }

    Category3DPlot plot = new Category3DPlot() ;
    CategoryAxis3D categoryAxis = new CategoryAxis3D(xAxisLabel, dataset, plot) ;
    categoryAxis.setAxisLabelType(AxisLabelType.COLUMN) ;
    NumberValueAxis3D valueAxis = new NumberValueAxis3D(yAxisLabel, dataset, plot) ;
    valueAxis.setValueLineVisible(true) ;

    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      categoryAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      valueAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    Line3DRender render = new Line3DRender(plot, dataset) ;
    render.setBaseItemLabelVerticalAlignment(VerticalAlignment.CENTER) ;
    render.setBaseItemLabelHorizontalAlignment(HorizontalAlignment.CENTER) ;
    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    plot.setCategoryAxis(categoryAxis) ;
    plot.setValueAxis(valueAxis) ;
    plot.setRender(render) ;
    plot.setOrientation(orientation) ;
    plot.setForegroundAlpha(0.75f) ;

    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>XYջ״ͼChart.ChartPlotΪ{@link XYPlot},XΪ
   * {@link XYNumberValueAxis},YΪ{@link StackedXYValueAxis},
   * RenderΪ{@link XYStackedBarRender},ݼеÿ
   * {@link com.ijchart.xychart.data.XYNumberChartData}.</zh>
   * <en>Creates a interval stacked bar chart. The chart object returned by this method uses a
   * {@link XYPlot} instance as the plot, with a
   * {@link com.ijchart.xychart.axis.value.StackedXYValueAxis}
   * for the X axis, a {@link com.ijchart.xychart.axis.value.StackedXYValueAxis} as the Y axis, a
   * {@link XYStackedBarRender} as the render,and each data is
   * {@link com.ijchart.xychart.data.XYNumberChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param xAxisLabel String <zh>Xıǩ (Ϊnull).</zh>
   * <en>The label for the category axis (null permitted).</en>
   * @param yAxisLabel String <zh>Yıǩ (Ϊnull).</zh>
   * <en>The label for the value axis (null permitted).</en>
   * @param dataset IMatrixDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param orientation ChartOrientation <zh>ͼķ,ˮƽֱ (Ϊnull).</zh>
   * <en>The plot orientation (horizontal or vertical) (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   * @param isXAxisDate boolean <zh>Ƿx.</zh>
   * <en>Whether or not x-axis is date.</en>
   * @param isYAxisDate boolean <zh>Ƿy.</zh>
   * <en>Whether or not y-axis is date.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createStackedXYBarChart(String title, String xAxisLabel,
                                                String yAxisLabel, IMatrixDataset dataset,
                                                ChartOrientation orientation,
                                                boolean legend, boolean tooltips,
                                                boolean isXAxisDate, boolean isYAxisDate) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }
    if (orientation == null) {
      throw new IllegalArgumentException("Null 'orientation' argument.") ;
    }

    XYStackedBarRender render = new XYStackedBarRender(dataset) ;
    StackedXYBarValueAxis xAxis = new StackedXYBarValueAxis(xAxisLabel, dataset, render,
                                                            XYValueAxisType.XY_VALUE_AXIS_X,
                                                            isXAxisDate) ;
    xAxis.setAxisLabelType(AxisLabelType.COLUMN) ;
    xAxis.setAxisRangeIncludeZero(false) ;

    StackedXYBarValueAxis yAxis = new StackedXYBarValueAxis(yAxisLabel, dataset, render,
                                                            XYValueAxisType.XY_VALUE_AXIS_Y,
                                                            isYAxisDate) ;
    yAxis.setValueLineVisible(true) ;

    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      xAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      yAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    XYPlot plot = new XYPlot(xAxis, yAxis, render) ;
    plot.setOrientation(orientation) ;

    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>XYջ(Area)ͼChart.ChartPlotΪ{@link XYPlot},XΪ
   * {@link StackedXYValueAxis},YΪ{@link StackedXYValueAxis},
   * RenderΪ{@link XYStackedAreaRender},ݼеÿ
   * {@link com.ijchart.xychart.data.XYNumberChartData}.</zh>
   * <en>Creates a stacked area xy chart. The chart object returned by this method uses a
   * {@link XYPlot} instance as the plot, with a
   *  {@link com.ijchart.xychart.axis.value.StackedXYValueAxis}
   * for the X axis, a {@link com.ijchart.xychart.axis.value.StackedXYValueAxis} as the Y axis,
   *  a {@link XYStackedAreaRender} as the render,and each data is
   * {@link com.ijchart.xychart.data.XYNumberChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param xAxisLabel String <zh>Xıǩ (Ϊnull).</zh>
   * <en>The label for the category axis (null permitted).</en>
   * @param yAxisLabel String <zh>Yıǩ (Ϊnull).</zh>
   * <en>The label for the value axis (null permitted).</en>
   * @param dataset IMatrixDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param orientation ChartOrientation <zh>ͼķ,ˮƽֱ (Ϊnull).</zh>
   * <en>The plot orientation (horizontal or vertical) (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   * @param isXAxisDate boolean <zh>Ƿx.</zh>
   * <en>Whether or not x-axis is date.</en>
   * @param isYAxisDate boolean <zh>Ƿy.</zh>
   * <en>Whether or not y-axis is date.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createStackedXYAreaChart(String title, String xAxisLabel,
                                                 String yAxisLabel, IMatrixDataset dataset,
                                                 ChartOrientation orientation,
                                                 boolean legend, boolean tooltips,
                                                 boolean isXAxisDate, boolean isYAxisDate) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }
    if (orientation == null) {
      throw new IllegalArgumentException("Null 'orientation' argument.") ;
    }

    StackedXYValueAxis xAxis = new StackedXYValueAxis(xAxisLabel, dataset,
                                                      XYValueAxisType.XY_VALUE_AXIS_X, isXAxisDate) ;
    xAxis.setAxisLabelType(AxisLabelType.COLUMN) ;
    xAxis.setAxisRangeIncludeZero(false) ;

    StackedXYValueAxis yAxis = new StackedXYValueAxis(yAxisLabel, dataset,
                                                      XYValueAxisType.XY_VALUE_AXIS_Y, isYAxisDate) ;
    yAxis.setValueLineVisible(true) ;

    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      xAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      yAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    XYStackedAreaRender render = new XYStackedAreaRender(dataset) ;
    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    XYPlot plot = new XYPlot(xAxis, yAxis, render) ;
    plot.setOrientation(orientation) ;

    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>XY(Area)ͼChart.ChartPlotΪ{@link XYPlot},XΪ
   * {@link XYNumberValueAxis},YΪ{@link XYNumberValueAxis},
   * RenderΪ{@link XYAreaRender},ݼеÿ
   * {@link com.ijchart.xychart.data.XYNumberChartData}.</zh>
   * <en>Creates a xy area chart. The chart object returned by this method uses a
   * {@link XYPlot} instance as the plot, with a
   *  {@link com.ijchart.xychart.axis.value.XYNumberValueAxis}
   * for the X axis, a {@link com.ijchart.xychart.axis.value.XYNumberValueAxis} as the Y axis, a
   * {@link XYAreaRender} as the render,and each data is
   * {@link com.ijchart.xychart.data.XYNumberChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param xAxisLabel String <zh>Xıǩ (Ϊnull).</zh>
   * <en>The label for the category axis (null permitted).</en>
   * @param yAxisLabel String <zh>Yıǩ (Ϊnull).</zh>
   * <en>The label for the value axis (null permitted).</en>
   * @param dataset IMatrixDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param orientation ChartOrientation <zh>ͼķ,ˮƽֱ (Ϊnull).</zh>
   * <en>The plot orientation (horizontal or vertical) (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   * @param isXAxisDate boolean <zh>Ƿx.</zh>
   * <en>Whether or not x-axis is date.</en>
   * @param isYAxisDate boolean <zh>Ƿy.</zh>
   * <en>Whether or not y-axis is date.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createXYAreaChart(String title, String xAxisLabel, String yAxisLabel,
                                          IMatrixDataset dataset, ChartOrientation orientation,
                                          boolean legend, boolean tooltips,
                                          boolean isXAxisDate, boolean isYAxisDate) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }
    if (orientation == null) {
      throw new IllegalArgumentException("Null 'orientation' argument.") ;
    }

    XYNumberValueAxis xAxis = new XYNumberValueAxis(xAxisLabel, dataset,
                                                    XYValueAxisType.XY_VALUE_AXIS_X, isXAxisDate) ;
    xAxis.setAxisLabelType(AxisLabelType.COLUMN) ;
    xAxis.setAxisRangeIncludeZero(false) ;

    XYNumberValueAxis yAxis = new XYNumberValueAxis(yAxisLabel, dataset,
                                                    XYValueAxisType.XY_VALUE_AXIS_Y, isYAxisDate) ;
    yAxis.setValueLineVisible(true) ;

    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      xAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      yAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    XYAreaRender render = new XYAreaRender(dataset) ;
    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    XYPlot plot = new XYPlot(xAxis, yAxis, render) ;
    plot.setOrientation(orientation) ;
    plot.setForegroundAlpha(0.5f) ;

    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>ջ͵XY StepͼChart.ChartPlotΪ{@link XYPlot},XΪ
   * {@link StackedXYValueAxis},YΪ{@link StackedXYValueAxis},
   * RenderΪ{@link XYStackedStepAreaRender},ݼеÿ
   * {@link com.ijchart.xychart.data.XYNumberChartData}.</zh>
   * <en>Creates a stacked step area xy chart.The chart object returned by this method uses a
   * {@link XYPlot} instance as the plot, with a
   *  {@link com.ijchart.xychart.axis.value.StackedXYValueAxis}
   * for the X axis, a {@link com.ijchart.xychart.axis.value.StackedXYValueAxis} as the Y axis,
   *  a {@link XYStackedStepAreaRender} as the render,and each data is
   * {@link com.ijchart.xychart.data.XYNumberChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param xAxisLabel String <zh>Xıǩ (Ϊnull).</zh>
   * <en>The label for the category axis (null permitted).</en>
   * @param yAxisLabel String <zh>Yıǩ (Ϊnull).</zh>
   * <en>The label for the value axis (null permitted).</en>
   * @param dataset IMatrixDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param orientation ChartOrientation <zh>ͼķ,ˮƽֱ (Ϊnull).</zh>
   * <en>The plot orientation (horizontal or vertical) (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   * @param isXAxisDate boolean <zh>Ƿx.</zh>
   * <en>Whether or not x-axis is date.</en>
   * @param isYAxisDate boolean <zh>Ƿy.</zh>
   * <en>Whether or not y-axis is date.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createXYStackedStepAreaChart(String title, String xAxisLabel,
                                                     String yAxisLabel, IMatrixDataset dataset,
                                                     ChartOrientation orientation,
                                                     boolean legend, boolean tooltips,
                                                     boolean isXAxisDate, boolean isYAxisDate) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }
    if (orientation == null) {
      throw new IllegalArgumentException("Null 'orientation' argument.") ;
    }

    StackedXYValueAxis xAxis = new StackedXYValueAxis(xAxisLabel, dataset,
                                                      XYValueAxisType.XY_VALUE_AXIS_X, isXAxisDate) ;
    xAxis.setAxisLabelType(AxisLabelType.COLUMN) ;
    xAxis.setAxisRangeIncludeZero(false) ;

    StackedXYValueAxis yAxis = new StackedXYValueAxis(yAxisLabel, dataset,
                                                      XYValueAxisType.XY_VALUE_AXIS_Y, isYAxisDate) ;
    yAxis.setValueLineVisible(true) ;

    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      xAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      yAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    XYStackedStepAreaRender render = new XYStackedStepAreaRender(dataset) ;
    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    XYPlot plot = new XYPlot(xAxis, yAxis, render) ;
    plot.setOrientation(orientation) ;
    plot.setForegroundAlpha(0.8F) ;

    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>ƱͼChart.ChartPlotΪ{@link XYPlot},XΪ
   * {@link OHLCDateAxis},YΪ{@link OHLCValueAxis},
   * RenderΪ{@link StockRender},ݼеÿ
   * {@link com.ijchart.xychart.data.OHLCChartData}.</zh>
   * <en>Creates a stock xy chart.The chart object returned by this method uses a
   * {@link XYPlot} instance as the plot, with a
   *  {@link com.ijchart.xychart.axis.value.OHLCDateAxis}
   * for the X axis, a {@link com.ijchart.xychart.axis.value.OHLCValueAxis} as the Y axis,
   *  a {@link StockRender} as the render,and each data is
   * {@link com.ijchart.xychart.data.OHLCChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param xAxisLabel String <zh>Xıǩ (Ϊnull).</zh>
   * <en>The label for the category axis (null permitted).</en>
   * @param yAxisLabel String <zh>Yıǩ (Ϊnull).</zh>
   * <en>The label for the value axis (null permitted).</en>
   * @param dataset SingleRowDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param orientation ChartOrientation <zh>ͼķ,ˮƽֱ (Ϊnull).</zh>
   * <en>The plot orientation (horizontal or vertical) (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createStockChart(String title, String xAxisLabel, String yAxisLabel,
                                         SingleRowDataset dataset, ChartOrientation orientation,
                                         boolean legend, boolean tooltips) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }
    if (orientation == null) {
      throw new IllegalArgumentException("Null 'orientation' argument.") ;
    }

    OHLCDateAxis xAxis = new OHLCDateAxis(xAxisLabel, dataset) ;
    OHLCValueAxis yAxis = new OHLCValueAxis(yAxisLabel, dataset) ;
    yAxis.setAxisRangeIncludeZero(false) ;
    yAxis.setValueLineVisible(true) ;

    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      xAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      yAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    StockRender render = new StockRender(dataset) ;
    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    XYPlot plot = new XYPlot(xAxis, yAxis, render) ;
    plot.setOrientation(orientation) ;
    plot.setForegroundAlpha(0.3F) ;

    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>Ʊhigh-low Chart.ChartPlotΪ{@link XYPlot},XΪ
   * {@link OHLCDateAxis},YΪ{@link OHLCValueAxis},
   * RenderΪ{@link HighLowRender},ݼеÿ
   * {@link com.ijchart.xychart.data.OHLCChartData}.</zh>
   * <en>Creates a stock high-low xy chart.The chart object returned by this method uses a
   * {@link XYPlot} instance as the plot, with a
   *  {@link com.ijchart.xychart.axis.value.OHLCDateAxis}
   * for the X axis, a {@link com.ijchart.xychart.axis.value.OHLCValueAxis} as the Y axis,
   *  a {@link HighLowRender} as the render,and each data is
   * {@link com.ijchart.xychart.data.OHLCChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param xAxisLabel String <zh>Xıǩ (Ϊnull).</zh>
   * <en>The label for the category axis (null permitted).</en>
   * @param yAxisLabel String <zh>Yıǩ (Ϊnull).</zh>
   * <en>The label for the value axis (null permitted).</en>
   * @param dataset SingleRowDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param orientation ChartOrientation <zh>ͼķ,ˮƽֱ (Ϊnull).</zh>
   * <en>The plot orientation (horizontal or vertical) (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createHighLowChart(String title, String xAxisLabel, String yAxisLabel,
                                           SingleRowDataset dataset, ChartOrientation orientation,
                                           boolean legend, boolean tooltips) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }
    if (orientation == null) {
      throw new IllegalArgumentException("Null 'orientation' argument.") ;
    }

    OHLCDateAxis xAxis = new OHLCDateAxis(xAxisLabel, dataset) ;
    OHLCValueAxis yAxis = new OHLCValueAxis(yAxisLabel, dataset) ;
    yAxis.setValueLineVisible(true) ;

    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      xAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      yAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    HighLowRender render = new HighLowRender(dataset) ;
    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    XYPlot plot = new XYPlot(xAxis, yAxis, render) ;
    plot.setOrientation(orientation) ;

    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>Ʊhigh-lowƽ(average)Chart.ChartPlotΪ{@link XYPlot},XΪ
   * {@link OHLCDateAxis},YΪ{@link OHLCValueAxis},
   * RenderΪ{@link HighLowRender}{@link XYLineAndShapeRender},ݼеÿ
   * {@link com.ijchart.xychart.data.OHLCChartData}.</zh>
   * <en>Creates a stock high-low and average xy chart.The chart object returned by this method uses
   *  a {@link XYPlot} instance as the plot, with a
   *  {@link com.ijchart.xychart.axis.value.OHLCDateAxis}
   * for the X axis, a {@link com.ijchart.xychart.axis.value.OHLCValueAxis} as the Y axis,
   *  a {@link HighLowRender} and {@link XYLineAndShapeRender} as the renders,and each data is
   * {@link com.ijchart.xychart.data.OHLCChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param xAxisLabel String <zh>Xıǩ (Ϊnull).</zh>
   * <en>The label for the category axis (null permitted).</en>
   * @param yAxisLabel String <zh>Yıǩ (Ϊnull).</zh>
   * <en>The label for the value axis (null permitted).</en>
   * @param dataset SingleRowDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param averageDatasetRowKeyPrefix String <zh>ǰ׺䵽ԭݼrowKeyǰ (Ϊnull).</zh>
   * <en>The string to added in front of thesource rowKey to create new rowKey
   *  names (null permitted).</en>
   * @param averageDatasetRowKeySuffix String <zh>ǰ׺䵽ԭݼrowKeyĺ (Ϊnull).</zh>
   * <en>The string to append to source rowKey to create new rowKey names (null permitted).</en>
   * @param averageLen int <zh>ƶƽֵõڵݵĸ.</zh>
   * <en>The length of average datas.</en>
   * @param orientation ChartOrientation <zh>ͼķ,ˮƽֱ (Ϊnull).</zh>
   * <en>The plot orientation (horizontal or vertical) (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createHighLowAndAverageChart(String title, String xAxisLabel,
                                                     String yAxisLabel, SingleRowDataset dataset,
                                                     String averageDatasetRowKeyPrefix,
                                                     String averageDatasetRowKeySuffix,
                                                     int averageLen, ChartOrientation orientation,
                                                     boolean legend, boolean tooltips) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }
    if (orientation == null) {
      throw new IllegalArgumentException("Null 'orientation' argument.") ;
    }

    OHLCDateAxis xAxis = new OHLCDateAxis(xAxisLabel, dataset) ;
    OHLCValueAxis yAxis = new OHLCValueAxis(yAxisLabel, dataset) ;
    yAxis.setValueLineVisible(true) ;

    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      xAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      yAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    HighLowRender render = new HighLowRender(dataset) ;
    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    XYPlot plot = new XYPlot(xAxis, yAxis, render) ;
    plot.setOrientation(orientation) ;

    IMatrixDataset averageDataset =
      DatasetUtil.createMovingAverageOHLCDataset(dataset, averageDatasetRowKeyPrefix,
                                                 averageDatasetRowKeySuffix, averageLen) ;
    XYLineAndShapeRender lineRender = new XYLineAndShapeRender(averageDataset) ;
    lineRender.setBaseItemShapeVisible(false) ;
    plot.setRender(1, lineRender) ;

    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>Ʊɽ(volume)ͼ۸(price)Chart.ChartPlotΪ{@link XYPlot},һXΪ
   * {@link IntervalXYValueAxis},ڶXΪ{@link XYNumberValueAxis},
   * һYΪ{@link IntervalXYValueAxis},ڶYΪ{@link XYNumberValueAxis},
   * һRenderΪ{@link XYClusteredBar2DRender},ڶRenderΪ{@link XYLineAndShapeRender},
   * volumeDatasetݼеÿ{@link com.ijchart.xychart.data.IntervalXYNumberChartData},
   * priceDatasetݼеÿ{@link com.ijchart.xychart.data.XYNumberChartData}.</zh>
   * <en>Creates a stock volume and price chart.The chart object returned by this method uses
   *  a {@link XYPlot} instance as the plot, the first X axis is {@link IntervalXYValueAxis},
   * the second X axis is {@link XYNumberValueAxis},the first Y axis is {@link IntervalXYValueAxis},
   * the second Y axis is {@link XYNumberValueAxis},
   *  a {@link XYClusteredBar2DRender} and {@link XYLineAndShapeRender} as the renders,each data is
   * {@link com.ijchart.xychart.data.IntervalXYNumberChartData} object in volume dataset,each data
   *  is {@link com.ijchart.xychart.data.XYNumberChartData} object in volume dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param volumeXAxisLabel String <zh>volume Xıǩ (Ϊnull).</zh>
   * <en>The label for the volume x-axis (null permitted).</en>
   * @param volumeYAxisLabel String <zh>volume Yıǩ (Ϊnull).</zh>
   * <en>The label for the volume y-axis (null permitted).</en>
   * @param priceYAxisLabel String <zh>price Yıǩ (Ϊnull).</zh>
   * <en>The label for the price y-axis (null permitted).</en>
   * @param volumeDataset SingleRowDataset <zh>volumeݼ (Ϊnull).</zh>
   * <en>The volume dataset for the chart (null not permitted).</en>
   * @param priceDataset SingleRowDataset <zh>priceݼ (Ϊnull).</zh>
   * <en>The price dataset for the chart (null not permitted).</en>
   * @param orientation ChartOrientation <zh>ͼķ,ˮƽֱ (Ϊnull).</zh>
   * <en>The plot orientation (horizontal or vertical) (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createPriceVolumeChart(String title, String volumeXAxisLabel,
                                               String volumeYAxisLabel, String priceYAxisLabel,
                                               SingleRowDataset volumeDataset,
                                               SingleRowDataset priceDataset,
                                               ChartOrientation orientation, boolean legend,
                                               boolean tooltips) {
    if (volumeDataset == null) {
      throw new IllegalArgumentException("Null 'volumeDataset' argument.") ;
    }
    if (priceDataset == null) {
      throw new IllegalArgumentException("Null 'priceDataset' argument.") ;
    }
    if (orientation == null) {
      throw new IllegalArgumentException("Null 'orientation' argument.") ;
    }

    //volume objects
    IntervalXYValueAxis volumeXAxis = new IntervalXYValueAxis(volumeXAxisLabel, volumeDataset,
                                                              XYValueAxisType.XY_VALUE_AXIS_X, true) ;
    volumeXAxis.setAxisLabelType(AxisLabelType.COLUMN) ;

    IntervalXYValueAxis volumeYAxis = new IntervalXYValueAxis(volumeYAxisLabel, volumeDataset,
                                                              XYValueAxisType.XY_VALUE_AXIS_Y, false) ;
    volumeYAxis.setValueLineVisible(true) ;

    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      volumeXAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      volumeYAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    XYClusteredBar2DRender render = new XYClusteredBar2DRender(volumeDataset) ;
    render.setCenterBarAtStartValue(true) ;
    volumeXAxis.setRender(render) ;
    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    XYPlot plot = new XYPlot(volumeXAxis, volumeYAxis, render) ;
    plot.setOrientation(orientation) ;

    //price objects
    XYNumberValueAxis priceXAxis = new XYNumberValueAxis(null, priceDataset,
                                                         XYValueAxisType.XY_VALUE_AXIS_X, true) ;
    priceXAxis.setAxisLabelType(AxisLabelType.COLUMN) ;
    priceXAxis.setVisible(false) ;

    XYNumberValueAxis priceYAxis = new XYNumberValueAxis(priceYAxisLabel, priceDataset,
                                                         XYValueAxisType.XY_VALUE_AXIS_Y, false) ;
    priceYAxis.setAxisRangeIncludeZero(false) ;

    XYLineAndShapeRender lineRender = new XYLineAndShapeRender(priceDataset) ;
    lineRender.setBaseItemShapeVisible(false) ;

    plot.setDomainAxis(1, priceXAxis) ;
    plot.setValueAxis(1, priceYAxis) ;
    plot.setRender(1, lineRender) ;

    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      priceXAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      priceYAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>ǱͼChart.ChartPlotΪ{@link NoAxisPlot},RenderΪ{@link MeterRender},
   * ݼеÿ{@link com.ijchart.xychart.data.StartEndNumberChartData}.</zh>
   * <en>Creates a meter chart. The chart object returned by this method uses a
   * {@link NoAxisPlot} instance as the plot, a {@link MeterRender} as the render,and each data is
   * {@link com.ijchart.xychart.data.StartEndNumberChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param dataset SingleRowDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createMeterChart(String title, SingleRowDataset dataset, boolean legend,
                                         boolean tooltips) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }

    MeterRender render = new MeterRender(dataset) ;
    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    NoAxisPlot plot = new NoAxisPlot(render) ;
    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>ͼChart.ChartPlotΪ{@link XYPlot},XΪ{@link XYNumberValueAxis},
   * YΪ{@link XYNumberValueAxis},RenderΪ{@link XYBlockRender},ݼеÿ
   * {@link com.ijchart.xychart.data.XYZNumberChartData}.</zh>
   * <en>Creates a block chart.The chart object returned by this method uses
   *  a {@link XYPlot} instance as the plot, the X axis is {@link XYNumberValueAxis},
   *  the Y axis is {@link XYNumberValueAxis},a {@link XYBlockRender} as the render,each data is
   * {@link com.ijchart.xychart.data.XYZNumberChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param xAxisLabel String <zh>Xıǩ (Ϊnull).</zh>
   * <en>The label for the x-axis (null permitted).</en>
   * @param yAxisLabel String <zh>Yıǩ (Ϊnull).</zh>
   * <en>The label for the y-axis (null permitted).</en>
   * @param legendLabel String <zh>ͼǩ.</zh>
   * <en>The legend label.</en>
   * @param dataset IMatrixDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param orientation ChartOrientation <zh>ͼķ,ˮƽֱ (Ϊnull).</zh>
   * <en>The plot orientation (horizontal or vertical) (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   * @param isXAxisDate boolean <zh>Ƿx.</zh>
   * <en>Whether or not x-axis is date.</en>
   * @param isYAxisDate boolean <zh>Ƿy.</zh>
   * <en>Whether or not y-axis is date.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createXYBlockChart(String title, String xAxisLabel, String yAxisLabel,
                                           String legendLabel, IMatrixDataset dataset,
                                           ChartOrientation orientation, boolean legend,
                                           boolean tooltips, boolean isXAxisDate,
                                           boolean isYAxisDate) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }
    if (orientation == null) {
      throw new IllegalArgumentException("Null 'orientation' argument.") ;
    }

    XYNumberValueAxis xAxis = new XYNumberValueAxis(xAxisLabel, dataset,
                                                    XYValueAxisType.XY_VALUE_AXIS_X, isXAxisDate) ;
    xAxis.setAxisLabelType(AxisLabelType.COLUMN) ;
    XYNumberValueAxis yAxis = new XYNumberValueAxis(yAxisLabel, dataset,
                                                    XYValueAxisType.XY_VALUE_AXIS_Y, isYAxisDate) ;
    yAxis.setValueLineVisible(true) ;

    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      xAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      yAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    XYBlockRender render = new XYBlockRender(dataset, legendLabel) ;
    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    XYPlot plot = new XYPlot(xAxis, yAxis, render) ;
    plot.setOrientation(orientation) ;

    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    if (legend) {
      chart.getLegendTitle().setBorderVisible(false) ;
    }

    return chart ;
  }

  /**
   * <zh>һͼεChart.ChartPlotΪ{@link XYPlot},XΪ{@link XYNumberValueAxis}
   * ,YΪ{@link XYNumberValueAxis},RenderΪ{@link XYShapeRender},ݼеÿ
   * {@link com.ijchart.xychart.data.XYZNumberChartData}.</zh>
   * <en>Creates a general shape chart.The chart object returned by this method uses
   *  a {@link XYPlot} instance as the plot, the X axis is {@link XYNumberValueAxis},
   *  the Y axis is {@link XYNumberValueAxis},a {@link XYShapeRender} as the render,each data is
   * {@link com.ijchart.xychart.data.XYZNumberChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param xAxisLabel String <zh>Xıǩ (Ϊnull).</zh>
   * <en>The label for the x-axis (null permitted).</en>
   * @param yAxisLabel String <zh>Yıǩ (Ϊnull).</zh>
   * <en>The label for the y-axis (null permitted).</en>
   * @param legendLabel String <zh>ͼǩ.</zh>
   * <en>The legend label.</en>
   * @param dataset IMatrixDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param orientation ChartOrientation <zh>ͼķ,ˮƽֱ (Ϊnull).</zh>
   * <en>The plot orientation (horizontal or vertical) (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   * @param isXAxisDate boolean <zh>Ƿx.</zh>
   * <en>Whether or not x-axis is date.</en>
   * @param isYAxisDate boolean <zh>Ƿy.</zh>
   * <en>Whether or not y-axis is date.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createXYShapeChart(String title, String xAxisLabel, String yAxisLabel,
                                           String legendLabel, IMatrixDataset dataset,
                                           ChartOrientation orientation, boolean legend,
                                           boolean tooltips, boolean isXAxisDate,
                                           boolean isYAxisDate) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }
    if (orientation == null) {
      throw new IllegalArgumentException("Null 'orientation' argument.") ;
    }

    XYNumberValueAxis xAxis = new XYNumberValueAxis(xAxisLabel, dataset,
                                                    XYValueAxisType.XY_VALUE_AXIS_X, isXAxisDate) ;
    xAxis.setAxisLabelType(AxisLabelType.COLUMN) ;
    XYNumberValueAxis yAxis = new XYNumberValueAxis(yAxisLabel, dataset,
                                                    XYValueAxisType.XY_VALUE_AXIS_Y, isYAxisDate) ;
    yAxis.setValueLineVisible(true) ;

    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      xAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      yAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    XYShapeRender render = new XYShapeRender(dataset, legendLabel) ;
    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    XYPlot plot = new XYPlot(xAxis, yAxis, render) ;
    plot.setOrientation(orientation) ;

    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    if (legend) {
      chart.getLegendTitle().setBorderVisible(false) ;
    }
    return chart ;
  }

  /**
   * <zh>ͼChart.ChartPlotΪ{@link XYPlot},XΪ{@link XYNumberValueAxis},
   * YΪ{@link XYNumberValueAxis},RenderΪ{@link VectorRender},ݼеÿ
   * {@link com.ijchart.xychart.data.VectorChartData}.</zh>
   * <en>Creates a vector chart.The chart object returned by this method uses
   *  a {@link XYPlot} instance as the plot, the X axis is {@link XYNumberValueAxis},
   *  the Y axis is {@link XYNumberValueAxis},a {@link VectorRender} as the render,each data is
   * {@link com.ijchart.xychart.data.VectorChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param xAxisLabel String <zh>Xıǩ (Ϊnull).</zh>
   * <en>The label for the x-axis (null permitted).</en>
   * @param yAxisLabel String <zh>Yıǩ (Ϊnull).</zh>
   * <en>The label for the y-axis (null permitted).</en>
   * @param dataset IMatrixDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param orientation ChartOrientation <zh>ͼķ,ˮƽֱ (Ϊnull).</zh>
   * <en>The plot orientation (horizontal or vertical) (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   * @param isXAxisDate boolean <zh>Ƿx.</zh>
   * <en>Whether or not x-axis is date.</en>
   * @param isYAxisDate boolean <zh>Ƿy.</zh>
   * <en>Whether or not y-axis is date.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createVectorChart(String title, String xAxisLabel, String yAxisLabel,
                                          IMatrixDataset dataset, ChartOrientation orientation,
                                          boolean legend, boolean tooltips,
                                          boolean isXAxisDate, boolean isYAxisDate) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }
    if (orientation == null) {
      throw new IllegalArgumentException("Null 'orientation' argument.") ;
    }

    XYNumberValueAxis xAxis = new XYNumberValueAxis(xAxisLabel, dataset,
                                                    XYValueAxisType.XY_VALUE_AXIS_X, isXAxisDate) ;
    xAxis.setAxisLabelType(AxisLabelType.COLUMN) ;
    XYNumberValueAxis yAxis = new XYNumberValueAxis(yAxisLabel, dataset,
                                                    XYValueAxisType.XY_VALUE_AXIS_Y, isYAxisDate) ;
    yAxis.setValueLineVisible(true) ;

    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      xAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      yAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    VectorRender render = new VectorRender(dataset) ;
    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    XYPlot plot = new XYPlot(xAxis, yAxis, render) ;
    plot.setOrientation(orientation) ;

    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>ͼChart.ChartPlotΪ{@link XYPlot},XΪ{@link WindValueAxis},
   * YΪ{@link WindValueAxis},RenderΪ{@link VectorRender},ݼеÿ
   * {@link com.ijchart.xychart.data.WindChartData}.</zh>
   * <en>Creates a wind chart.The chart object returned by this method uses
   *  a {@link XYPlot} instance as the plot, the X axis is {@link WindValueAxis},
   *  the Y axis is {@link WindValueAxis},a {@link WindRender} as the render,each data is
   * {@link com.ijchart.xychart.data.WindChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param xAxisLabel String <zh>Xıǩ (Ϊnull).</zh>
   * <en>The label for the x-axis (null permitted).</en>
   * @param yAxisLabel String <zh>Yıǩ (Ϊnull).</zh>
   * <en>The label for the y-axis (null permitted).</en>
   * @param dataset IMatrixDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param orientation ChartOrientation <zh>ͼķ,ˮƽֱ (Ϊnull).</zh>
   * <en>The plot orientation (horizontal or vertical) (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   * @param isXAxisDate boolean <zh>Ƿx.</zh>
   * <en>Whether or not x-axis is date.</en>
   * @param isYAxisDate boolean <zh>Ƿy.</zh>
   * <en>Whether or not y-axis is date.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createWindChart(String title, String xAxisLabel, String yAxisLabel,
                                        IMatrixDataset dataset, ChartOrientation orientation,
                                        boolean legend, boolean tooltips,
                                        boolean isXAxisDate, boolean isYAxisDate) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }
    if (orientation == null) {
      throw new IllegalArgumentException("Null 'orientation' argument.") ;
    }

    WindValueAxis xAxis = new WindValueAxis(xAxisLabel, dataset,
                                            XYValueAxisType.XY_VALUE_AXIS_X, isXAxisDate) ;
    xAxis.setAxisLabelType(AxisLabelType.COLUMN) ;
    WindValueAxis yAxis = new WindValueAxis(yAxisLabel, dataset,
                                            XYValueAxisType.XY_VALUE_AXIS_Y, isYAxisDate) ;
    yAxis.setValueLineVisible(true) ;
    yAxis.setTickUnit(new LongTickUnit()) ;

    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      xAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      yAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    WindRender render = new WindRender(dataset) ;
    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    XYPlot plot = new XYPlot(xAxis, yAxis, render) ;
    plot.setOrientation(orientation) ;

    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>XYͼChart.ChartPlotΪ{@link XYPlot},XΪ
   * {@link XYNumberValueAxis},YΪ{@link XYNumberValueAxis},RenderΪ
   * {@link XYLineAndShapeRender},ݼеÿ
   * {@link com.ijchart.xychart.data.XYNumberChartData}.</zh>
   * <en>Creates a XY dot chart. The chart object returned by this method uses a
   * {@link XYPlot} instance as the plot, with a {@link XYNumberValueAxis}
   * for the X axis, a {@link XYNumberValueAxis} as the Y axis, a
   * {@link XYLineAndShapeRender} as the render,and each data is
   * {@link com.ijchart.xychart.data.XYNumberChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param xAxisLabel String <zh>Xıǩ (Ϊnull).</zh>
   * <en>The label for the category axis (null permitted).</en>
   * @param yAxisLabel String <zh>Yıǩ (Ϊnull).</zh>
   * <en>The label for the value axis (null permitted).</en>
   * @param dataset IMatrixDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param orientation ChartOrientation <zh>ͼķ,ˮƽֱ (Ϊnull).</zh>
   * <en>The plot orientation (horizontal or vertical) (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   * @param isXAxisDate boolean <zh>Ƿx.</zh>
   * <en>Whether or not x-axis is date.</en>
   * @param isYAxisDate boolean <zh>Ƿy.</zh>
   * <en>Whether or not y-axis is date.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createXYDotChart(String title, String xAxisLabel, String yAxisLabel,
                                         IMatrixDataset dataset, ChartOrientation orientation,
                                         boolean legend, boolean tooltips,
                                         boolean isXAxisDate, boolean isYAxisDate) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }
    if (orientation == null) {
      throw new IllegalArgumentException("Null 'orientation' argument.") ;
    }

    XYNumberValueAxis xAxis = new XYNumberValueAxis(xAxisLabel, dataset,
                                                    XYValueAxisType.XY_VALUE_AXIS_X, isXAxisDate) ;
    xAxis.setAxisLabelType(AxisLabelType.COLUMN) ;
    XYNumberValueAxis yAxis = new XYNumberValueAxis(yAxisLabel, dataset,
                                                    XYValueAxisType.XY_VALUE_AXIS_Y, isYAxisDate) ;
    yAxis.setValueLineVisible(true) ;

    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      xAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      yAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    XYDotRender render = new XYDotRender(dataset) ;
    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    XYPlot plot = new XYPlot(xAxis, yAxis, render) ;
    plot.setOrientation(orientation) ;

    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>ͼChart.ChartPlotΪ{@link NoAxisPlot},RenderΪ{@link PieRender},
   * ݼеÿ{@link com.ijchart.xychart.data.NumberChartData}.</zh>
   * <en>Creates a pie chart. The chart object returned by this method uses a
   * {@link NoAxisPlot} instance as the plot, a {@link PieRender} as the render,and each data is
   * {@link com.ijchart.xychart.data.NumberChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param dataset SingleRowDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createPieChart(String title, SingleRowDataset dataset, boolean legend,
                                       boolean tooltips) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }

    PieRender render = new PieRender(dataset) ;
    render.setBaseItemLabelVisible(true) ;
    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    NoAxisPlot plot = new NoAxisPlot(render) ;
    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>3DͼChart.ChartPlotΪ{@link NoAxisPlot},RenderΪ{@link PieRender},
   * ݼеÿ{@link com.ijchart.xychart.data.NumberChartData}.</zh>
   * <en>Creates a 3d pie chart. The chart object returned by this method uses a
   * {@link NoAxisPlot} instance as the plot, a {@link PieRender} as the render,and each data is
   * {@link com.ijchart.xychart.data.NumberChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param dataset SingleRowDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createPie3DChart(String title, SingleRowDataset dataset, boolean legend,
                                         boolean tooltips) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }

    PieRender render = new PieRender(dataset, true) ;
    render.setBaseItemLabelVisible(true) ;
    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    NoAxisPlot plot = new NoAxisPlot(render) ;
    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>ԲͼChart.ChartPlotΪ{@link NoAxisPlot},RenderΪ{@link PieRender},
   * ݼеÿ{@link com.ijchart.xychart.data.NumberChartData}.</zh>
   * <en>Creates a ring chart. The chart object returned by this method uses a
   * {@link NoAxisPlot} instance as the plot, a {@link PieRender} as the render,and each data is
   * {@link com.ijchart.xychart.data.NumberChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param dataset SingleRowDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createRingChart(String title, SingleRowDataset dataset, boolean legend,
                                        boolean tooltips) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }

    PieRender render = new PieRender(dataset, true) ;
    render.setBaseItemLabelVisible(true) ;
    render.setDrawAsRing(true) ;
    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    NoAxisPlot plot = new NoAxisPlot(render) ;
    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>ֱͼChart.ChartPlotΪ{@link XYPlot},XΪ
   * {@link IntervalXYValueAxis},YΪ{@link IntervalXYValueAxis},RenderΪ
   * {@link XYIntervalBar2DRender},ݼеÿ
   * {@link com.ijchart.xychart.data.IntervalXYNumberChartData}.</zh>
   * <en>Creates a histogram chart. The chart object returned by this method uses a
   * {@link XYPlot} instance as the plot, with a {@link IntervalXYValueAxis}
   * for the X axis, a {@link IntervalXYValueAxis} as the Y axis, a
   * {@link XYIntervalBar2DRender} as the render,and each data is
   * {@link com.ijchart.xychart.data.IntervalXYNumberChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param xAxisLabel String <zh>Xıǩ (Ϊnull).</zh>
   * <en>The label for the category axis (null permitted).</en>
   * @param yAxisLabel String <zh>Yıǩ (Ϊnull).</zh>
   * <en>The label for the value axis (null permitted).</en>
   * @param dataset IMatrixDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param orientation ChartOrientation <zh>ͼķ,ˮƽֱ (Ϊnull).</zh>
   * <en>The plot orientation (horizontal or vertical) (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createHistogramChart(String title, String xAxisLabel, String yAxisLabel,
                                             IMatrixDataset dataset, ChartOrientation orientation,
                                             boolean legend, boolean tooltips) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }
    if (orientation == null) {
      throw new IllegalArgumentException("Null 'orientation' argument.") ;
    }

    IntervalXYValueAxis xAxis = new IntervalXYValueAxis(xAxisLabel, dataset,
                                                        XYValueAxisType.XY_VALUE_AXIS_X, false) ;
    xAxis.setAxisLabelType(AxisLabelType.COLUMN) ;
    IntervalXYValueAxis yAxis = new IntervalXYValueAxis(yAxisLabel, dataset,
                                                        XYValueAxisType.XY_VALUE_AXIS_Y, false) ;
    yAxis.setValueLineVisible(true) ;

    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      xAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      yAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    XYIntervalBar2DRender render = new XYIntervalBar2DRender(dataset) ;
    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    XYPlot plot = new XYPlot(xAxis, yAxis, render) ;
    plot.setOrientation(orientation) ;
    plot.setForegroundAlpha(0.85F) ;

    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>ɢͼChart.ChartPlotΪ{@link XYPlot},XΪ
   * {@link XYNumberValueAxis},YΪ{@link XYNumberValueAxis},RenderΪ
   * {@link XYLineAndShapeRender},ݼеÿ
   * {@link com.ijchart.xychart.data.XYNumberChartData}.</zh>
   * <en>Creates a Scatter chart. The chart object returned by this method uses a
   * {@link XYPlot} instance as the plot, with a {@link XYNumberValueAxis}
   * for the X axis, a {@link XYNumberValueAxis} as the Y axis, a
   * {@link XYLineAndShapeRender} as the render,and each data is
   * {@link com.ijchart.xychart.data.XYNumberChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param xAxisLabel String <zh>Xıǩ (Ϊnull).</zh>
   * <en>The label for the category axis (null permitted).</en>
   * @param yAxisLabel String <zh>Yıǩ (Ϊnull).</zh>
   * <en>The label for the value axis (null permitted).</en>
   * @param dataset IMatrixDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param orientation ChartOrientation <zh>ͼķ,ˮƽֱ (Ϊnull).</zh>
   * <en>The plot orientation (horizontal or vertical) (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   * @param isXAxisDate boolean <zh>Ƿx.</zh>
   * <en>Whether or not x-axis is date.</en>
   * @param isYAxisDate boolean <zh>Ƿy.</zh>
   * <en>Whether or not y-axis is date.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createScatterChart(String title, String xAxisLabel, String yAxisLabel,
                                           IMatrixDataset dataset, ChartOrientation orientation,
                                           boolean legend, boolean tooltips,
                                           boolean isXAxisDate, boolean isYAxisDate) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }
    if (orientation == null) {
      throw new IllegalArgumentException("Null 'orientation' argument.") ;
    }

    XYNumberValueAxis xAxis = new XYNumberValueAxis(xAxisLabel, dataset,
                                                    XYValueAxisType.XY_VALUE_AXIS_X, isXAxisDate) ;
    xAxis.setAxisLabelType(AxisLabelType.COLUMN) ;
    XYNumberValueAxis yAxis = new XYNumberValueAxis(yAxisLabel, dataset,
                                                    XYValueAxisType.XY_VALUE_AXIS_Y, isYAxisDate) ;
    yAxis.setValueLineVisible(true) ;

    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      xAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      yAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    XYLineAndShapeRender render = new XYLineAndShapeRender(dataset) ;
    render.setBaseItemLineVisible(false) ;
    render.setBaseItemShapeVisible(true) ;
    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    XYPlot plot = new XYPlot(xAxis, yAxis, render) ;
    plot.setOrientation(orientation) ;

    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>XY-Error Chart.ChartPlotΪ{@link XYPlot},XΪ
   * {@link ErrorValueAxis},YΪ{@link ErrorValueAxis},RenderΪ
   * {@link XYErrorRender},ݼеÿ
   * {@link com.ijchart.xychart.data.ErrorChartData}.</zh>
   * <en>Creates a XY-Error chart. The chart object returned by this method uses a
   * {@link XYPlot} instance as the plot, with a {@link ErrorValueAxis}
   * for the X axis, a {@link ErrorValueAxis} as the Y axis, a
   * {@link XYErrorRender} as the render,and each data is
   * {@link com.ijchart.xychart.data.ErrorChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param xAxisLabel String <zh>Xıǩ (Ϊnull).</zh>
   * <en>The label for the category axis (null permitted).</en>
   * @param yAxisLabel String <zh>Yıǩ (Ϊnull).</zh>
   * <en>The label for the value axis (null permitted).</en>
   * @param dataset IMatrixDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param orientation ChartOrientation <zh>ͼķ,ˮƽֱ (Ϊnull).</zh>
   * <en>The plot orientation (horizontal or vertical) (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   * @param isXAxisDate boolean <zh>Ƿx.</zh>
   * <en>Whether or not x-axis is date.</en>
   * @param isYAxisDate boolean <zh>Ƿy.</zh>
   * <en>Whether or not y-axis is date.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createXYErrorChart(String title, String xAxisLabel, String yAxisLabel,
                                           IMatrixDataset dataset, ChartOrientation orientation,
                                           boolean legend, boolean tooltips,
                                           boolean isXAxisDate, boolean isYAxisDate) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }
    if (orientation == null) {
      throw new IllegalArgumentException("Null 'orientation' argument.") ;
    }

    ErrorValueAxis xAxis = new ErrorValueAxis(xAxisLabel, dataset,
                                              XYValueAxisType.XY_VALUE_AXIS_X, isXAxisDate) ;
    xAxis.setAxisLabelType(AxisLabelType.COLUMN) ;
    ErrorValueAxis yAxis = new ErrorValueAxis(yAxisLabel, dataset,
                                              XYValueAxisType.XY_VALUE_AXIS_Y, isYAxisDate) ;
    yAxis.setValueLineVisible(true) ;

    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      xAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      yAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    XYErrorRender render = new XYErrorRender(dataset) ;
    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    XYPlot plot = new XYPlot(xAxis, yAxis, render) ;
    plot.setOrientation(orientation) ;

    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>XYͼƫChart.ChartPlotΪ{@link XYPlot},XΪ
   * {@link YIntervalValueAxis},YΪ{@link YIntervalValueAxis},RenderΪ
   * {@link XYLineAndShapeRender},ݼеÿ
   * {@link com.ijchart.xychart.data.YIntervalChartData}.</zh>
   * <en>Creates a XY line and deviation chart. The chart object returned by this method uses a
   * {@link XYPlot} instance as the plot, with a {@link YIntervalValueAxis}
   * for the X axis, a {@link YIntervalValueAxis} as the Y axis, a
   * {@link XYLineAndShapeRender} as the render,and each data is
   * {@link com.ijchart.xychart.data.YIntervalChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param xAxisLabel String <zh>Xıǩ (Ϊnull).</zh>
   * <en>The label for the category axis (null permitted).</en>
   * @param yAxisLabel String <zh>Yıǩ (Ϊnull).</zh>
   * <en>The label for the value axis (null permitted).</en>
   * @param dataset IMatrixDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param orientation ChartOrientation <zh>ͼķ,ˮƽֱ (Ϊnull).</zh>
   * <en>The plot orientation (horizontal or vertical) (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   * @param isXAxisDate boolean <zh>Ƿx.</zh>
   * <en>Whether or not x-axis is date.</en>
   * @param isYAxisDate boolean <zh>Ƿy.</zh>
   * <en>Whether or not y-axis is date.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createDeviationChart(String title, String xAxisLabel, String yAxisLabel,
                                             IMatrixDataset dataset, ChartOrientation orientation,
                                             boolean legend, boolean tooltips,
                                             boolean isXAxisDate, boolean isYAxisDate) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }
    if (orientation == null) {
      throw new IllegalArgumentException("Null 'orientation' argument.") ;
    }

    YIntervalValueAxis xAxis = new YIntervalValueAxis(xAxisLabel, dataset,
                                                      XYValueAxisType.XY_VALUE_AXIS_X, isXAxisDate) ;
    xAxis.setAxisLabelType(AxisLabelType.COLUMN) ;
    YIntervalValueAxis yAxis = new YIntervalValueAxis(yAxisLabel, dataset,
                                                      XYValueAxisType.XY_VALUE_AXIS_Y, isYAxisDate) ;
    yAxis.setValueLineVisible(true) ;

    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      xAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      yAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    DeviationRender render = new DeviationRender(dataset) ;
    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    XYPlot plot = new XYPlot(xAxis, yAxis, render) ;
    plot.setOrientation(orientation) ;

    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>XYðͼChart.ChartPlotΪ{@link XYPlot},XΪ
   * {@link XYZNumberValueAxis},YΪ{@link XYZNumberValueAxis},RenderΪ
   * {@link XYBubbleRender},ݼеÿ
   * {@link com.ijchart.xychart.data.XYZNumberChartData}.</zh>
   * <en>Creates a XY line chart. The chart object returned by this method uses a
   * {@link XYPlot} instance as the plot, with a {@link XYZNumberValueAxis}
   * for the X axis, a {@link XYZNumberValueAxis} as the Y axis, a
   * {@link XYBubbleRender} as the render,and each data is
   * {@link com.ijchart.xychart.data.XYZNumberChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param xAxisLabel String <zh>Xıǩ (Ϊnull).</zh>
   * <en>The label for the category axis (null permitted).</en>
   * @param yAxisLabel String <zh>Yıǩ (Ϊnull).</zh>
   * <en>The label for the value axis (null permitted).</en>
   * @param dataset IMatrixDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param orientation ChartOrientation <zh>ͼķ,ˮƽֱ (Ϊnull).</zh>
   * <en>The plot orientation (horizontal or vertical) (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   * @param isXAxisDate boolean <zh>Ƿx.</zh>
   * <en>Whether or not x-axis is date.</en>
   * @param isYAxisDate boolean <zh>Ƿy.</zh>
   * <en>Whether or not y-axis is date.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createXYBubbleChart(String title, String xAxisLabel, String yAxisLabel,
                                            IMatrixDataset dataset, ChartOrientation orientation,
                                            boolean legend, boolean tooltips,
                                            boolean isXAxisDate, boolean isYAxisDate) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }
    if (orientation == null) {
      throw new IllegalArgumentException("Null 'orientation' argument.") ;
    }

    XYZNumberValueAxis xAxis = new XYZNumberValueAxis(xAxisLabel, dataset,
                                                      XYValueAxisType.XY_VALUE_AXIS_X, isXAxisDate) ;
    xAxis.setAxisLabelType(AxisLabelType.COLUMN) ;
    xAxis.setAxisRangeIncludeZero(false) ;
    XYZNumberValueAxis yAxis = new XYZNumberValueAxis(yAxisLabel, dataset,
                                                      XYValueAxisType.XY_VALUE_AXIS_Y, isYAxisDate) ;
    yAxis.setValueLineVisible(true) ;
    yAxis.setAxisRangeIncludeZero(false) ;

    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      xAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      yAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    XYBubbleRender render = new XYBubbleRender(dataset) ;
    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;
    render.setScaleType(XYBubbleRender.SCALE_ON_RANGE_AXIS) ;

    XYPlot plot = new XYPlot(xAxis, yAxis, render) ;
    plot.setOrientation(orientation) ;

    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>(difference)ͼChart.ChartPlotΪ{@link XYPlot},XΪ
   * {@link XYNumberValueAxis},YΪ{@link XYNumberValueAxis},RenderΪ
   * {@link XYDifferenceRender},ݼеÿ
   * {@link com.ijchart.xychart.data.XYNumberChartData}.</zh>
   * <en>Creates a XY line chart. The chart object returned by this method uses a
   * {@link XYPlot} instance as the plot, with a {@link XYNumberValueAxis}
   * for the X axis, a {@link XYNumberValueAxis} as the Y axis, a
   * {@link XYDifferenceRender} as the render,and each data is
   * {@link com.ijchart.xychart.data.XYNumberChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param xAxisLabel String <zh>Xıǩ (Ϊnull).</zh>
   * <en>The label for the category axis (null permitted).</en>
   * @param yAxisLabel String <zh>Yıǩ (Ϊnull).</zh>
   * <en>The label for the value axis (null permitted).</en>
   * @param dataset IMatrixDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param orientation ChartOrientation <zh>ͼķ,ˮƽֱ (Ϊnull).</zh>
   * <en>The plot orientation (horizontal or vertical) (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   * @param isXAxisDate boolean <zh>Ƿx.</zh>
   * <en>Whether or not x-axis is date.</en>
   * @param isYAxisDate boolean <zh>Ƿy.</zh>
   * <en>Whether or not y-axis is date.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createXYDifferenceChart(String title, String xAxisLabel, String yAxisLabel,
                                                IMatrixDataset dataset,
                                                ChartOrientation orientation,
                                                boolean legend, boolean tooltips,
                                                boolean isXAxisDate, boolean isYAxisDate) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }
    if (orientation == null) {
      throw new IllegalArgumentException("Null 'orientation' argument.") ;
    }

    XYNumberValueAxis xAxis = new XYNumberValueAxis(xAxisLabel, dataset,
                                                    XYValueAxisType.XY_VALUE_AXIS_X, isXAxisDate) ;
    xAxis.setAxisLabelType(AxisLabelType.COLUMN) ;
    XYNumberValueAxis yAxis = new XYNumberValueAxis(yAxisLabel, dataset,
                                                    XYValueAxisType.XY_VALUE_AXIS_Y, isYAxisDate) ;
    yAxis.setValueLineVisible(true) ;

    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      xAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      yAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    XYDifferenceRender render = new XYDifferenceRender(dataset) ;
    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    XYPlot plot = new XYPlot(xAxis, yAxis, render) ;
    plot.setOrientation(orientation) ;

    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>ͼChart.ChartPlotΪ{@link NoAxisPlot},RenderΪ{@link PolarRender},
   * ݼеÿ{@link com.ijchart.xychart.data.XYNumberChartData}.</zh>
   * <en>Creates a polar chart. The chart object returned by this method uses a
   * {@link NoAxisPlot} instance as the plot, a {@link PolarRender} as the render,and each data is
   * {@link com.ijchart.xychart.data.XYNumberChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param dataset IMatrixDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createPolarChart(String title, IMatrixDataset dataset, boolean legend,
                                         boolean tooltips) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }

    PolarRender render = new PolarRender(dataset) ;
    render.setBaseItemLabelVisible(true) ;
    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    NoAxisPlot plot = new NoAxisPlot(render) ;
    plot.setForegroundAlpha(0.75F) ;
    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>ͼChart.ChartPlotΪ{@link NoAxisPlot},RenderΪ{@link SpiderWebRender},
   * ݼеÿ{@link com.ijchart.xychart.data.NumberChartData}.</zh>
   * <en>Creates a spider web chart. The chart object returned by this method uses a
   * {@link NoAxisPlot} instance as the plot, a {@link SpiderWebRender} as the render,and each data
   *  is {@link com.ijchart.xychart.data.NumberChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param dataset IMatrixDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createSpiderWebChart(String title, IMatrixDataset dataset, boolean legend,
                                             boolean tooltips) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }

    SpiderWebRender render = new SpiderWebRender(dataset) ;
    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    NoAxisPlot plot = new NoAxisPlot(render) ;
    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>yͼChart.ChartPlotΪ{@link XYPlot},XΪ
   * {@link YIntervalValueAxis},YΪ{@link YIntervalValueAxis},RenderΪ
   * {@link XYLineAndShapeRender},ݼеÿ
   * {@link com.ijchart.xychart.data.YIntervalChartData}.</zh>
   * <en>Creates a Y-Interval chart. The chart object returned by this method uses a
   * {@link XYPlot} instance as the plot, with a {@link YIntervalValueAxis}
   * for the X axis, a {@link YIntervalValueAxis} as the Y axis, a
   * {@link XYLineAndShapeRender} as the render,and each data is
   * {@link com.ijchart.xychart.data.YIntervalChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param xAxisLabel String <zh>Xıǩ (Ϊnull).</zh>
   * <en>The label for the category axis (null permitted).</en>
   * @param yAxisLabel String <zh>Yıǩ (Ϊnull).</zh>
   * <en>The label for the value axis (null permitted).</en>
   * @param dataset IMatrixDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param orientation ChartOrientation <zh>ͼķ,ˮƽֱ (Ϊnull).</zh>
   * <en>The plot orientation (horizontal or vertical) (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   * @param isXAxisDate boolean <zh>Ƿx.</zh>
   * <en>Whether or not x-axis is date.</en>
   * @param isYAxisDate boolean <zh>Ƿy.</zh>
   * <en>Whether or not y-axis is date.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createYIntervalChart(String title, String xAxisLabel, String yAxisLabel,
                                             IMatrixDataset dataset, ChartOrientation orientation,
                                             boolean legend, boolean tooltips,
                                             boolean isXAxisDate, boolean isYAxisDate) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }
    if (orientation == null) {
      throw new IllegalArgumentException("Null 'orientation' argument.") ;
    }

    YIntervalValueAxis xAxis = new YIntervalValueAxis(xAxisLabel, dataset,
                                                      XYValueAxisType.XY_VALUE_AXIS_X, isXAxisDate) ;
    xAxis.setAxisLabelType(AxisLabelType.COLUMN) ;
    xAxis.setAxisRangeIncludeZero(false) ;
    YIntervalValueAxis yAxis = new YIntervalValueAxis(yAxisLabel, dataset,
                                                      XYValueAxisType.XY_VALUE_AXIS_Y, isYAxisDate) ;
    yAxis.setValueLineVisible(true) ;
    yAxis.setAxisRangeIncludeZero(false) ;

    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      xAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      yAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    YIntervalRenderer render = new YIntervalRenderer(dataset) ;
    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    XYPlot plot = new XYPlot(xAxis, yAxis, render) ;
    plot.setOrientation(orientation) ;

    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

  /**
   * <zh>ջͼChart.ChartPlotΪ{@link CategoryPlot},XΪ{@link CategoryAxis}
   * ,YΪ{@link StackedNumberValueAxis},RenderΪ{@link StackedAreaRender},ݼеÿ
   * {@link com.ijchart.xychart.data.NumberChartData}.</zh>
   * <en>Creates a stacked area chart. The chart object returned by this method uses a
   * {@link CategoryPlot} instance as the plot, with a {@link CategoryAxis}
   * for the X axis, a {@link StackedNumberValueAxis} as the Y axis, and a
   * {@link StackedAreaRender} as the render,and each data is
   * {@link com.ijchart.xychart.data.NumberChartData} object in dataset.</en>
   *
   * @param title String <zh>ͼı (Ϊnull).</zh>
   * <en>The chart title (null permitted).</en>
   * @param xAxisLabel String <zh>Xıǩ (Ϊnull).</zh>
   * <en>The label for the category axis (null permitted).</en>
   * @param yAxisLabel String <zh>Yıǩ (Ϊnull).</zh>
   * <en>The label for the value axis (null permitted).</en>
   * @param dataset IMatrixDataset <zh>ݼ (Ϊnull).</zh>
   * <en>The dataset for the chart (null not permitted).</en>
   * @param orientation ChartOrientation <zh>ͼķ,ˮƽֱ (Ϊnull).</zh>
   * <en>The plot orientation (horizontal or vertical) (null not permitted).</en>
   * @param legend boolean <zh>Ƿʾͼ.</zh>
   * <en>A flag specifying whether or not a legend is required.</en>
   * @param tooltips boolean <zh>Ƿʾtooltip.</zh>
   * <en>Whether or not show tooltip.</en>
   *
   * @return IJChart <zh>ͼ (Ϊnull).</zh>
   * <en> A bar chart (never null).</en>
   */
  public static IJChart createStackedAreaChart(String title, String xAxisLabel, String yAxisLabel,
                                               IMatrixDataset dataset, ChartOrientation orientation,
                                               boolean legend, boolean tooltips) {
    if (dataset == null) {
      throw new IllegalArgumentException("Null 'dataset' argument.") ;
    }
    if (orientation == null) {
      throw new IllegalArgumentException("Null 'orientation' argument.") ;
    }

    CategoryAxis categoryAxis = new CategoryAxis(xAxisLabel, dataset) ;
    categoryAxis.setAxisLabelType(AxisLabelType.COLUMN) ;
    categoryAxis.setLowerMargin(0D) ;
    categoryAxis.setUpperMargin(0D) ;
    StackedAreaRender render = new StackedAreaRender(dataset) ;
    StackedNumberValueAxis valueAxis = new StackedNumberValueAxis(yAxisLabel, dataset, render) ;
    valueAxis.setValueLineVisible(true) ;

    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      categoryAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      valueAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    render.setGeneratorTooltip(tooltips) ;
    render.setToolTipGenerator(new DefaultTooltipGenerator()) ;

    CategoryPlot plot = new CategoryPlot(categoryAxis, valueAxis, render) ;
    plot.setOrientation(orientation) ;

    IJChart chart = new IJChart(title, IJChart.DEFAULT_TITLE_FONT, plot, legend) ;
    return chart ;
  }

}
