package com.ijchart.xychart.constant ;

import java.io.Serializable ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>ͼ仯¼.</zh>
 * <en>Defines tokens used to indicate an event type.</en>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public final class ChartChangeEventType implements Serializable {
  /**
   * <zh>л汾ID.</zh>
   * <en>For serialization.</en>
   */
  private static final long serialVersionUID = 2627515143499383468L ;

  /**
   * <zh>һ.</zh>
   * <en>GENERAL.</en>
   */
  public static final ChartChangeEventType GENERAL = new ChartChangeEventType(
    "ChartChangeEventType.GENERAL") ;

  /**
   * <zh>µݼ.</zh>
   * <en>NEW_DATASET.</en>
   */
  public static final ChartChangeEventType NEW_DATASET = new ChartChangeEventType(
    "ChartChangeEventType.NEW_DATASET") ;

  /**
   * <zh>ݼ仯.</zh>
   * <en>DATASET_UPDATED.</en>
   */
  public static final ChartChangeEventType DATASET_UPDATED = new ChartChangeEventType(
    "ChartChangeEventType.DATASET_UPDATED") ;

  /**
   * <zh>.</zh>
   * <en>The name.</en>
   */
  private String name ;

  /**
   * <zh>˽йֹʵ.</zh>
   * <en>Private constructor to prevent instance.</en>
   *
   * @param name <zh>.</zh>
   * <en>The name.</en>
   */
  private ChartChangeEventType(String name) {
    this.name = name ;
  }

  /**
   * <zh>¼.</zh>
   * <en>Returns a string representing the object.</en>
   *
   * @return <zh>¼.</zh>
   * <en>The string.</en>
   */
  public String toString() {
    return this.name ;
  }

  /**
   * <zh>ʵǷ.</zh>
   * <en>Returns true if this object is equal to the specified object, and false otherwise.</en>
   *
   * @param obj <zh>ҪȽϵĶ (Ϊnull).</zh>
   * <en>The object (null permitted).</en>
   *
   * @return A boolean.
   */
  public boolean equals(Object obj) {
    if (this == obj) {
      return true ;
    }
    if (!(obj instanceof ChartChangeEventType)) {
      return false ;
    }

    ChartChangeEventType that = (ChartChangeEventType) obj ;
    return this.name.equals(that.name) ;
  }

  /**
   * <zh>hashcodeֵ.</zh>
   * <en>Returns a hash code value for the object.</en>
   *
   * @return <zh>hascodeֵ.</zh>
   * <en>The hashcode.</en>
   */
  public int hashCode() {
    return this.name.hashCode() ;
  }
}
