package com.ijchart.xychart.constant ;

import java.io.Serializable ;

import com.ijchart.xychart.util.HashcodeUtil ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>ͼϢеͼε.</zh>
 * <en>Describe the type of {@link com.ijchart.xychart.shape.IChartShape} drawing on the chart.</en>
 * <zh>ݵ㱳ͼκݵͼεĻƹϵ.</zh>
 * <en>Describe the relationship of draw the data background shape and the data shape.</en>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public final class DataBackgroundShapeDrawType implements Serializable {
  /**
   * <zh>л汾ID.</zh>
   * <en>For serialization.</en>
   */
  private static final long serialVersionUID = -3429722239651497055L ;

  /**
   * <zh>еıͼκٻݵͼ.</zh>
   * <en>Draw all data item shapes after draw all background shapes.</en>
   */
  public static final DataBackgroundShapeDrawType ALL_BY_ALL =
    new DataBackgroundShapeDrawType("ALL_BY_ALL") ;

  /**
   * <zh>һͼκٻݵͼ.</zh>
   * <en>Draw data item shape after draw background shape.</en>
   */
  public static final DataBackgroundShapeDrawType ONE_BY_ONE =
    new DataBackgroundShapeDrawType("ONE_BY_ONE") ;

  /**
   * <zh>һͼκٻһݵͼ.</zh>
   * <en>Draw one row data item shape after draw background shape.</en>
   */
  public static final DataBackgroundShapeDrawType ONE_BY_ROW =
    new DataBackgroundShapeDrawType("ONE_BY_ROW") ;

  /**
   * <zh>һͼκٻݵͼ.</zh>
   * <en>Draw two rows data item shape after draw background shape.</en>
   */
  public static final DataBackgroundShapeDrawType ONE_BY_TWO_ROW =
    new DataBackgroundShapeDrawType("ONE_BY_TWO_ROW") ;

  /**
   * <zh>.</zh>
   * <en>The type.</en>
   */
  private String type ;

  /**
   * <zh>˽йֹʵ.</zh>
   * <en>Private constructor to prevent instance.</en>
   *
   * @param type String <zh>.</zh>
   * <en>The type.</en>
   */
  private DataBackgroundShapeDrawType(String type) {
    this.type = type ;
  }

  /**
   * <zh>equals.</zh>
   * <en>Override equals method.</en>
   * @param obj Object
   * @return boolean
   */
  public boolean equals(Object obj) {
    if (this == obj) {
      return true ;
    }

    if (!(obj instanceof DataBackgroundShapeDrawType)) {
      return false ;
    }

    DataBackgroundShapeDrawType that = (DataBackgroundShapeDrawType) obj ;

    return this.type.equals(that.type) ;
  }

  /**
   * <zh>toString().</zh>
   * <en>Override toString method.</en>
   * @return String
   */
  public String toString() {
    return "[type=" + this.type + "]" ;
  }

  /**
   * <zh>hashcodeֵ.</zh>
   * <en>Returns a hash code value for the object. </en>
   * @return  a hash code value for this object.
   */
  public int hashCode() {
    return HashcodeUtil.hashCode(this.type) ;
  }

}
