package com.ijchart.xychart.constant ;

import java.io.Serializable ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>ݼ,л</zh>
 * <en>The constant for dataset sliding type.</en>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public final class DatasetSlidingType implements Serializable {

  /**
   * <zh>л汾ID.</zh>
   * <en>For serialization</en>
   */
  private static final long serialVersionUID = 867315252038534676L ;

  /**
   * <zh>.</zh>
   * <en>The row type.</en>
   */
  public static final DatasetSlidingType ROW = new DatasetSlidingType(
    "DatasetSlidingType.ROW") ;

  /**
   * <zh>.</zh>
   * <en>The column type.</en>
   */
  public static final DatasetSlidingType COLUMN = new DatasetSlidingType(
    "DatasetSlidingType.COLUMN") ;

  /**
   * <zh>.</zh>
   * <en>The name.</en>
   */
  private String name ;

  /**
   * <zh>˽йֹʵ.</zh>
   * <en>Private constructor to prevent instance.</en>
   *
   * @param name String <zh>.</zh>
   * <en>The name.</en>
   */
  private DatasetSlidingType(String name) {
    this.name = name ;
  }

  /**
   * <zh></zh>
   * <en>Returns a string representing the object.</en>
   * @return The string.
   */
  public String toString() {
    return this.name ;
  }

  /**
   * <zh>Ƿ.</zh>
   * <en>Returns true if this object is equal to the specified object, and false otherwise.</en>
   *
   * @param o  the other object.
   * @return A boolean.
   */
  public boolean equals(Object o) {
    if (this == o) {
      return true ;
    }
    if (!(o instanceof DatasetSlidingType)) {
      return false ;
    }

    DatasetSlidingType that = (DatasetSlidingType) o ;
    if (!this.name.equals(that.name)) {
      return false ;
    }

    return true ;
  }

  /**
   * <zh>hashcodeֵ.</zh>
   * <en>Returns a hash code value for the object</en>
   *
   * @return int <zh>hashcodeֵ.</zh>
   * <en>A hash code value for this object.</en>
   */
  public int hashCode() {
    return name.hashCode() ;
  }

}
