package com.ijchart.xychart.constant ;

import java.io.Serializable ;

import com.ijchart.xychart.util.HashcodeUtil ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>,˳ʱʱ.</zh>
 * <en>Used to indicate the orientation (clockwise or anticlockwise).</en>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public final class Rotation implements Serializable {
  /**
   * <zh>л汾ID.</zh>
   * <en>For serialization.</en>
   */
  private static final long serialVersionUID = -573427700639177537L ;

  /**
   * <zh>˳ʱ뷽.</zh>
   * <en>clockwise.</en>
   */
  public static final Rotation CLOCKWISE = new Rotation("CLOCKWISE") ;

  /**
   * <zh>ʱ뷽.</zh>
   * <en>anticlockwise.</en>
   */
  public static final Rotation ANTICLOCKWISE = new Rotation("ANTICLOCKWISE") ;

  /**
   * <zh>.</zh>
   * <en>The name.</en>
   */
  private String name ;

  /**
   * <zh>˽йֹʵ.</zh>
   * <en>Private constructor to prevent instance.</en>
   *
   * @param name <zh>.</zh>
   * <en>The name.</en>
   */
  private Rotation(String name) {
    this.name = name ;
  }

  /**
   * <zh></zh>
   * <en>Returns a string representing the object.</en>
   * @return The string.
   */
  public String toString() {
    return this.name ;
  }

  /**
   * <zh>ϵ.</zh>
   * <en>Returns the factor.</en>
   *
   * @return int <zh>ϵ,CLOCKWISE-1,ANTICLOCKWISE1,0.</zh>
   * <en>The factor,-1 if this is CLOCKWISE otherwise,1 if this is ANTICLOCKWISE,0 otherwise.</en>
   */
  public int getFactor() {
    if (this.equals(CLOCKWISE)) {
      return -1 ;
    } else if (this.equals(ANTICLOCKWISE)) {
      return 1 ;
    }

    return 0 ;
  }

  /**
   * <zh>Ƿ.</zh>
   * <en>Returns true if this object is equal to the specified object, and false otherwise.</en>
   *
   * @param o  the other object.
   * @return A boolean.
   */
  public boolean equals(Object o) {
    if (this == o) {
      return true ;
    }
    if (!(o instanceof Rotation)) {
      return false ;
    }

    Rotation that = (Rotation) o ;
    if (!this.name.equals(that.name)) {
      return false ;
    }

    return true ;
  }

  /**
   * <zh>hashcodeֵ.</zh>
   * <en>Returns a hash code value for the object</en>
   *
   * @return int <zh>hashcodeֵ.</zh>
   * <en>A hash code value for this object.</en>
   */
  public int hashCode() {
    return HashcodeUtil.hashCode(this.name) ;
  }

}
