package com.ijchart.xychart.constant ;

import java.io.Serializable ;

import com.ijchart.xychart.util.EqualsUtil ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>ͼ.</zh>
 * <en>Describe the type of {@link com.ijchart.xychart.shape.IChartShape}.</en>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public final class ShapeType implements Serializable {
  /**
   * <zh>л汾ID.</zh>
   * <en>For serialization.</en>
   */
  private static final long serialVersionUID = 1440631003845631373L ;

  /**
   * <zh>ͼ.</zh>
   * <en>The rectangle type.</en>
   */
  public static final ShapeType SHAPE_RECTANGLE = new ShapeType("RECTANGLE") ;

  /**
   * <zh>Բͼ.</zh>
   * <en>The circle type.</en>
   */
  public static final ShapeType SHAPE_CIRCLE = new ShapeType("CIRCLE") ;

  /**
   * <zh>ֵľ.</zh>
   * <en>The text within a rectangle.</en>
   */
  public static final ShapeType SHAPE_TEXT_IN_RECTANGLE = new ShapeType("TEXT_IN_RECTANGLE") ;

  /**
   * <zh>ֵԲ.</zh>
   * <en>The text within a ellipse.</en>
   */
  public static final ShapeType SHAPE_TEXT_IN_ELLIPSE = new ShapeType("TEXT_IN_ELLIPSE") ;

  /**
   * <zh>α߿ͼƬͼ.</zh>
   * <en>The image within a rectangle.</en>
   */
  public static final ShapeType SHAPE_IMAGE_IN_RECTANGLE = new ShapeType("IMAGE_IN_RECTANGLE") ;

  /**
   * <zh>һֱ</zh>
   * <en>A line.</en>
   */
  public static final ShapeType SHAPE_LINE = new ShapeType("LINE") ;

  /**
   * <zh>ͼͼ.</zh>
   * <en>A legend item shape.</en>
   */
  public static final ShapeType SHAPE_LEGEND = new ShapeType("LEGEND") ;

  /**
   * <zh>ͼ.</zh>
   * <en>A parallelepiped shape.</en>
   */
  public static final ShapeType SHAPE_PARALLELEPIPED = new ShapeType("PARALLELEPIPED") ;

  /**
   * <zh>GeneralPathͼ.</zh>
   * <en>A GeneralPath shape.</en>
   */
  public static final ShapeType SHAPE_GENERALPATH = new ShapeType("GENERALPATH") ;

  /**
   * <zh>3D״ͼͼ.</zh>
   * <en>A cylinder shape.</en>
   */
  public static final ShapeType SHAPE_CYLINDER = new ShapeType("CYLINDER") ;

  /**
   * <zh>ͼ.</zh>
   * <en>A I-shaped shape.</en>
   */
  public static final ShapeType SHAPE_I_SHAPED = new ShapeType("I_SHAPED") ;

  /**
   * <zh>statistical barͼ.</zh>
   * <en>A statistical bar shape.</en>
   */
  public static final ShapeType SHAPE_STATISTICAL_BAR = new ShapeType("STATISTICAL_BAR") ;

  /**
   * <zh>statistical lineͼ.</zh>
   * <en>A statistical line shape.</en>
   */
  public static final ShapeType SHAPE_STATISTICAL_LINE = new ShapeType("STATISTICAL_LINE") ;

  /**
   * <zh>BoxAndWhiskerͼ.</zh>
   * <en>A BoxAndWhisker shape.</en>
   */
  public static final ShapeType SHAPE_BOXANDWHISKER = new ShapeType("BOXANDWHISKER") ;

  /**
   * <zh>˫ͼ.</zh>
   * <en>A dual break line shape.</en>
   */
  public static final ShapeType SHAPE_DUAL_BREAK_LINE = new ShapeType("DUAL_BREAK_LINE") ;

  /**
   * <zh>ͼͼ.</zh>
   * <en>A grantt shape.</en>
   */
  public static final ShapeType SHAPE_GRANTT = new ShapeType("GRANTT") ;

  /**
   * <zh>ͼεͼ.</zh>
   * <en>A shape composited by a line and a shape.</en>
   */
  public static final ShapeType SHAPE_LINE_AND_SHAPE = new ShapeType("LINE_AND_SHAPE") ;

  /**
   * <zh>Ʊͼ.</zh>
   * <en>A stock shape.</en>
   */
  public static final ShapeType SHAPE_STOCK = new ShapeType("STOCK") ;

  /**
   * <zh>high-lowͼ.</zh>
   * <en>A high-low shape.</en>
   */
  public static final ShapeType SHAPE_HIGH_LOW = new ShapeType("HIGH_LOW") ;

  /**
   * <zh>ֺͼͷͼ.</zh>
   * <en>A text and arrow shape.</en>
   */
  public static final ShapeType SHAPE_TEXT_ARROW = new ShapeType("TEXT_ARROW") ;

  /**
   * <zh>Ǳͼ.</zh>
   * <en>A meter arc shape.</en>
   */
  public static final ShapeType SHAPE_METER_ARC = new ShapeType("METER_ARC") ;

  /**
   * <zh>ͼͼͼ.</zh>
   * <en>The legend chart shape for block chart.</en>
   */
  public static final ShapeType SHAPE_BLOCK_CHART_LEGEND = new ShapeType("BLOCK_CHART_LEGEND") ;

  /**
   * <zh>ͼ.</zh>
   * <en>A arc shape.</en>
   */
  public static final ShapeType SHAPE_ARC = new ShapeType("ARC") ;

  /**
   * <zh>ͼǩͼ.</zh>
   * <en>A pie label shape.</en>
   */
  public static final ShapeType SHAPE_PIE_OUTSIDE_LABEL = new ShapeType("PIE_OUTSIDE_LABEL") ;

  /**
   * <zh>Բͼ.</zh>
   * <en>A ring sector shape.</en>
   */
  public static final ShapeType SHAPE_RING_SECTOR = new ShapeType("RING_SECTOR") ;

  /**
   * <zh>ERRORʮͼ.</zh>
   * <en>An error cross shape.</en>
   */
  public static final ShapeType SHAPE_ERROR_CROSS = new ShapeType("ERROR_CROSS") ;

  /**
   * <zh>˫ͷͼ.</zh>
   * <en>A double head matchstick shape.</en>
   */
  public static final ShapeType SHAPE_DBL_HEAD_MATCHSTICK = new ShapeType("DBL_HEAD_MATCHSTICK") ;


  /**
   * <zh>Сֵֵͼ.</zh>
   * <en>A minimum and maximum value shape.</en>
   */
  public static final ShapeType SHAPE_MIN_AND_MAX = new ShapeType("MIN_AND_MAX") ;


  /**
   * <zh>.</zh>
   * <en>The type.</en>
   */
  private String type ;

  /**
   * <zh>˽йֹʵ.</zh>
   * <en>Private constructor to prevent instance.</en>
   *
   * @param type String <zh>.</zh>
   * <en>The type.</en>
   */
  private ShapeType(String type) {
    this.type = type ;
  }

  /**
   * <zh>equals.</zh>
   * <en>Override equals method.</en>
   * @param obj Object
   * @return boolean
   */
  public boolean equals(Object obj) {
    if (this == obj) {
      return true ;
    }

    if (!(obj instanceof ShapeType)) {
      return false ;
    }

    ShapeType that = (ShapeType) obj ;

    return EqualsUtil.equals(this.type, that.type) ;
  }

  /**
   * <zh>toString().</zh>
   * <en>Override toString method.</en>
   * @return String
   */
  public String toString() {
    return "[type=" + this.type + "]" ;
  }

  /**
   * <zh>hashcodeֵ.</zh>
   * <en>Returns a hash code value for the object. </en>
   * @return  a hash code value for this object.
   */
  public int hashCode() {
    return this.type.hashCode() ;
  }

}
