package com.ijchart.xychart.event ;

import java.io.Serializable ;
import java.util.EventObject ;

import com.ijchart.xychart.annotation.IAnnotation ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>ע(annotation)仯¼.</zh>
 * <en>A change event that encapsulates information about a change to a annotation.</en>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class AnnotationChangeEvent extends EventObject implements Serializable {
  /**
   * <zh>л汾ID.</zh>
   * <en>For serialization.</en>
   */
  private static final long serialVersionUID = 3547303035689252334L ;

  /**
   * <zh>¼ע(annotation).</zh>
   * <en>The annotation that generated the change event.</en>
   */
  private IAnnotation annotation ;

  /**
   * <zh>һµĶ.</zh>
   * <en>Creates a new instance.</en>
   *
   * @param annotation IAnnotation <zh>¼ע(annotation) (Ϊnull).</zh>
   * <en>The annotation that generated the event (null not permitted).</en>
   */
  public AnnotationChangeEvent(IAnnotation annotation) {
    super(annotation) ;

    this.annotation = annotation ;
  }

  /**
   * <zh>ز¼ע(annotation).</zh>
   * <en>Returns the annotation that generated the event.</en>
   *
   * @return <zh>¼ע(annotation).</zh>
   * <en>The annotation that generated the event.</en>
   */
  public IAnnotation getAnnotation() {
    return this.annotation ;
  }

}
